/* ************************************************************************** */
/* Comunidade Firebird de Lngua Portuguesa                                   */
/*            http://www.comunidade-firebird.org                              */
/*                                                                            */
/* Este Script foi gentilmente cedido  CFLP para uso pblico                 */
/* pelo colaborador:                                                          */                                                                           */
/*                                                                            */
/*                                                                            */
/*            Romario Baldotto Ribeiro    firebird.vix@terra.com.br           */
/*                                                                            */
/*                                                                            */
/* Total de Registos:                                                         */
/*                                                                            */
/*     Pases:  1                                                             */
/*     states: 27                                                            */
/*     citys: 5507                                                          */
/*                                                                            */
/*                                                                            */
/*                                             Verso 1.0 - Novembro de 2002  */
/* ************************************************************************** */


/* ************************************************************************** */
/*                    C R I A   O   D A S   T A B E L A S                  /* 
/* ************************************************************************** */

/* ********************************** Pas ********************************** */

CREATE TABLE `country` (
    `country_id`  SMALLINT NOT NULL,
    `country_code`  CHAR(2) NOT NULL,
    `country_name`  VARCHAR(50) NOT NULL
);

/* ********************************* state ********************************* */

CREATE TABLE `state` (
    `state_id`  SMALLINT NOT NULL,
    `country_id`    SMALLINT NOT NULL,
    `state_code`  CHAR(2) NOT NULL,
    `state_name`  VARCHAR(50) NOT NULL
);

/* ********************************* city ********************************* */

CREATE TABLE `city` (
    `city_id`  INTEGER NOT NULL,
    `state_id`  SMALLINT NOT NULL,
    `city_name`  VARCHAR(50) NOT NULL
);


/******************************************************************************/
/*          C R I A   O   D A S   C H A V E S   P R I M  R I A S           */
/******************************************************************************/

ALTER TABLE `country`   ADD CONSTRAINT `PK_country`   PRIMARY KEY (`country_id`);
ALTER TABLE `state` ADD CONSTRAINT `PK_state` PRIMARY KEY (`state_id`);
ALTER TABLE `city` ADD CONSTRAINT `PK_city` PRIMARY KEY (`city_id`);


/******************************************************************************/
/*       C R I A   O   D A S   C H A V E S   E S T R A N G E I R A S        */
/******************************************************************************/

ALTER TABLE `state` ADD CONSTRAINT `fk_country_id_state` FOREIGN KEY (`country_id`) REFERENCES `country` (`country_id`) ON DELETE
CASCADE;

ALTER TABLE `city` ADD CONSTRAINT `fk_state_id_city` FOREIGN KEY (`state_id`) REFERENCES `state` (`state_id`) ON  
DELETE CASCADE;


/* ************************************************************************** */
/*                     I N S E R   O   D E   D A D O S                      */
/* ************************************************************************** */

/******************************************************************************/
/*                                    Pas                                    */
/******************************************************************************/

INSERT INTO `country` (`country_id`, `country_code`, `country_name`) VALUES (01, 'BR', 'Brasil');

COMMIT WORK;


/******************************************************************************/
/*                                   state                                   */
/******************************************************************************/

INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (01, 01, 'AC', 'Acre');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (02, 01, 'AL', 'Alagoas');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (03, 01, 'AP', 'Amap');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (04, 01, 'AM', 'Amazonas');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (05, 01, 'BA', 'Bahia');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (06, 01, 'CE', 'Cear');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (07, 01, 'DF', 'Distrito Federal');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (08, 01, 'ES', 'Esprito Santo');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (09, 01, 'GO', 'Gois');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (10, 01, 'MA', 'Maranho');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (11, 01, 'MT', 'Mato Grosso');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (12, 01, 'MS', 'Mato Grosso do Sul');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (13, 01, 'MG', 'Minas Gerais');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (14, 01, 'PA', 'Par');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (15, 01, 'PB', 'Paraba');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (16, 01, 'PR', 'Paran');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (17, 01, 'PE', 'Pernambuco');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (18, 01, 'PI', 'Piau');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (19, 01, 'RJ', 'Rio de Janeiro');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (20, 01, 'RN', 'Rio Grande do Norte');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (21, 01, 'RS', 'Rio Grande do Sul');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (22, 01, 'RO', 'Rondnia');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (23, 01, 'RR', 'Roraima');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (24, 01, 'SC', 'Santa Catarina');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (25, 01, 'SP', 'So Paulo');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (26, 01, 'SE', 'Sergipe');
INSERT INTO `state` (`state_id`, `country_id`, `state_code`, `state_name`) VALUES (27, 01, 'TO', 'Tocantins');

COMMIT WORK;


/******************************************************************************/
/*                                   city                                   */
/******************************************************************************/

/* ******************************** A c r e ********************************* */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0001, 01, 'Acrelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0002, 01, 'Assis Brasil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0003, 01, 'Brasilia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0004, 01, 'Bujari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0005, 01, 'Capixaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0006, 01, 'Cruzeiro do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0007, 01, 'Epitaciolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0008, 01, 'Feij');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0009, 01, 'Jordo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0010, 01, 'Mncio Lima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0011, 01, 'Manoel Urbano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0012, 01, 'Marechal Thaumaturgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0013, 01, 'Plcido de Castro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0014, 01, 'Porto Acre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0015, 01, 'Porto Walter');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0016, 01, 'Rio Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0017, 01, 'Rodrigues Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0018, 01, 'Santa Rosa do Purus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0019, 01, 'Sena Madureira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0020, 01, 'Senador Guiomard');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0021, 01, 'Tarauac');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0022, 01, 'Xapuri');


/* ***************************** A l a g o a s ****************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0023, 02, 'gua Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0024, 02, 'Anadia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0025, 02, 'Arapiraca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0026, 02, 'Atalaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0027, 02, 'Barra de Santo Antnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0028, 02, 'Barra de So Miguel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0029, 02, 'Batalha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0030, 02, 'Belm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0031, 02, 'Belo Monte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0032, 02, 'Boca da Mata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0033, 02, 'Branquinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0034, 02, 'Cacimbinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0035, 02, 'Cajueiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0036, 02, 'Campestre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0037, 02, 'Campo Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0038, 02, 'Campo Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0039, 02, 'Canapi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0040, 02, 'Capela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0041, 02, 'Carneiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0042, 02, 'Ch Preta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0043, 02, 'Coit do Nia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0044, 02, 'Colnia Leopoldina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0045, 02, 'Coqueiro Seco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0046, 02, 'Coruripe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0047, 02, 'Crabas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0048, 02, 'Delmiro Gouveia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0049, 02, 'Dois Riachos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0050, 02, 'Estrela de Alagoas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0051, 02, 'Feira Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0052, 02, 'Feliz Deserto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0053, 02, 'Flexeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0054, 02, 'Girau do Ponciano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0055, 02, 'Ibateguara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0056, 02, 'Igaci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0057, 02, 'Igreja Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0058, 02, 'Inhapi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0059, 02, 'Jacar dos Homens');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0060, 02, 'Jacupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0061, 02, 'Japaratinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0062, 02, 'Jaramataia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0063, 02, 'Joaquim Gomes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0064, 02, 'Jundi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0065, 02, 'Junqueiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0066, 02, 'Lagoa da Canoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0067, 02, 'Limoeiro de Anadia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0068, 02, 'Macei');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0069, 02, 'Major Isidoro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0070, 02, 'Mar Vermelho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0071, 02, 'Maragogi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0072, 02, 'Maravilha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0073, 02, 'Marechal Deodoro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0074, 02, 'Maribondo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0075, 02, 'Mata Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0076, 02, 'Matriz de Camaragibe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0077, 02, 'Messias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0078, 02, 'Minador do Negro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0079, 02, 'Monteirpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0080, 02, 'Murici');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0081, 02, 'Novo Lino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0082, 02, 'Olho d`gua das Flores');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0083, 02, 'Olho d`gua do Casado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0084, 02, 'Olho d`gua Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0085, 02, 'Olivena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0086, 02, 'Ouro Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0087, 02, 'Palestina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0088, 02, 'Palmeira dos ndios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0089, 02, 'Po de Acar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0090, 02, 'Pariconha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0091, 02, 'Paripueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0092, 02, 'Passo de Camaragibe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0093, 02, 'Paulo Jacinto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0094, 02, 'Penedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0095, 02, 'Piaabuu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0096, 02, 'Pilar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0097, 02, 'Pindoba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0098, 02, 'Piranhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0099, 02, 'Poo das Trincheiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0100, 02, 'Porto Calvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0101, 02, 'Porto de Pedras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0102, 02, 'Porto Real do Colgio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0103, 02, 'Quebrangulo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0104, 02, 'Rio Largo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0105, 02, 'Roteiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0106, 02, 'Santa Luzia do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0107, 02, 'Santana do Ipanema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0108, 02, 'Santana do Munda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0109, 02, 'So Brs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0110, 02, 'So Jos da Laje');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0111, 02, 'So Jos da Tapera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0112, 02, 'So Lus do Quitunde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0113, 02, 'So Miguel dos Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0114, 02, 'So Miguel dos Milagres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0115, 02, 'So Sebastio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0116, 02, 'Satuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0117, 02, 'Senador Rui Palmeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0118, 02, 'Tanque d`Arca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0119, 02, 'Taquarana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0120, 02, 'Teotnio Vilela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0121, 02, 'Traipu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0122, 02, 'Unio dos Palmares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0123, 02, 'Viosa');


/* ******************************* A m a p  ******************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0124, 03, 'Amap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0125, 03, 'Caloene');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0126, 03, 'Cutias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0127, 03, 'Ferreira Gomes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0128, 03, 'Itaubal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0129, 03, 'Laranjal do Jari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0130, 03, 'Macap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0131, 03, 'Mazago');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0132, 03, 'Oiapoque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0133, 03, 'Pedra Branca do Amapar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0134, 03, 'Porto Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0135, 03, 'Pracuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0136, 03, 'Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0137, 03, 'Serra do Navio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0138, 03, 'Tartarugalzinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0139, 03, 'Vitria do Jari');


/* **************************** A m a z o n a s ***************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0140, 04, 'Alvares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0141, 04, 'Amatur');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0142, 04, 'nam');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0143, 04, 'Anori');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0144, 04, 'Apu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0145, 04, 'Atalaia do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0146, 04, 'Autazes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0147, 04, 'Barcelos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0148, 04, 'Barreirinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0149, 04, 'Benjamin Constant');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0150, 04, 'Beruri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0151, 04, 'Boa Vista do Ramos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0152, 04, 'Boca do Acre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0153, 04, 'Borba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0154, 04, 'Caapiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0155, 04, 'Canutama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0156, 04, 'Carauari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0157, 04, 'Careiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0158, 04, 'Careiro da Vrzea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0159, 04, 'Coari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0160, 04, 'Codajs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0161, 04, 'Eirunep');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0162, 04, 'Envira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0163, 04, 'Fonte Boa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0164, 04, 'Guajar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0165, 04, 'Humait');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0166, 04, 'Ipixuna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0167, 04, 'Iranduba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0168, 04, 'Itacoatiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0169, 04, 'Itamarati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0170, 04, 'Itapiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0171, 04, 'Japur');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0172, 04, 'Juru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0173, 04, 'Juta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0174, 04, 'Lbrea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0175, 04, 'Manacapuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0176, 04, 'Manaquiri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0177, 04, 'Manaus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0178, 04, 'Manicor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0179, 04, 'Mara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0180, 04, 'Maus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0181, 04, 'Nhamund');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0182, 04, 'Nova Olinda do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0183, 04, 'Novo Airo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0184, 04, 'Novo Aripuan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0185, 04, 'Parintins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0186, 04, 'Pauini');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0187, 04, 'Presidente Figueiredo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0188, 04, 'Rio Preto da Eva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0189, 04, 'Santa Isabel do Rio Negro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0190, 04, 'Santo Antnio do I');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0191, 04, 'So Gabriel da Cachoeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0192, 04, 'So Paulo de Olivena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0193, 04, 'So Sebastio do Uatum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0194, 04, 'Silves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0195, 04, 'Tabatinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0196, 04, 'Tapau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0197, 04, 'Tef');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0198, 04, 'Tonantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0199, 04, 'Uarini');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0200, 04, 'Urucar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0201, 04, 'Urucurituba');


/* ******************************* B a h i a ******************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0202, 05, 'Abara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0203, 05, 'Abar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0204, 05, 'Acajutiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0205, 05, 'Adustina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0206, 05, 'gua Fria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0207, 05, 'Aiquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0208, 05, 'Alagoinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0209, 05, 'Alcobaa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0210, 05, 'Almadina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0211, 05, 'Amargosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0212, 05, 'Amlia Rodrigues');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0213, 05, 'Amrica Dourada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0214, 05, 'Anag');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0215, 05, 'Andara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0216, 05, 'Andorinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0217, 05, 'Angical');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0218, 05, 'Anguera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0219, 05, 'Antas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0220, 05, 'Antnio Cardoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0221, 05, 'Antnio Gonalves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0222, 05, 'Apor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0223, 05, 'Apuarema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0224, 05, 'Araas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0225, 05, 'Aracatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0226, 05, 'Araci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0227, 05, 'Aramari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0228, 05, 'Arataca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0229, 05, 'Aratupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0230, 05, 'Aurelino Leal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0231, 05, 'Baianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0232, 05, 'Baixa Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0233, 05, 'Banza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0234, 05, 'Barra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0235, 05, 'Barra da Estiva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0236, 05, 'Barra do Choa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0237, 05, 'Barra do Mendes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0238, 05, 'Barra do Rocha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0239, 05, 'Barreiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0240, 05, 'Barro Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0241, 05, 'Belmonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0242, 05, 'Belo Campo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0243, 05, 'Biritinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0244, 05, 'Boa Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0245, 05, 'Boa Vista do Tupim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0246, 05, 'Bom Jesus da Lapa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0247, 05, 'Bom Jesus da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0248, 05, 'Boninal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0249, 05, 'Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0250, 05, 'Boquira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0251, 05, 'Botupor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0252, 05, 'Brejes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0253, 05, 'Brejolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0254, 05, 'Brotas de Macabas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0255, 05, 'Brumado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0256, 05, 'Buerarema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0257, 05, 'Buritirama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0258, 05, 'Caatiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0259, 05, 'Cabaceiras do Paraguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0260, 05, 'Cachoeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0261, 05, 'Cacul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0262, 05, 'Cam');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0263, 05, 'Caetanos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0264, 05, 'Caetit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0265, 05, 'Cafarnaum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0266, 05, 'Cairu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0267, 05, 'Caldeiro Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0268, 05, 'Camacan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0269, 05, 'Camaari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0270, 05, 'Camamu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0271, 05, 'Campo Alegre de Lourdes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0272, 05, 'Campo Formoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0273, 05, 'Canpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0274, 05, 'Canarana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0275, 05, 'Canavieiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0276, 05, 'Candeal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0277, 05, 'Candeias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0278, 05, 'Candiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0279, 05, 'Cndido Sales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0280, 05, 'Cansano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0281, 05, 'Canudos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0282, 05, 'Capela do Alto Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0283, 05, 'Capim Grosso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0284, 05, 'Carabas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0285, 05, 'Caravelas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0286, 05, 'Cardeal da Silva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0287, 05, 'Carinhanha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0288, 05, 'Casa Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0289, 05, 'Castro Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0290, 05, 'Catolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0291, 05, 'Catu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0292, 05, 'Caturama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0293, 05, 'Central');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0294, 05, 'Chorroch');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0295, 05, 'Ccero Dantas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0296, 05, 'Cip');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0297, 05, 'Coaraci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0298, 05, 'Cocos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0299, 05, 'Conceio da Feira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0300, 05, 'Conceio do Almeida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0301, 05, 'Conceio do Coit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0302, 05, 'Conceio do Jacupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0303, 05, 'Conde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0304, 05, 'Condeba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0305, 05, 'Contendas do Sincor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0306, 05, 'Corao de Maria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0307, 05, 'Cordeiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0308, 05, 'Coribe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0309, 05, 'Coronel Joo S');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0310, 05, 'Correntina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0311, 05, 'Cotegipe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0312, 05, 'Cravolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0313, 05, 'Crispolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0314, 05, 'Cristpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0315, 05, 'Cruz das Almas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0316, 05, 'Cura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0317, 05, 'Drio Meira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0318, 05, 'Dias d`vila');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0319, 05, 'Dom Baslio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0320, 05, 'Dom Macedo Costa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0321, 05, 'Elsio Medrado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0322, 05, 'Encruzilhada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0323, 05, 'Entre Rios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0324, 05, 'rico Cardoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0325, 05, 'Esplanada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0326, 05, 'Euclides da Cunha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0327, 05, 'Eunpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0328, 05, 'Ftima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0329, 05, 'Feira da Mata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0330, 05, 'Feira de Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0331, 05, 'Filadlfia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0332, 05, 'Firmino Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0333, 05, 'Floresta Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0334, 05, 'Formosa do Rio Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0335, 05, 'Gandu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0336, 05, 'Gavio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0337, 05, 'Gentio do Ouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0338, 05, 'Glria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0339, 05, 'Gongogi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0340, 05, 'Governador Lomanto Jnior');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0341, 05, 'Governador Mangabeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0342, 05, 'Guajeru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0343, 05, 'Guanambi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0344, 05, 'Guaratinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0345, 05, 'Helipolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0346, 05, 'Iau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0347, 05, 'Ibiassuc');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0348, 05, 'Ibicara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0349, 05, 'Ibicoara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0350, 05, 'Ibicu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0351, 05, 'Ibipeba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0352, 05, 'Ibipitanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0353, 05, 'Ibiquera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0354, 05, 'Ibirapitanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0355, 05, 'Ibirapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0356, 05, 'Ibirataia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0357, 05, 'Ibitiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0358, 05, 'Ibitit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0359, 05, 'Ibotirama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0360, 05, 'Ichu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0361, 05, 'Igapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0362, 05, 'Igrapina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0363, 05, 'Igua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0364, 05, 'Ilhus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0365, 05, 'Inhambupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0366, 05, 'Ipecaet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0367, 05, 'Ipia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0368, 05, 'Ipir');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0369, 05, 'Ipupiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0370, 05, 'Irajuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0371, 05, 'Iramaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0372, 05, 'Iraquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0373, 05, 'Irar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0374, 05, 'Irec');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0375, 05, 'Itabela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0376, 05, 'Itaberaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0377, 05, 'Itabuna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0378, 05, 'Itacar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0379, 05, 'Itaet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0380, 05, 'Itagi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0381, 05, 'Itagib');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0382, 05, 'Itagimirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0383, 05, 'Itaguau da Bahia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0384, 05, 'Itaju do Colnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0385, 05, 'Itajupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0386, 05, 'Itamaraju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0387, 05, 'Itamari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0388, 05, 'Itamb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0389, 05, 'Itanagra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0390, 05, 'Itanhm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0391, 05, 'Itaparica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0392, 05, 'Itap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0393, 05, 'Itapebi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0394, 05, 'Itapetinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0395, 05, 'Itapicuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0396, 05, 'Itapitanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0397, 05, 'Itaquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0398, 05, 'Itarantim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0399, 05, 'Itatim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0400, 05, 'Itiruu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0401, 05, 'Itiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0402, 05, 'Itoror');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0403, 05, 'Ituau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0404, 05, 'Ituber');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0405, 05, 'Iui');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0406, 05, 'Jaborandi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0407, 05, 'Jacaraci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0408, 05, 'Jacobina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0409, 05, 'Jaguaquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0410, 05, 'Jaguarari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0411, 05, 'Jaguaripe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0412, 05, 'Jandara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0413, 05, 'Jequi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0414, 05, 'Jeremoabo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0415, 05, 'Jiquiri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0416, 05, 'Jitana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0417, 05, 'Joo Dourado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0418, 05, 'Juazeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0419, 05, 'Jucuruu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0420, 05, 'Jussara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0421, 05, 'Jussari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0422, 05, 'Jussiape');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0423, 05, 'Lafaiete Coutinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0424, 05, 'Lagoa Real');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0425, 05, 'Laje');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0426, 05, 'Lajedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0427, 05, 'Lajedinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0428, 05, 'Lajedo do Tabocal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0429, 05, 'Lamaro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0430, 05, 'Lapo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0431, 05, 'Lauro de Freitas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0432, 05, 'Lenis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0433, 05, 'Licnio de Almeida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0434, 05, 'Livramento de Nossa Senhora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0435, 05, 'Macajuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0436, 05, 'Macarani');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0437, 05, 'Macabas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0438, 05, 'Macurur');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0439, 05, 'Madre de Deus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0440, 05, 'Maetinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0441, 05, 'Maiquinique');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0442, 05, 'Mairi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0443, 05, 'Malhada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0444, 05, 'Malhada de Pedras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0445, 05, 'Manoel Vitorino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0446, 05, 'Mansido');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0447, 05, 'Maracs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0448, 05, 'Maragogipe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0449, 05, 'Mara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0450, 05, 'Marcionlio Souza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0451, 05, 'Mascote');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0452, 05, 'Mata de So Joo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0453, 05, 'Matina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0454, 05, 'Medeiros Neto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0455, 05, 'Miguel Calmon');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0456, 05, 'Milagres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0457, 05, 'Mirangaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0458, 05, 'Mirante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0459, 05, 'Monte Santo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0460, 05, 'Morpar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0461, 05, 'Morro do Chapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0462, 05, 'Mortugaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0463, 05, 'Mucug');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0464, 05, 'Mucuri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0465, 05, 'Mulungu do Morro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0466, 05, 'Mundo Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0467, 05, 'Muniz Ferreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0468, 05, 'Muqum de So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0469, 05, 'Muritiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0470, 05, 'Mutupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0471, 05, 'Nazar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0472, 05, 'Nilo Peanha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0473, 05, 'Nordestina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0474, 05, 'Nova Cana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0475, 05, 'Nova Ftima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0476, 05, 'Nova Ibi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0477, 05, 'Nova Itarana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0478, 05, 'Nova Redeno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0479, 05, 'Nova Soure');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0480, 05, 'Nova Viosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0481, 05, 'Novo Horizonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0482, 05, 'Novo Triunfo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0483, 05, 'Olindina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0484, 05, 'Oliveira dos Brejinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0485, 05, 'Ouriangas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0486, 05, 'Ourolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0487, 05, 'Palmas de Monte Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0488, 05, 'Palmeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0489, 05, 'Paramirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0490, 05, 'Paratinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0491, 05, 'Paripiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0492, 05, 'Pau Brasil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0493, 05, 'Paulo Afonso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0494, 05, 'P de Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0495, 05, 'Pedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0496, 05, 'Pedro Alexandre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0497, 05, 'Piat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0498, 05, 'Pilo Arcado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0499, 05, 'Pinda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0500, 05, 'Pindobau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0501, 05, 'Pintadas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0502, 05, 'Pira do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0503, 05, 'Pirip');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0504, 05, 'Piritiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0505, 05, 'Planaltino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0506, 05, 'Planalto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0507, 05, 'Poes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0508, 05, 'Pojuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0509, 05, 'Ponto Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0510, 05, 'Porto Seguro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0511, 05, 'Potiragu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0512, 05, 'Prado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0513, 05, 'Presidente Dutra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0514, 05, 'Presidente Jnio Quadros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0515, 05, 'Presidente Tancredo Neves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0516, 05, 'Queimadas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0517, 05, 'Quijingue');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0518, 05, 'Quixabeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0519, 05, 'Rafael Jambeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0520, 05, 'Remanso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0521, 05, 'Retirolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0522, 05, 'Riacho das Neves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0523, 05, 'Riacho do Jacupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0524, 05, 'Riacho de Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0525, 05, 'Ribeira do Amparo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0526, 05, 'Ribeira do Pombal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0527, 05, 'Ribeiro do Largo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0528, 05, 'Rio de Contas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0529, 05, 'Rio do Antnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0530, 05, 'Rio do Pires');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0531, 05, 'Rio Real');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0532, 05, 'Rodelas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0533, 05, 'Ruy Barbosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0534, 05, 'Salinas da Margarida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0535, 05, 'Salvador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0536, 05, 'Santa Brbara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0537, 05, 'Santa Brgida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0538, 05, 'Santa Cruz Cabrlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0539, 05, 'Santa Cruz da Vitria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0540, 05, 'Santa Ins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0541, 05, 'Santa Luzia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0542, 05, 'Santa Maria da Vitria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0543, 05, 'Santa Rita de Cssia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0544, 05, 'Santa Teresinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0545, 05, 'Santaluz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0546, 05, 'Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0547, 05, 'Santanpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0548, 05, 'Santo Amaro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0549, 05, 'Santo Antnio de Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0550, 05, 'Santo Estvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0551, 05, 'So Desidrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0552, 05, 'So Domingos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0553, 05, 'So Felipe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0554, 05, 'So Flix');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0555, 05, 'So Flix do Coribe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0556, 05, 'So Francisco do Conde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0557, 05, 'So Gabriel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0558, 05, 'So Gonalo dos Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0559, 05, 'So Jos da Vitria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0560, 05, 'So Jos do Jacupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0561, 05, 'So Miguel das Matas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0562, 05, 'So Sebastio do Pass');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0563, 05, 'Sapeau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0564, 05, 'Stiro Dias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0565, 05, 'Saubara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0566, 05, 'Sade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0567, 05, 'Seabra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0568, 05, 'Sebastio Laranjeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0569, 05, 'Senhor do Bonfim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0570, 05, 'Sento S');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0571, 05, 'Serra do Ramalho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0572, 05, 'Serra Dourada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0573, 05, 'Serra Preta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0574, 05, 'Serrinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0575, 05, 'Serrolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0576, 05, 'Simes Filho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0577, 05, 'Stio do Mato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0578, 05, 'Stio do Quinto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0579, 05, 'Sobradinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0580, 05, 'Souto Soares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0581, 05, 'Tabocas do Brejo Velho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0582, 05, 'Tanhau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0583, 05, 'Tanque Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0584, 05, 'Tanquinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0585, 05, 'Tapero');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0586, 05, 'Tapiramut');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0587, 05, 'Teixeira de Freitas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0588, 05, 'Teodoro Sampaio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0589, 05, 'Teofilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0590, 05, 'Teolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0591, 05, 'Terra Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0592, 05, 'Tremedal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0593, 05, 'Tucano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0594, 05, 'Uau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0595, 05, 'Ubara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0596, 05, 'Ubaitaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0597, 05, 'Ubat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0598, 05, 'Uiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0599, 05, 'Umburanas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0600, 05, 'Una');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0601, 05, 'Urandi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0602, 05, 'Uruuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0603, 05, 'Utinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0604, 05, 'Valena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0605, 05, 'Valente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0606, 05, 'Vrzea da Roa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0607, 05, 'Vrzea do Poo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0608, 05, 'Vrzea Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0609, 05, 'Varzedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0610, 05, 'Vera Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0611, 05, 'Vereda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0612, 05, 'Vitria da Conquista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0613, 05, 'Wagner');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0614, 05, 'Wanderley');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0615, 05, 'Wenceslau Guimares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0616, 05, 'Xique-Xique');


/* ******************************* C e a r  ******************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0617, 06, 'Abaiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0618, 06, 'Acarap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0619, 06, 'Acara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0620, 06, 'Acopiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0621, 06, 'Aiuaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0622, 06, 'Alcntaras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0623, 06, 'Altaneira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0624, 06, 'Alto Santo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0625, 06, 'Amontada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0626, 06, 'Antonina do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0627, 06, 'Apuiars');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0628, 06, 'Aquiraz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0629, 06, 'Aracati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0630, 06, 'Aracoiaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0631, 06, 'Ararend');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0632, 06, 'Araripe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0633, 06, 'Aratuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0634, 06, 'Arneiroz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0635, 06, 'Assar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0636, 06, 'Aurora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0637, 06, 'Baixio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0638, 06, 'Banabui');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0639, 06, 'Barbalha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0640, 06, 'Barreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0641, 06, 'Barro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0642, 06, 'Barroquinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0643, 06, 'Baturit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0644, 06, 'Beberibe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0645, 06, 'Bela Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0646, 06, 'Boa Viagem');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0647, 06, 'Brejo Santo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0648, 06, 'Camocim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0649, 06, 'Campos Sales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0650, 06, 'Canind');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0651, 06, 'Capistrano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0652, 06, 'Caridade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0653, 06, 'Carir');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0654, 06, 'Caririau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0655, 06, 'Caris');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0656, 06, 'Carnaubal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0657, 06, 'Cascavel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0658, 06, 'Catarina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0659, 06, 'Catunda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0660, 06, 'Caucaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0661, 06, 'Cedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0662, 06, 'Chaval');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0663, 06, 'Chor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0664, 06, 'Chorozinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0665, 06, 'Corea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0666, 06, 'Crates');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0667, 06, 'Crato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0668, 06, 'Croat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0669, 06, 'Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0670, 06, 'Deputado Irapuan Pinheiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0671, 06, 'Erer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0672, 06, 'Eusbio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0673, 06, 'Farias Brito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0674, 06, 'Forquilha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0675, 06, 'Fortaleza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0676, 06, 'Fortim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0677, 06, 'Frecheirinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0678, 06, 'General Sampaio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0679, 06, 'Graa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0680, 06, 'Granja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0681, 06, 'Granjeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0682, 06, 'Groaras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0683, 06, 'Guaiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0684, 06, 'Guaraciaba do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0685, 06, 'Guaramiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0686, 06, 'Hidrolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0687, 06, 'Horizonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0688, 06, 'Ibaretama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0689, 06, 'Ibiapina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0690, 06, 'Ibicuitinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0691, 06, 'Icapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0692, 06, 'Ic');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0693, 06, 'Iguatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0694, 06, 'Independncia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0695, 06, 'Ipaporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0696, 06, 'Ipaumirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0697, 06, 'Ipu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0698, 06, 'Ipueiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0699, 06, 'Iracema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0700, 06, 'Irauuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0701, 06, 'Itaiaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0702, 06, 'Itaitinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0703, 06, 'Itapag');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0704, 06, 'Itapipoca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0705, 06, 'Itapina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0706, 06, 'Itarema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0707, 06, 'Itatira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0708, 06, 'Jaguaretama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0709, 06, 'Jaguaribara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0710, 06, 'Jaguaribe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0711, 06, 'Jaguaruana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0712, 06, 'Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0713, 06, 'Jati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0714, 06, 'Jijoca de Jericoacoara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0715, 06, 'Juazeiro do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0716, 06, 'Jucs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0717, 06, 'Lavras da Mangabeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0718, 06, 'Limoeiro do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0719, 06, 'Madalena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0720, 06, 'Maracana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0721, 06, 'Maranguape');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0722, 06, 'Marco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0723, 06, 'Martinpole');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0724, 06, 'Massap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0725, 06, 'Mauriti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0726, 06, 'Meruoca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0727, 06, 'Milagres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0728, 06, 'Milh');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0729, 06, 'Mirama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0730, 06, 'Misso Velha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0731, 06, 'Mombaa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0732, 06, 'Monsenhor Tabosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0733, 06, 'Morada Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0734, 06, 'Morajo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0735, 06, 'Morrinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0736, 06, 'Mucambo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0737, 06, 'Mulungu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0738, 06, 'Nova Olinda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0739, 06, 'Nova Russas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0740, 06, 'Novo Oriente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0741, 06, 'Ocara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0742, 06, 'Ors');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0743, 06, 'Pacajus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0744, 06, 'Pacatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0745, 06, 'Pacoti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0746, 06, 'Pacuj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0747, 06, 'Palhano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0748, 06, 'Palmcia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0749, 06, 'Paracuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0750, 06, 'Paraipaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0751, 06, 'Parambu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0752, 06, 'Paramoti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0753, 06, 'Pedra Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0754, 06, 'Penaforte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0755, 06, 'Pentecoste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0756, 06, 'Pereiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0757, 06, 'Pindoretama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0758, 06, 'Piquet Carneiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0759, 06, 'Pires Ferreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0760, 06, 'Poranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0761, 06, 'Porteiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0762, 06, 'Potengi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0763, 06, 'Potiretama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0764, 06, 'Quiterianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0765, 06, 'Quixad');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0766, 06, 'Quixel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0767, 06, 'Quixeramobim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0768, 06, 'Quixer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0769, 06, 'Redeno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0770, 06, 'Reriutaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0771, 06, 'Russas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0772, 06, 'Saboeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0773, 06, 'Salitre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0774, 06, 'Santa Quitria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0775, 06, 'Santana do Acara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0776, 06, 'Santana do Cariri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0777, 06, 'So Benedito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0778, 06, 'So Gonalo do Amarante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0779, 06, 'So Joo do Jaguaribe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0780, 06, 'So Lus do Curu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0781, 06, 'Senador Pompeu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0782, 06, 'Senador S');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0783, 06, 'Sobral');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0784, 06, 'Solonpole');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0785, 06, 'Tabuleiro do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0786, 06, 'Tamboril');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0787, 06, 'Tarrafas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0788, 06, 'Tau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0789, 06, 'Tejuuoca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0790, 06, 'Tiangu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0791, 06, 'Trairi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0792, 06, 'Tururu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0793, 06, 'Ubajara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0794, 06, 'Umari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0795, 06, 'Umirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0796, 06, 'Uruburetama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0797, 06, 'Uruoca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0798, 06, 'Varjota');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0799, 06, 'Vrzea Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0800, 06, 'Viosa do Cear');


/* ******************** D i s t r i t o   F e d e r a l ********************* */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0801, 07, 'Braslia');


/* ********************** E s p  r i t o   S a n t o *********************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0802, 08, 'Afonso Cludio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0803, 08, 'gua Doce do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0804, 08, 'guia Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0805, 08, 'Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0806, 08, 'Alfredo Chaves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0807, 08, 'Alto Rio Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0808, 08, 'Anchieta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0809, 08, 'Apiac');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0810, 08, 'Aracruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0811, 08, 'Atilio Vivacqua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0812, 08, 'Baixo Guandu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0813, 08, 'Barra de So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0814, 08, 'Boa Esperana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0815, 08, 'Bom Jesus do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0816, 08, 'Brejetuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0817, 08, 'Cachoeiro de Itapemirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0818, 08, 'Cariacica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0819, 08, 'Castelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0820, 08, 'Colatina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0821, 08, 'Conceio da Barra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0822, 08, 'Conceio do Castelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0823, 08, 'Divino de So Loureno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0824, 08, 'Domingos Martins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0825, 08, 'Dores do Rio Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0826, 08, 'Ecoporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0827, 08, 'Fundo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0828, 08, 'Guau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0829, 08, 'Guarapari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0830, 08, 'Ibatiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0831, 08, 'Ibirau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0832, 08, 'Ibitirama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0833, 08, 'Iconha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0834, 08, 'Irupi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0835, 08, 'Itaguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0836, 08, 'Itapemirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0837, 08, 'Itarana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0838, 08, 'Ina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0839, 08, 'Jaguar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0840, 08, 'Jernimo Monteiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0841, 08, 'Joo Neiva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0842, 08, 'Laranja da Terra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0843, 08, 'Linhares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0844, 08, 'Mantenpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0845, 08, 'Maratazes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0846, 08, 'Marechal Floriano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0847, 08, 'Marilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0848, 08, 'Mimoso do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0849, 08, 'Montanha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0850, 08, 'Mucurici');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0851, 08, 'Muniz Freire');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0852, 08, 'Muqui');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0853, 08, 'Nova Vencia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0854, 08, 'Pancas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0855, 08, 'Pedro Canrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0856, 08, 'Pinheiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0857, 08, 'Pima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0858, 08, 'Ponto Belo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0859, 08, 'Presidente Kennedy');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0860, 08, 'Rio Bananal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0861, 08, 'Rio Novo do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0862, 08, 'Santa Leopoldina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0863, 08, 'Santa Maria de Jetib');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0864, 08, 'Santa Teresa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0865, 08, 'So Domingos do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0866, 08, 'So Gabriel da Palha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0867, 08, 'So Jos do Calado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0868, 08, 'So Mateus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0869, 08, 'So Roque do Cana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0870, 08, 'Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0871, 08, 'Sooretama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0872, 08, 'Vargem Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0873, 08, 'Venda Nova do Imigrante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0874, 08, 'Viana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0875, 08, 'Vila Pavo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0876, 08, 'Vila Valrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0877, 08, 'Vila Velha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0878, 08, 'Vitria');


/* ******************************* G o i  s ******************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0879, 09, 'Abadia de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0880, 09, 'Abadinia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0881, 09, 'Acrena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0882, 09, 'Adelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0883, 09, 'gua Fria de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0884, 09, 'gua Limpa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0885, 09, 'guas Lindas de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0886, 09, 'Alexnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0887, 09, 'Alondia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0888, 09, 'Alto Horizonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0889, 09, 'Alto Paraso de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0890, 09, 'Alvorada do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0891, 09, 'Amaralina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0892, 09, 'Americano do Brasil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0893, 09, 'Amorinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0894, 09, 'Anpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0895, 09, 'Anhanguera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0896, 09, 'Anicuns');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0897, 09, 'Aparecida de Goinia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0898, 09, 'Aparecida do Rio Doce');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0899, 09, 'Apor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0900, 09, 'Arau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0901, 09, 'Aragaras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0902, 09, 'Aragoinia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0903, 09, 'Araguapaz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0904, 09, 'Arenpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0905, 09, 'Aruan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0906, 09, 'Aurilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0907, 09, 'Avelinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0908, 09, 'Baliza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0909, 09, 'Barro Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0910, 09, 'Bela Vista de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0911, 09, 'Bom Jardim de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0912, 09, 'Bom Jesus de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0913, 09, 'Bonfinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0914, 09, 'Bonpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0915, 09, 'Brazabrantes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0916, 09, 'Britnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0917, 09, 'Buriti Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0918, 09, 'Buriti de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0919, 09, 'Buritinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0920, 09, 'Cabeceiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0921, 09, 'Cachoeira Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0922, 09, 'Cachoeira de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0923, 09, 'Cachoeira Dourada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0924, 09, 'Cau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0925, 09, 'Caiapnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0926, 09, 'Caldas Novas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0927, 09, 'Caldazinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0928, 09, 'Campestre de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0929, 09, 'Campinau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0930, 09, 'Campinorte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0931, 09, 'Campo Alegre de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0932, 09, 'Campos Belos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0933, 09, 'Campos Verdes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0934, 09, 'Carmo do Rio Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0935, 09, 'Castelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0936, 09, 'Catalo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0937, 09, 'Catura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0938, 09, 'Cavalcante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0939, 09, 'Ceres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0940, 09, 'Cezarina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0941, 09, 'Chapado do Cu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0942, 09, 'city Ocidental');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0943, 09, 'Cocalzinho de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0944, 09, 'Colinas do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0945, 09, 'Crrego do Ouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0946, 09, 'Corumb de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0947, 09, 'Corumbaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0948, 09, 'Cristalina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0949, 09, 'Cristianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0950, 09, 'Crixs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0951, 09, 'Cromnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0952, 09, 'Cumari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0953, 09, 'Damianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0954, 09, 'Damolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0955, 09, 'Davinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0956, 09, 'Diorama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0957, 09, 'Divinpolis de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0958, 09, 'Doverlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0959, 09, 'Edealina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0960, 09, 'Edia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0961, 09, 'Estrela do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0962, 09, 'Faina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0963, 09, 'Fazenda Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0964, 09, 'Firminpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0965, 09, 'Flores de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0966, 09, 'Formosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0967, 09, 'Formoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0968, 09, 'Goianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0969, 09, 'Goiandira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0970, 09, 'Goiansia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0971, 09, 'Goinia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0972, 09, 'Goianira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0973, 09, 'Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0974, 09, 'Goiatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0975, 09, 'Gouvelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0976, 09, 'Guap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0977, 09, 'Guarata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0978, 09, 'Guarani de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0979, 09, 'Guarinos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0980, 09, 'Heitora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0981, 09, 'Hidrolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0982, 09, 'Hidrolina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0983, 09, 'Iaciara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0984, 09, 'Inaciolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0985, 09, 'Indiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0986, 09, 'Inhumas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0987, 09, 'Ipameri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0988, 09, 'Ipor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0989, 09, 'Israelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0990, 09, 'Itabera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0991, 09, 'Itaguari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0992, 09, 'Itaguaru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0993, 09, 'Itaj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0994, 09, 'Itapaci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0995, 09, 'Itapirapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0996, 09, 'Itapuranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0997, 09, 'Itarum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0998, 09, 'Itauu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (0999, 09, 'Itumbiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1000, 09, 'Ivolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1001, 09, 'Jandaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1002, 09, 'Jaragu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1003, 09, 'Jata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1004, 09, 'Jaupaci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1005, 09, 'Jespolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1006, 09, 'Jovinia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1007, 09, 'Jussara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1008, 09, 'Leopoldo de Bulhes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1009, 09, 'Luzinia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1010, 09, 'Mairipotaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1011, 09, 'Mamba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1012, 09, 'Mara Rosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1013, 09, 'Marzago');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1014, 09, 'Matrinch');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1015, 09, 'Maurilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1016, 09, 'Mimoso de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1017, 09, 'Minau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1018, 09, 'Mineiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1019, 09, 'Moipor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1020, 09, 'Monte Alegre de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1021, 09, 'Montes Claros de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1022, 09, 'Montividiu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1023, 09, 'Montividiu do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1024, 09, 'Morrinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1025, 09, 'Morro Agudo de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1026, 09, 'Mossmedes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1027, 09, 'Mozarlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1028, 09, 'Mundo Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1029, 09, 'Mutunpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1030, 09, 'Nazrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1031, 09, 'Nerpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1032, 09, 'Niquelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1033, 09, 'Nova Amrica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1034, 09, 'Nova Aurora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1035, 09, 'Nova Crixs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1036, 09, 'Nova Glria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1037, 09, 'Nova Iguau de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1038, 09, 'Nova Roma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1039, 09, 'Nova Veneza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1040, 09, 'Novo Brasil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1041, 09, 'Novo Gama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1042, 09, 'Novo Planalto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1043, 09, 'Orizona');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1044, 09, 'Ouro Verde de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1045, 09, 'Ouvidor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1046, 09, 'Padre Bernardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1047, 09, 'Palestina de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1048, 09, 'Palmeiras de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1049, 09, 'Palmelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1050, 09, 'Palminpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1051, 09, 'Panam');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1052, 09, 'Paranaiguara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1053, 09, 'Parana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1054, 09, 'Perolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1055, 09, 'Petrolina de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1056, 09, 'Pilar de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1057, 09, 'Piracanjuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1058, 09, 'Piranhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1059, 09, 'Pirenpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1060, 09, 'Pires do Rio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1061, 09, 'Planaltina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1062, 09, 'Pontalina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1063, 09, 'Porangatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1064, 09, 'Porteiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1065, 09, 'Portelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1066, 09, 'Posse');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1067, 09, 'Professor Jamil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1068, 09, 'Quirinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1069, 09, 'Rialma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1070, 09, 'Rianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1071, 09, 'Rio Quente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1072, 09, 'Rio Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1073, 09, 'Rubiataba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1074, 09, 'Sanclerlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1075, 09, 'Santa Brbara de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1076, 09, 'Santa Cruz de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1077, 09, 'Santa F de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1078, 09, 'Santa Helena de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1079, 09, 'Santa Isabel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1080, 09, 'Santa Rita do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1081, 09, 'Santa Rita do Novo Destino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1082, 09, 'Santa Rosa de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1083, 09, 'Santa Tereza de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1084, 09, 'Santa Terezinha de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1085, 09, 'Santo Antnio da Barra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1086, 09, 'Santo Antnio de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1087, 09, 'Santo Antnio do Descoberto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1088, 09, 'So Domingos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1089, 09, 'So Francisco de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1090, 09, 'So Joo d`Aliana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1091, 09, 'So Joo da Parana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1092, 09, 'So Lus de Montes Belos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1093, 09, 'So Luz do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1094, 09, 'So Miguel do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1095, 09, 'So Miguel do Passa Quatro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1096, 09, 'So Patrcio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1097, 09, 'So Simo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1098, 09, 'Senador Canedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1099, 09, 'Serranpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1100, 09, 'Silvnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1101, 09, 'Simolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1102, 09, 'Stio d`Abadia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1103, 09, 'Taquaral de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1104, 09, 'Teresina de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1105, 09, 'Terezpolis de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1106, 09, 'Trs Ranchos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1107, 09, 'Trindade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1108, 09, 'Trombas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1109, 09, 'Turvnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1110, 09, 'Turvelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1111, 09, 'Uirapuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1112, 09, 'Uruau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1113, 09, 'Uruana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1114, 09, 'Uruta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1115, 09, 'Valparaso de Gois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1116, 09, 'Varjo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1117, 09, 'Vianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1118, 09, 'Vicentinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1119, 09, 'Vila Boa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1120, 09, 'Vila Propcio');


/* **************************** M a r a n h  o ***************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1121, 10, 'Aailndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1122, 10, 'Afonso Cunha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1123, 10, 'gua Doce do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1124, 10, 'Alcntara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1125, 10, 'Aldeias Altas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1126, 10, 'Altamira do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1127, 10, 'Alto Alegre do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1128, 10, 'Alto Alegre do Pindar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1129, 10, 'Alto Parnaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1130, 10, 'Amap do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1131, 10, 'Amarante do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1132, 10, 'Anajatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1133, 10, 'Anapurus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1134, 10, 'Apicum-Au');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1135, 10, 'Araguan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1136, 10, 'Araioses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1137, 10, 'Arame');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1138, 10, 'Arari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1139, 10, 'Axix');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1140, 10, 'Bacabal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1141, 10, 'Bacabeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1142, 10, 'Bacuri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1143, 10, 'Bacurituba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1144, 10, 'Balsas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1145, 10, 'Baro de Graja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1146, 10, 'Barra do Corda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1147, 10, 'Barreirinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1148, 10, 'Bela Vista do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1149, 10, 'Belgua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1150, 10, 'Benedito Leite');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1151, 10, 'Bequimo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1152, 10, 'Bernardo do Mearim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1153, 10, 'Boa Vista do Gurupi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1154, 10, 'Bom Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1155, 10, 'Bom Jesus das Selvas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1156, 10, 'Bom Lugar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1157, 10, 'Brejo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1158, 10, 'Brejo de Areia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1159, 10, 'Buriti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1160, 10, 'Buriti Bravo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1161, 10, 'Buriticupu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1162, 10, 'Buritirana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1163, 10, 'Cachoeira Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1164, 10, 'Cajapi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1165, 10, 'Cajari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1166, 10, 'Campestre do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1167, 10, 'Cndido Mendes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1168, 10, 'Cantanhede');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1169, 10, 'Capinzal do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1170, 10, 'Carolina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1171, 10, 'Carutapera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1172, 10, 'Caxias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1173, 10, 'Cedral');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1174, 10, 'Central do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1175, 10, 'Centro do Guilherme');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1176, 10, 'Centro Novo do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1177, 10, 'Chapadinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1178, 10, 'Cidelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1179, 10, 'Cod');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1180, 10, 'Coelho Neto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1181, 10, 'Colinas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1182, 10, 'Conceio do Lago-Au');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1183, 10, 'Coroat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1184, 10, 'Cururupu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1185, 10, 'Davinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1186, 10, 'Dom Pedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1187, 10, 'Duque Bacelar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1188, 10, 'Esperantinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1189, 10, 'Estreito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1190, 10, 'Feira Nova do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1191, 10, 'Fernando Falco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1192, 10, 'Formosa da Serra Negra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1193, 10, 'Fortaleza dos Nogueiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1194, 10, 'Fortuna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1195, 10, 'Godofredo Viana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1196, 10, 'Gonalves Dias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1197, 10, 'Governador Archer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1198, 10, 'Governador Edison Lobo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1199, 10, 'Governador Eugnio Barros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1200, 10, 'Governador Luiz Rocha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1201, 10, 'Governador Newton Bello');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1202, 10, 'Governador Nunes Freire');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1203, 10, 'Graa Aranha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1204, 10, 'Graja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1205, 10, 'Guimares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1206, 10, 'Humberto de Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1207, 10, 'Icatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1208, 10, 'Igarap do Meio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1209, 10, 'Igarap Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1210, 10, 'Imperatriz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1211, 10, 'Itaipava do Graja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1212, 10, 'Itapecuru Mirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1213, 10, 'Itinga do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1214, 10, 'Jatob');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1215, 10, 'Jenipapo dos Vieiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1216, 10, 'Joo Lisboa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1217, 10, 'Joselndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1218, 10, 'Junco do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1219, 10, 'Lago da Pedra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1220, 10, 'Lago do Junco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1221, 10, 'Lago dos Rodrigues');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1222, 10, 'Lago Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1223, 10, 'Lagoa do Mato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1224, 10, 'Lagoa Grande do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1225, 10, 'Lajeado Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1226, 10, 'Lima Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1227, 10, 'Loreto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1228, 10, 'Lus Domingues');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1229, 10, 'Magalhes de Almeida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1230, 10, 'Maracaum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1231, 10, 'Maraj do Sena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1232, 10, 'Maranhozinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1233, 10, 'Mata Roma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1234, 10, 'Matinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1235, 10, 'Mates');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1236, 10, 'Mates do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1237, 10, 'Milagres do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1238, 10, 'Mirador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1239, 10, 'Miranda do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1240, 10, 'Mirinzal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1241, 10, 'Mono');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1242, 10, 'Montes Altos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1243, 10, 'Morros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1244, 10, 'Nina Rodrigues');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1245, 10, 'Nova Colinas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1246, 10, 'Nova Iorque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1247, 10, 'Nova Olinda do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1248, 10, 'Olho d`gua das Cunhs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1249, 10, 'Olinda Nova do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1250, 10, 'Pao do Lumiar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1251, 10, 'Palmeirndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1252, 10, 'Paraibano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1253, 10, 'Parnarama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1254, 10, 'Passagem Franca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1255, 10, 'Pastos Bons');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1256, 10, 'Paulino Neves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1257, 10, 'Paulo Ramos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1258, 10, 'Pedreiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1259, 10, 'Pedro do Rosrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1260, 10, 'Penalva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1261, 10, 'Peri Mirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1262, 10, 'Peritor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1263, 10, 'Pindar-Mirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1264, 10, 'Pinheiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1265, 10, 'Pio XII');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1266, 10, 'Pirapemas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1267, 10, 'Poo de Pedras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1268, 10, 'Porto Franco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1269, 10, 'Porto Rico do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1270, 10, 'Presidente Dutra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1271, 10, 'Presidente Juscelino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1272, 10, 'Presidente Mdici');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1273, 10, 'Presidente Sarney');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1274, 10, 'Presidente Vargas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1275, 10, 'Primeira Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1276, 10, 'Raposa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1277, 10, 'Riacho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1278, 10, 'Ribamar Fiquene');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1279, 10, 'Rosrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1280, 10, 'Sambaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1281, 10, 'Santa Filomena do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1282, 10, 'Santa Helena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1283, 10, 'Santa Ins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1284, 10, 'Santa Luzia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1285, 10, 'Santa Luzia do Paru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1286, 10, 'Santa Quitria do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1287, 10, 'Santa Rita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1288, 10, 'Santana do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1289, 10, 'Santo Amaro do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1290, 10, 'Santo Antnio dos Lopes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1291, 10, 'So Benedito do Rio Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1292, 10, 'So Bento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1293, 10, 'So Bernardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1294, 10, 'So Domingos do Azeito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1295, 10, 'So Domingos do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1296, 10, 'So Flix de Balsas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1297, 10, 'So Francisco do Brejo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1298, 10, 'So Francisco do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1299, 10, 'So Joo Batista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1300, 10, 'So Joo do Car');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1301, 10, 'So Joo do Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1302, 10, 'So Joo do Soter');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1303, 10, 'So Joo dos Patos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1304, 10, 'So Jos de Ribamar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1305, 10, 'So Jos dos Baslios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1306, 10, 'So Lus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1307, 10, 'So Lus Gonzaga do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1308, 10, 'So Mateus do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1309, 10, 'So Pedro da gua Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1310, 10, 'So Pedro dos Crentes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1311, 10, 'So Raimundo das Mangabeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1312, 10, 'So Raimundo do Doca Bezerra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1313, 10, 'So Roberto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1314, 10, 'So Vicente Ferrer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1315, 10, 'Satubinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1316, 10, 'Senador Alexandre Costa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1317, 10, 'Senador La Rocque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1318, 10, 'Serrano do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1319, 10, 'Stio Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1320, 10, 'Sucupira do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1321, 10, 'Sucupira do Riacho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1322, 10, 'Tasso Fragoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1323, 10, 'Timbiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1324, 10, 'Timon');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1325, 10, 'Trizidela do Vale');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1326, 10, 'Tufilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1327, 10, 'Tuntum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1328, 10, 'Turiau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1329, 10, 'Turilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1330, 10, 'Tutia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1331, 10, 'Urbano Santos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1332, 10, 'Vargem Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1333, 10, 'Viana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1334, 10, 'Vila Nova dos Martrios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1335, 10, 'Vitria do Mearim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1336, 10, 'Vitorino Freire');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1337, 10, 'Z Doca');


/* ************************* M a t o   G r o s s o ************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1338, 11, 'Acorizal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1339, 11, 'gua Boa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1340, 11, 'Alta Floresta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1341, 11, 'Alto Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1342, 11, 'Alto Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1343, 11, 'Alto Garas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1344, 11, 'Alto Paraguai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1345, 11, 'Alto Taquari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1346, 11, 'Apiacs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1347, 11, 'Araguaiana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1348, 11, 'Araguainha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1349, 11, 'Araputanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1350, 11, 'Arenpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1351, 11, 'Aripuan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1352, 11, 'Baro de Melgao');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1353, 11, 'Barra do Bugres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1354, 11, 'Barra do Garas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1355, 11, 'Brasnorte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1356, 11, 'Cceres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1357, 11, 'Campinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1358, 11, 'Campo Novo do Parecis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1359, 11, 'Campo Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1360, 11, 'Campos de Jlio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1361, 11, 'Canabrava do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1362, 11, 'Canarana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1363, 11, 'Carlinda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1364, 11, 'Castanheira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1365, 11, 'Chapada dos Guimares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1366, 11, 'Cludia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1367, 11, 'Cocalinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1368, 11, 'Colder');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1369, 11, 'Comodoro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1370, 11, 'Confresa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1371, 11, 'Cotriguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1372, 11, 'Cuiab');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1373, 11, 'Denise');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1374, 11, 'Diamantino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1375, 11, 'Dom Aquino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1376, 11, 'Feliz Natal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1377, 11, 'Figueirpolis d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1378, 11, 'Gacha do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1379, 11, 'General Carneiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1380, 11, 'Glria d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1381, 11, 'Guarant do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1382, 11, 'Guiratinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1383, 11, 'Indiava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1384, 11, 'Itaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1385, 11, 'Itiquira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1386, 11, 'Jaciara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1387, 11, 'Jangada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1388, 11, 'Jauru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1389, 11, 'Juara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1390, 11, 'Juna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1391, 11, 'Juruena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1392, 11, 'Juscimeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1393, 11, 'Lambari d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1394, 11, 'Lucas do Rio Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1395, 11, 'Lucira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1396, 11, 'Marcelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1397, 11, 'Matup');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1398, 11, 'Mirassol d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1399, 11, 'Nobres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1400, 11, 'Nortelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1401, 11, 'Nossa Senhora do Livramento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1402, 11, 'Nova Bandeirantes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1403, 11, 'Nova Brasilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1404, 11, 'Nova Cana do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1405, 11, 'Nova Guarita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1406, 11, 'Nova Lacerda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1407, 11, 'Nova Marilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1408, 11, 'Nova Maring');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1409, 11, 'Nova Monte Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1410, 11, 'Nova Mutum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1411, 11, 'Nova Olmpia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1412, 11, 'Nova Ubirat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1413, 11, 'Nova Xavantina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1414, 11, 'Novo Horizonte do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1415, 11, 'Novo Mundo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1416, 11, 'Novo So Joaquim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1417, 11, 'Paranata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1418, 11, 'Paranatinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1419, 11, 'Pedra Preta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1420, 11, 'Peixoto de Azevedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1421, 11, 'Planalto da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1422, 11, 'Pocon');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1423, 11, 'Pontal do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1424, 11, 'Ponte Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1425, 11, 'Pontes e Lacerda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1426, 11, 'Porto Alegre do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1427, 11, 'Porto dos Gachos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1428, 11, 'Porto Esperidio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1429, 11, 'Porto Estrela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1430, 11, 'Poxoro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1431, 11, 'Primavera do Leste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1432, 11, 'Querncia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1433, 11, 'Reserva do Cabaal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1434, 11, 'Ribeiro Cascalheira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1435, 11, 'Ribeirozinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1436, 11, 'Rio Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1437, 11, 'Rondonpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1438, 11, 'Rosrio Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1439, 11, 'Salto do Cu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1440, 11, 'Santa Carmem');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1441, 11, 'Santa Terezinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1442, 11, 'Santo Afonso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1443, 11, 'Santo Antnio do Leverger');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1444, 11, 'So Flix do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1445, 11, 'So Jos do Povo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1446, 11, 'So Jos do Rio Claro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1447, 11, 'So Jos do Xingu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1448, 11, 'So Jos dos Quatro Marcos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1449, 11, 'So Pedro da Cipa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1450, 11, 'Sapezal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1451, 11, 'Sinop');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1452, 11, 'Sorriso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1453, 11, 'Tabapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1454, 11, 'Tangar da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1455, 11, 'Tapurah');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1456, 11, 'Terra Nova do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1457, 11, 'Tesouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1458, 11, 'Torixoru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1459, 11, 'Unio do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1460, 11, 'Vrzea Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1461, 11, 'Vera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1462, 11, 'Vila Bela da Santssima Trindade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1463, 11, 'Vila Rica');



/* ****************** M a t o   G r o s s o   do   S u l ******************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1464, 12, 'gua Clara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1465, 12, 'Alcinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1466, 12, 'Amamba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1467, 12, 'Anastcio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1468, 12, 'Anaurilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1469, 12, 'Anglica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1470, 12, 'Antnio Joo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1471, 12, 'Aparecida do Taboado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1472, 12, 'Aquidauana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1473, 12, 'Aral Moreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1474, 12, 'Bandeirantes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1475, 12, 'Bataguassu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1476, 12, 'Bataipor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1477, 12, 'Bela Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1478, 12, 'Bodoquena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1479, 12, 'Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1480, 12, 'Brasilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1481, 12, 'Caarap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1482, 12, 'Camapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1483, 12, 'Campo Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1484, 12, 'Caracol');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1485, 12, 'Cassilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1486, 12, 'Chapado do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1487, 12, 'Corguinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1488, 12, 'Coronel Sapucaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1489, 12, 'Corumb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1490, 12, 'Costa Rica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1491, 12, 'Coxim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1492, 12, 'Deodpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1493, 12, 'Dois Irmos do Buriti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1494, 12, 'Douradina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1495, 12, 'Dourados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1496, 12, 'Eldorado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1497, 12, 'Ftima do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1498, 12, 'Glria de Dourados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1499, 12, 'Guia Lopes da Laguna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1500, 12, 'Iguatemi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1501, 12, 'Inocncia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1502, 12, 'Itapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1503, 12, 'Itaquira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1504, 12, 'Ivinhema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1505, 12, 'Japor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1506, 12, 'Jaraguari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1507, 12, 'Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1508, 12, 'Jate');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1509, 12, 'Juti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1510, 12, 'Ladrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1511, 12, 'Laguna Carap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1512, 12, 'Maracaju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1513, 12, 'Miranda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1514, 12, 'Mundo Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1515, 12, 'Navira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1516, 12, 'Nioaque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1517, 12, 'Nova Alvorada do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1518, 12, 'Nova Andradina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1519, 12, 'Novo Horizonte do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1520, 12, 'Paranaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1521, 12, 'Paranhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1522, 12, 'Pedro Gomes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1523, 12, 'Ponta Por');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1524, 12, 'Porto Murtinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1525, 12, 'Ribas do Rio Pardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1526, 12, 'Rio Brilhante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1527, 12, 'Rio Negro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1528, 12, 'Rio Verde de Mato Grosso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1529, 12, 'Rochedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1530, 12, 'Santa Rita do Pardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1531, 12, 'So Gabriel do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1532, 12, 'Selvria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1533, 12, 'Sete Quedas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1534, 12, 'Sidrolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1535, 12, 'Sonora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1536, 12, 'Tacuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1537, 12, 'Taquarussu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1538, 12, 'Terenos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1539, 12, 'Trs Lagoas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1540, 12, 'Vicentina');


/* ************************ M i n a s   G e r a i s ************************* */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1541, 13, 'Abadia dos Dourados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1542, 13, 'Abaet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1543, 13, 'Abre Campo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1544, 13, 'Acaiaca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1545, 13, 'Aucena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1546, 13, 'gua Boa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1547, 13, 'gua Comprida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1548, 13, 'Aguanil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1549, 13, 'guas Formosas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1550, 13, 'guas Vermelhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1551, 13, 'Aimors');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1552, 13, 'Aiuruoca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1553, 13, 'Alagoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1554, 13, 'Albertina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1555, 13, 'Alm Paraba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1556, 13, 'Alfenas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1557, 13, 'Alfredo Vasconcelos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1558, 13, 'Almenara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1559, 13, 'Alpercata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1560, 13, 'Alpinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1561, 13, 'Alterosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1562, 13, 'Alto Capara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1563, 13, 'Alto Jequitib');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1564, 13, 'Alto Rio Doce');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1565, 13, 'Alvarenga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1566, 13, 'Alvinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1567, 13, 'Alvorada de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1568, 13, 'Amparo do Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1569, 13, 'Andradas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1570, 13, 'Andrelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1571, 13, 'Angelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1572, 13, 'Antnio Carlos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1573, 13, 'Antnio Dias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1574, 13, 'Antnio Prado de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1575, 13, 'Araa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1576, 13, 'Aracitaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1577, 13, 'Araua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1578, 13, 'Araguari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1579, 13, 'Arantina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1580, 13, 'Araponga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1581, 13, 'Arapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1582, 13, 'Arapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1583, 13, 'Arajos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1584, 13, 'Arax');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1585, 13, 'Arceburgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1586, 13, 'Arcos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1587, 13, 'Areado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1588, 13, 'Argirita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1589, 13, 'Aricanduva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1590, 13, 'Arinos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1591, 13, 'Astolfo Dutra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1592, 13, 'Atalia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1593, 13, 'Augusto de Lima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1594, 13, 'Baependi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1595, 13, 'Baldim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1596, 13, 'Bambu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1597, 13, 'Bandeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1598, 13, 'Bandeira do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1599, 13, 'Baro de Cocais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1600, 13, 'Baro de Monte Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1601, 13, 'Barbacena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1602, 13, 'Barra Longa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1603, 13, 'Barroso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1604, 13, 'Bela Vista de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1605, 13, 'Belmiro Braga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1606, 13, 'Belo Horizonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1607, 13, 'Belo Oriente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1608, 13, 'Belo Vale');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1609, 13, 'Berilo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1610, 13, 'Berizal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1611, 13, 'Bertpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1612, 13, 'Betim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1613, 13, 'Bias Fortes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1614, 13, 'Bicas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1615, 13, 'Biquinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1616, 13, 'Boa Esperana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1617, 13, 'Bocaina de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1618, 13, 'Bocaiva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1619, 13, 'Bom Despacho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1620, 13, 'Bom Jardim de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1621, 13, 'Bom Jesus da Penha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1622, 13, 'Bom Jesus do Amparo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1623, 13, 'Bom Jesus do Galho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1624, 13, 'Bom Repouso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1625, 13, 'Bom Sucesso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1626, 13, 'Bonfim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1627, 13, 'Bonfinpolis de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1628, 13, 'Bonito de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1629, 13, 'Borda da Mata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1630, 13, 'Botelhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1631, 13, 'Botumirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1632, 13, 'Brs Pires');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1633, 13, 'Brasilndia de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1634, 13, 'Braslia de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1635, 13, 'Braspolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1636, 13, 'Branas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1637, 13, 'Brumadinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1638, 13, 'Bueno Brando');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1639, 13, 'Buenpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1640, 13, 'Bugre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1641, 13, 'Buritis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1642, 13, 'Buritizeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1643, 13, 'Cabeceira Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1644, 13, 'Cabo Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1645, 13, 'Cachoeira da Prata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1646, 13, 'Cachoeira de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1647, 13, 'Cachoeira de Paje');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1648, 13, 'Cachoeira Dourada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1649, 13, 'Caetanpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1650, 13, 'Caet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1651, 13, 'Caiana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1652, 13, 'Cajuri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1653, 13, 'Caldas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1654, 13, 'Camacho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1655, 13, 'Camanducaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1656, 13, 'Cambu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1657, 13, 'Cambuquira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1658, 13, 'Campanrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1659, 13, 'Campanha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1660, 13, 'Campestre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1661, 13, 'Campina Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1662, 13, 'Campo Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1663, 13, 'Campo Belo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1664, 13, 'Campo do Meio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1665, 13, 'Campo Florido');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1666, 13, 'Campos Altos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1667, 13, 'Campos Gerais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1668, 13, 'Cana Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1669, 13, 'Cana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1670, 13, 'Canpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1671, 13, 'Candeias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1672, 13, 'Cantagalo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1673, 13, 'Capara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1674, 13, 'Capela Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1675, 13, 'Capelinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1676, 13, 'Capetinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1677, 13, 'Capim Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1678, 13, 'Capinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1679, 13, 'Capito Andrade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1680, 13, 'Capito Enas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1681, 13, 'Capitlio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1682, 13, 'Caputira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1683, 13, 'Cara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1684, 13, 'Caranaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1685, 13, 'Caranda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1686, 13, 'Carangola');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1687, 13, 'Caratinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1688, 13, 'Carbonita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1689, 13, 'Careau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1690, 13, 'Carlos Chagas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1691, 13, 'Carmsia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1692, 13, 'Carmo da Cachoeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1693, 13, 'Carmo da Mata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1694, 13, 'Carmo de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1695, 13, 'Carmo do Cajuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1696, 13, 'Carmo do Paranaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1697, 13, 'Carmo do Rio Claro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1698, 13, 'Carmpolis de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1699, 13, 'Carneirinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1700, 13, 'Carrancas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1701, 13, 'Carvalhpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1702, 13, 'Carvalhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1703, 13, 'Casa Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1704, 13, 'Cascalho Rico');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1705, 13, 'Cssia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1706, 13, 'Cataguases');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1707, 13, 'Catas Altas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1708, 13, 'Catas Altas da Noruega');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1709, 13, 'Catuji');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1710, 13, 'Catuti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1711, 13, 'Caxambu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1712, 13, 'Cedro do Abaet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1713, 13, 'Central de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1714, 13, 'Centralina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1715, 13, 'Chcara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1716, 13, 'Chal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1717, 13, 'Chapada do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1718, 13, 'Chapada Gacha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1719, 13, 'Chiador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1720, 13, 'Cipotnea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1721, 13, 'Claraval');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1722, 13, 'Claro dos Poes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1723, 13, 'Cludio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1724, 13, 'Coimbra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1725, 13, 'Coluna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1726, 13, 'Comendador Gomes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1727, 13, 'Comercinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1728, 13, 'Conceio da Aparecida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1729, 13, 'Conceio da Barra de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1730, 13, 'Conceio das Alagoas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1731, 13, 'Conceio das Pedras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1732, 13, 'Conceio de Ipanema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1733, 13, 'Conceio do Mato Dentro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1734, 13, 'Conceio do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1735, 13, 'Conceio do Rio Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1736, 13, 'Conceio dos Ouros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1737, 13, 'Cnego Marinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1738, 13, 'Confins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1739, 13, 'Congonhal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1740, 13, 'Congonhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1741, 13, 'Congonhas do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1742, 13, 'Conquista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1743, 13, 'Conselheiro Lafaiete');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1744, 13, 'Conselheiro Pena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1745, 13, 'Consolao');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1746, 13, 'Contagem');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1747, 13, 'Coqueiral');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1748, 13, 'Corao de Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1749, 13, 'Cordisburgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1750, 13, 'Cordislndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1751, 13, 'Corinto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1752, 13, 'Coroaci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1753, 13, 'Coromandel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1754, 13, 'Coronel Fabriciano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1755, 13, 'Coronel Murta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1756, 13, 'Coronel Pacheco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1757, 13, 'Coronel Xavier Chaves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1758, 13, 'Crrego Danta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1759, 13, 'Crrego do Bom Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1760, 13, 'Crrego Fundo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1761, 13, 'Crrego Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1762, 13, 'Couto de Magalhes de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1763, 13, 'Crislita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1764, 13, 'Cristais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1765, 13, 'Cristlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1766, 13, 'Cristiano Otoni');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1767, 13, 'Cristina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1768, 13, 'Crucilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1769, 13, 'Cruzeiro da Fortaleza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1770, 13, 'Cruzlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1771, 13, 'Cuparaque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1772, 13, 'Curral de Dentro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1773, 13, 'Curvelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1774, 13, 'Datas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1775, 13, 'Delfim Moreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1776, 13, 'Delfinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1777, 13, 'Delta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1778, 13, 'Descoberto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1779, 13, 'Desterro de Entre Rios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1780, 13, 'Desterro do Melo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1781, 13, 'Diamantina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1782, 13, 'Diogo de Vasconcelos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1783, 13, 'Dionsio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1784, 13, 'Divinsia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1785, 13, 'Divino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1786, 13, 'Divino das Laranjeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1787, 13, 'Divinolndia de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1788, 13, 'Divinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1789, 13, 'Divisa Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1790, 13, 'Divisa Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1791, 13, 'Divispolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1792, 13, 'Dom Bosco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1793, 13, 'Dom Cavati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1794, 13, 'Dom Joaquim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1795, 13, 'Dom Silvrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1796, 13, 'Dom Vioso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1797, 13, 'Dona Eusbia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1798, 13, 'Dores de Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1799, 13, 'Dores de Guanhes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1800, 13, 'Dores do Indai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1801, 13, 'Dores do Turvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1802, 13, 'Dorespolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1803, 13, 'Douradoquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1804, 13, 'Durand');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1805, 13, 'Eli Mendes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1806, 13, 'Engenheiro Caldas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1807, 13, 'Engenheiro Navarro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1808, 13, 'Entre Folhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1809, 13, 'Entre Rios de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1810, 13, 'Ervlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1811, 13, 'Esmeraldas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1812, 13, 'Espera Feliz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1813, 13, 'Espinosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1814, 13, 'Esprito Santo do Dourado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1815, 13, 'Estiva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1816, 13, 'Estrela Dalva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1817, 13, 'Estrela do Indai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1818, 13, 'Estrela do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1819, 13, 'Eugenpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1820, 13, 'Ewbank da Cmara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1821, 13, 'Extrema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1822, 13, 'Fama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1823, 13, 'Faria Lemos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1824, 13, 'Felcio dos Santos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1825, 13, 'Felisburgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1826, 13, 'Felixlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1827, 13, 'Fernandes Tourinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1828, 13, 'Ferros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1829, 13, 'Fervedouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1830, 13, 'Florestal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1831, 13, 'Formiga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1832, 13, 'Formoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1833, 13, 'Fortaleza de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1834, 13, 'Fortuna de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1835, 13, 'Francisco Badar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1836, 13, 'Francisco Dumont');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1837, 13, 'Francisco S');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1838, 13, 'Franciscpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1839, 13, 'Frei Gaspar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1840, 13, 'Frei Inocncio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1841, 13, 'Frei Lagonegro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1842, 13, 'Fronteira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1843, 13, 'Fronteira dos Vales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1844, 13, 'Fruta de Leite');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1845, 13, 'Frutal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1846, 13, 'Funilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1847, 13, 'Galilia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1848, 13, 'Gameleiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1849, 13, 'Glaucilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1850, 13, 'Goiabeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1851, 13, 'Goian');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1852, 13, 'Gonalves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1853, 13, 'Gonzaga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1854, 13, 'Gouveia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1855, 13, 'Governador Valadares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1856, 13, 'Gro Mogol');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1857, 13, 'Grupiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1858, 13, 'Guanhes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1859, 13, 'Guap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1860, 13, 'Guaraciaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1861, 13, 'Guaraciama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1862, 13, 'Guaransia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1863, 13, 'Guarani');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1864, 13, 'Guarar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1865, 13, 'Guarda-Mor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1866, 13, 'Guaxup');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1867, 13, 'Guidoval');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1868, 13, 'Guimarnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1869, 13, 'Guiricema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1870, 13, 'Gurinhat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1871, 13, 'Heliodora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1872, 13, 'Iapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1873, 13, 'Ibertioga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1874, 13, 'Ibi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1875, 13, 'Ibia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1876, 13, 'Ibiracatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1877, 13, 'Ibiraci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1878, 13, 'Ibirit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1879, 13, 'Ibitira de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1880, 13, 'Ibituruna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1881, 13, 'Icara de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1882, 13, 'Igarap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1883, 13, 'Igaratinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1884, 13, 'Iguatama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1885, 13, 'Ijaci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1886, 13, 'Ilicnea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1887, 13, 'Imb de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1888, 13, 'Inconfidentes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1889, 13, 'Indaiabira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1890, 13, 'Indianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1891, 13, 'Inga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1892, 13, 'Inhapim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1893, 13, 'Inhama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1894, 13, 'Inimutaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1895, 13, 'Ipaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1896, 13, 'Ipanema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1897, 13, 'Ipatinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1898, 13, 'Ipiau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1899, 13, 'Ipuina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1900, 13, 'Ira de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1901, 13, 'Itabira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1902, 13, 'Itabirinha de Mantena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1903, 13, 'Itabirito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1904, 13, 'Itacambira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1905, 13, 'Itacarambi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1906, 13, 'Itaguara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1907, 13, 'Itaip');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1908, 13, 'Itajub');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1909, 13, 'Itamarandiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1910, 13, 'Itamarati de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1911, 13, 'Itambacuri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1912, 13, 'Itamb do Mato Dentro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1913, 13, 'Itamogi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1914, 13, 'Itamonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1915, 13, 'Itanhandu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1916, 13, 'Itanhomi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1917, 13, 'Itaobim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1918, 13, 'Itapagipe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1919, 13, 'Itapecerica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1920, 13, 'Itapeva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1921, 13, 'Itatiaiuu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1922, 13, 'Ita de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1923, 13, 'Itana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1924, 13, 'Itaverava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1925, 13, 'Itinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1926, 13, 'Itueta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1927, 13, 'Ituiutaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1928, 13, 'Itumirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1929, 13, 'Iturama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1930, 13, 'Itutinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1931, 13, 'Jaboticatubas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1932, 13, 'Jacinto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1933, 13, 'Jacu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1934, 13, 'Jacutinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1935, 13, 'Jaguarau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1936, 13, 'Jaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1937, 13, 'Jampruca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1938, 13, 'Janaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1939, 13, 'Januria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1940, 13, 'Japaraba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1941, 13, 'Japonvar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1942, 13, 'Jeceaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1943, 13, 'Jenipapo de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1944, 13, 'Jequeri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1945, 13, 'Jequita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1946, 13, 'Jequitib');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1947, 13, 'Jequitinhonha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1948, 13, 'Jesunia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1949, 13, 'Joama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1950, 13, 'Joansia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1951, 13, 'Joo Monlevade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1952, 13, 'Joo Pinheiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1953, 13, 'Joaquim Felcio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1954, 13, 'Jordnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1955, 13, 'Jos Gonalves de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1956, 13, 'Jos Raydan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1957, 13, 'Josenpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1958, 13, 'Juatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1959, 13, 'Juiz de Fora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1960, 13, 'Juramento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1961, 13, 'Juruaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1962, 13, 'Juvenlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1963, 13, 'Ladainha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1964, 13, 'Lagamar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1965, 13, 'Lagoa da Prata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1966, 13, 'Lagoa dos Patos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1967, 13, 'Lagoa Dourada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1968, 13, 'Lagoa Formosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1969, 13, 'Lagoa Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1970, 13, 'Lagoa Santa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1971, 13, 'Lajinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1972, 13, 'Lambari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1973, 13, 'Lamim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1974, 13, 'Laranjal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1975, 13, 'Lassance');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1976, 13, 'Lavras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1977, 13, 'Leandro Ferreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1978, 13, 'Leme do Prado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1979, 13, 'Leopoldina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1980, 13, 'Liberdade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1981, 13, 'Lima Duarte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1982, 13, 'Limeira do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1983, 13, 'Lontra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1984, 13, 'Luisburgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1985, 13, 'Luislndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1986, 13, 'Luminrias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1987, 13, 'Luz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1988, 13, 'Machacalis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1989, 13, 'Machado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1990, 13, 'Madre de Deus de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1991, 13, 'Malacacheta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1992, 13, 'Mamonas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1993, 13, 'Manga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1994, 13, 'Manhuau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1995, 13, 'Manhumirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1996, 13, 'Mantena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1997, 13, 'Mar de Espanha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1998, 13, 'Maravilhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (1999, 13, 'Maria da F');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2000, 13, 'Mariana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2001, 13, 'Marilac');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2002, 13, 'Mrio Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2003, 13, 'Marip de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2004, 13, 'Marliria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2005, 13, 'Marmelpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2006, 13, 'Martinho Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2007, 13, 'Martins Soares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2008, 13, 'Mata Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2009, 13, 'Materlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2010, 13, 'Mateus Leme');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2011, 13, 'Mathias Lobato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2012, 13, 'Matias Barbosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2013, 13, 'Matias Cardoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2014, 13, 'Matip');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2015, 13, 'Mato Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2016, 13, 'Matozinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2017, 13, 'Matutina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2018, 13, 'Medeiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2019, 13, 'Medina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2020, 13, 'Mendes Pimentel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2021, 13, 'Mercs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2022, 13, 'Mesquita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2023, 13, 'Minas Novas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2024, 13, 'Minduri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2025, 13, 'Mirabela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2026, 13, 'Miradouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2027, 13, 'Mira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2028, 13, 'Miravnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2029, 13, 'Moeda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2030, 13, 'Moema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2031, 13, 'Monjolos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2032, 13, 'Monsenhor Paulo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2033, 13, 'Montalvnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2034, 13, 'Monte Alegre de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2035, 13, 'Monte Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2036, 13, 'Monte Belo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2037, 13, 'Monte Carmelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2038, 13, 'Monte Formoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2039, 13, 'Monte Santo de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2040, 13, 'Monte Sio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2041, 13, 'Montes Claros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2042, 13, 'Montezuma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2043, 13, 'Morada Nova de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2044, 13, 'Morro da Gara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2045, 13, 'Morro do Pilar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2046, 13, 'Munhoz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2047, 13, 'Muria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2048, 13, 'Mutum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2049, 13, 'Muzambinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2050, 13, 'Nacip Raydan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2051, 13, 'Nanuque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2052, 13, 'Naque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2053, 13, 'Natalndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2054, 13, 'Natrcia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2055, 13, 'Nazareno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2056, 13, 'Nepomuceno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2057, 13, 'Ninheira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2058, 13, 'Nova Belm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2059, 13, 'Nova Era');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2060, 13, 'Nova Lima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2061, 13, 'Nova Mdica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2062, 13, 'Nova Ponte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2063, 13, 'Nova Porteirinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2064, 13, 'Nova Resende');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2065, 13, 'Nova Serrana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2066, 13, 'Nova Unio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2067, 13, 'Novo Cruzeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2068, 13, 'Novo Oriente de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2069, 13, 'Novorizonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2070, 13, 'Olaria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2071, 13, 'Olhos-d`gua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2072, 13, 'Olmpio Noronha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2073, 13, 'Oliveira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2074, 13, 'Oliveira Fortes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2075, 13, 'Ona de Pitangui');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2076, 13, 'Oratrios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2077, 13, 'Oriznia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2078, 13, 'Ouro Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2079, 13, 'Ouro Fino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2080, 13, 'Ouro Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2081, 13, 'Ouro Verde de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2082, 13, 'Padre Carvalho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2083, 13, 'Padre Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2084, 13, 'Pai Pedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2085, 13, 'Paineiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2086, 13, 'Pains');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2087, 13, 'Paiva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2088, 13, 'Palma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2089, 13, 'Palmpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2090, 13, 'Papagaios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2091, 13, 'Par de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2092, 13, 'Paracatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2093, 13, 'Paraguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2094, 13, 'Paraispolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2095, 13, 'Paraopeba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2096, 13, 'Passa Quatro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2097, 13, 'Passa Tempo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2098, 13, 'Passa-Vinte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2099, 13, 'Passabm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2100, 13, 'Passos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2101, 13, 'Patis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2102, 13, 'Patos de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2103, 13, 'Patrocnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2104, 13, 'Patrocnio do Muria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2105, 13, 'Paula Cndido');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2106, 13, 'Paulistas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2107, 13, 'Pavo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2108, 13, 'Peanha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2109, 13, 'Pedra Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2110, 13, 'Pedra Bonita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2111, 13, 'Pedra do Anta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2112, 13, 'Pedra do Indai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2113, 13, 'Pedra Dourada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2114, 13, 'Pedralva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2115, 13, 'Pedras de Maria da Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2116, 13, 'Pedrinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2117, 13, 'Pedro Leopoldo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2118, 13, 'Pedro Teixeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2119, 13, 'Pequeri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2120, 13, 'Pequi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2121, 13, 'Perdigo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2122, 13, 'Perdizes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2123, 13, 'Perdes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2124, 13, 'Periquito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2125, 13, 'Pescador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2126, 13, 'Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2127, 13, 'Piedade de Caratinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2128, 13, 'Piedade de Ponte Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2129, 13, 'Piedade do Rio Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2130, 13, 'Piedade dos Gerais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2131, 13, 'Pimenta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2132, 13, 'Pingo-d`gua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2133, 13, 'Pintpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2134, 13, 'Piracema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2135, 13, 'Pirajuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2136, 13, 'Piranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2137, 13, 'Piranguu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2138, 13, 'Piranguinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2139, 13, 'Pirapetinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2140, 13, 'Pirapora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2141, 13, 'Piraba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2142, 13, 'Pitangui');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2143, 13, 'Piumhi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2144, 13, 'Planura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2145, 13, 'Poo Fundo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2146, 13, 'Poos de Caldas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2147, 13, 'Pocrane');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2148, 13, 'Pompu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2149, 13, 'Ponte Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2150, 13, 'Ponto Chique');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2151, 13, 'Ponto dos Volantes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2152, 13, 'Porteirinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2153, 13, 'Porto Firme');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2154, 13, 'Pot');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2155, 13, 'Pouso Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2156, 13, 'Pouso Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2157, 13, 'Prados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2158, 13, 'Prata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2159, 13, 'Pratpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2160, 13, 'Pratinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2161, 13, 'Presidente Bernardes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2162, 13, 'Presidente Juscelino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2163, 13, 'Presidente Kubitschek');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2164, 13, 'Presidente Olegrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2165, 13, 'Prudente de Morais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2166, 13, 'Quartel Geral');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2167, 13, 'Queluzito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2168, 13, 'Raposos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2169, 13, 'Raul Soares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2170, 13, 'Recreio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2171, 13, 'Reduto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2172, 13, 'Resende Costa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2173, 13, 'Resplendor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2174, 13, 'Ressaquinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2175, 13, 'Riachinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2176, 13, 'Riacho dos Machados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2177, 13, 'Ribeiro das Neves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2178, 13, 'Ribeiro Vermelho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2179, 13, 'Rio Acima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2180, 13, 'Rio Casca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2181, 13, 'Rio do Prado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2182, 13, 'Rio Doce');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2183, 13, 'Rio Espera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2184, 13, 'Rio Manso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2185, 13, 'Rio Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2186, 13, 'Rio Paranaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2187, 13, 'Rio Pardo de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2188, 13, 'Rio Piracicaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2189, 13, 'Rio Pomba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2190, 13, 'Rio Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2191, 13, 'Rio Vermelho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2192, 13, 'Ritpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2193, 13, 'Rochedo de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2194, 13, 'Rodeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2195, 13, 'Romaria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2196, 13, 'Rosrio da Limeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2197, 13, 'Rubelita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2198, 13, 'Rubim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2199, 13, 'Sabar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2200, 13, 'Sabinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2201, 13, 'Sacramento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2202, 13, 'Salinas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2203, 13, 'Salto da Divisa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2204, 13, 'Santa Brbara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2205, 13, 'Santa Brbara do Leste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2206, 13, 'Santa Brbara do Monte Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2207, 13, 'Santa Brbara do Tugrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2208, 13, 'Santa Cruz de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2209, 13, 'Santa Cruz de Salinas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2210, 13, 'Santa Cruz do Escalvado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2211, 13, 'Santa Efignia de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2212, 13, 'Santa F de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2213, 13, 'Santa Helena de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2214, 13, 'Santa Juliana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2215, 13, 'Santa Luzia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2216, 13, 'Santa Margarida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2217, 13, 'Santa Maria de Itabira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2218, 13, 'Santa Maria do Salto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2219, 13, 'Santa Maria do Suau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2220, 13, 'Santa Rita de Caldas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2221, 13, 'Santa Rita de Ibitipoca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2222, 13, 'Santa Rita de Jacutinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2223, 13, 'Santa Rita de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2224, 13, 'Santa Rita do Itueto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2225, 13, 'Santa Rita do Sapuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2226, 13, 'Santa Rosa da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2227, 13, 'Santa Vitria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2228, 13, 'Santana da Vargem');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2229, 13, 'Santana de Cataguases');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2230, 13, 'Santana de Pirapama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2231, 13, 'Santana do Deserto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2232, 13, 'Santana do Garambu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2233, 13, 'Santana do Jacar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2234, 13, 'Santana do Manhuau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2235, 13, 'Santana do Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2236, 13, 'Santana do Riacho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2237, 13, 'Santana dos Montes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2238, 13, 'Santo Antnio do Amparo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2239, 13, 'Santo Antnio do Aventureiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2240, 13, 'Santo Antnio do Grama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2241, 13, 'Santo Antnio do Itamb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2242, 13, 'Santo Antnio do Jacinto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2243, 13, 'Santo Antnio do Monte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2244, 13, 'Santo Antnio do Retiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2245, 13, 'Santo Antnio do Rio Abaixo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2246, 13, 'Santo Hiplito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2247, 13, 'Santos Dumont');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2248, 13, 'So Bento Abade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2249, 13, 'So Brs do Suau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2250, 13, 'So Domingos das Dores');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2251, 13, 'So Domingos do Prata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2252, 13, 'So Flix de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2253, 13, 'So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2254, 13, 'So Francisco de Paula');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2255, 13, 'So Francisco de Sales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2256, 13, 'So Francisco do Glria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2257, 13, 'So Geraldo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2258, 13, 'So Geraldo da Piedade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2259, 13, 'So Geraldo do Baixio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2260, 13, 'So Gonalo do Abaet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2261, 13, 'So Gonalo do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2262, 13, 'So Gonalo do Rio Abaixo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2263, 13, 'So Gonalo do Rio Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2264, 13, 'So Gonalo do Sapuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2265, 13, 'So Gotardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2266, 13, 'So Joo Batista do Glria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2267, 13, 'So Joo da Lagoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2268, 13, 'So Joo da Mata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2269, 13, 'So Joo da Ponte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2270, 13, 'So Joo das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2271, 13, 'So Joo del Rei');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2272, 13, 'So Joo do Manhuau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2273, 13, 'So Joo do Manteninha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2274, 13, 'So Joo do Oriente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2275, 13, 'So Joo do Pacu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2276, 13, 'So Joo do Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2277, 13, 'So Joo Evangelista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2278, 13, 'So Joo Nepomuceno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2279, 13, 'So Joaquim de Bicas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2280, 13, 'So Jos da Barra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2281, 13, 'So Jos da Lapa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2282, 13, 'So Jos da Safira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2283, 13, 'So Jos da Varginha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2284, 13, 'So Jos do Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2285, 13, 'So Jos do Divino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2286, 13, 'So Jos do Goiabal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2287, 13, 'So Jos do Jacuri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2288, 13, 'So Jos do Mantimento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2289, 13, 'So Loureno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2290, 13, 'So Miguel do Anta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2291, 13, 'So Pedro da Unio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2292, 13, 'So Pedro do Suau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2293, 13, 'So Pedro dos Ferros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2294, 13, 'So Romo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2295, 13, 'So Roque de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2296, 13, 'So Sebastio da Bela Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2297, 13, 'So Sebastio da Vargem Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2298, 13, 'So Sebastio do Anta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2299, 13, 'So Sebastio do Maranho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2300, 13, 'So Sebastio do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2301, 13, 'So Sebastio do Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2302, 13, 'So Sebastio do Rio Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2303, 13, 'So Sebastio do Rio Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2304, 13, 'So Thom das Letras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2305, 13, 'So Tiago');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2306, 13, 'So Toms de Aquino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2307, 13, 'So Vicente de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2308, 13, 'Sapuca-Mirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2309, 13, 'Sardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2310, 13, 'Sarzedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2311, 13, 'Sem-Peixe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2312, 13, 'Senador Amaral');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2313, 13, 'Senador Cortes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2314, 13, 'Senador Firmino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2315, 13, 'Senador Jos Bento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2316, 13, 'Senador Modestino Gonalves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2317, 13, 'Senhora de Oliveira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2318, 13, 'Senhora do Porto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2319, 13, 'Senhora dos Remdios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2320, 13, 'Sericita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2321, 13, 'Seritinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2322, 13, 'Serra Azul de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2323, 13, 'Serra da Saudade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2324, 13, 'Serra do Salitre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2325, 13, 'Serra dos Aimors');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2326, 13, 'Serrania');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2327, 13, 'Serranpolis de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2328, 13, 'Serranos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2329, 13, 'Serro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2330, 13, 'Sete Lagoas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2331, 13, 'Setubinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2332, 13, 'Silveirnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2333, 13, 'Silvianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2334, 13, 'Simo Pereira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2335, 13, 'Simonsia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2336, 13, 'Sobrlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2337, 13, 'Soledade de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2338, 13, 'Tabuleiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2339, 13, 'Taiobeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2340, 13, 'Taparuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2341, 13, 'Tapira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2342, 13, 'Tapira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2343, 13, 'Taquarau de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2344, 13, 'Tarumirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2345, 13, 'Teixeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2346, 13, 'Tefilo Otoni');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2347, 13, 'Timteo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2348, 13, 'Tiradentes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2349, 13, 'Tiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2350, 13, 'Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2351, 13, 'Tocos do Moji');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2352, 13, 'Toledo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2353, 13, 'Tombos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2354, 13, 'Trs Coraes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2355, 13, 'Trs Marias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2356, 13, 'Trs Pontas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2357, 13, 'Tumiritinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2358, 13, 'Tupaciguara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2359, 13, 'Turmalina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2360, 13, 'Turvolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2361, 13, 'Ub');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2362, 13, 'Uba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2363, 13, 'Ubaporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2364, 13, 'Uberaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2365, 13, 'Uberlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2366, 13, 'Umburatiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2367, 13, 'Una');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2368, 13, 'Unio de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2369, 13, 'Uruana de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2370, 13, 'Urucnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2371, 13, 'Urucuia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2372, 13, 'Vargem Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2373, 13, 'Vargem Bonita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2374, 13, 'Vargem Grande do Rio Pardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2375, 13, 'Varginha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2376, 13, 'Varjo de Minas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2377, 13, 'Vrzea da Palma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2378, 13, 'Varzelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2379, 13, 'Vazante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2380, 13, 'Verdelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2381, 13, 'Veredinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2382, 13, 'Verssimo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2383, 13, 'Vermelho Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2384, 13, 'Vespasiano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2385, 13, 'Viosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2386, 13, 'Vieiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2387, 13, 'Virgem da Lapa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2388, 13, 'Virgnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2389, 13, 'Virginpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2390, 13, 'Virgolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2391, 13, 'Visconde do Rio Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2392, 13, 'Volta Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2393, 13, 'Wenceslau Braz');


/* ******************************** P a r  ********************************* */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2394, 14, 'Abaetetuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2395, 14, 'Abel Figueiredo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2396, 14, 'Acar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2397, 14, 'Afu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2398, 14, 'gua Azul do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2399, 14, 'Alenquer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2400, 14, 'Almeirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2401, 14, 'Altamira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2402, 14, 'Anajs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2403, 14, 'Ananindeua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2404, 14, 'Anapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2405, 14, 'Augusto Corra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2406, 14, 'Aurora do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2407, 14, 'Aveiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2408, 14, 'Bagre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2409, 14, 'Baio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2410, 14, 'Bannach');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2411, 14, 'Barcarena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2412, 14, 'Belm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2413, 14, 'Belterra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2414, 14, 'Benevides');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2415, 14, 'Bom Jesus do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2416, 14, 'Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2417, 14, 'Bragana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2418, 14, 'Brasil Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2419, 14, 'Brejo Grande do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2420, 14, 'Breu Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2421, 14, 'Breves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2422, 14, 'Bujaru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2423, 14, 'Cachoeira do Arari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2424, 14, 'Cachoeira do Piri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2425, 14, 'Camet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2426, 14, 'Cana dos Carajs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2427, 14, 'Capanema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2428, 14, 'Capito Poo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2429, 14, 'Castanhal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2430, 14, 'Chaves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2431, 14, 'Colares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2432, 14, 'Conceio do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2433, 14, 'Concrdia do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2434, 14, 'Cumaru do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2435, 14, 'Curionpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2436, 14, 'Curralinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2437, 14, 'Curu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2438, 14, 'Curu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2439, 14, 'Dom Eliseu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2440, 14, 'Eldorado dos Carajs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2441, 14, 'Faro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2442, 14, 'Floresta do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2443, 14, 'Garrafo do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2444, 14, 'Goiansia do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2445, 14, 'Gurup');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2446, 14, 'Igarap-Au');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2447, 14, 'Igarap-Miri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2448, 14, 'Inhangapi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2449, 14, 'Ipixuna do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2450, 14, 'Irituia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2451, 14, 'Itaituba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2452, 14, 'Itupiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2453, 14, 'Jacareacanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2454, 14, 'Jacund');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2455, 14, 'Juruti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2456, 14, 'Limoeiro do Ajuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2457, 14, 'Me do Rio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2458, 14, 'Magalhes Barata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2459, 14, 'Marab');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2460, 14, 'Maracan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2461, 14, 'Marapanim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2462, 14, 'Marituba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2463, 14, 'Medicilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2464, 14, 'Melgao');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2465, 14, 'Mocajuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2466, 14, 'Moju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2467, 14, 'Monte Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2468, 14, 'Muan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2469, 14, 'Nova Esperana do Piri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2470, 14, 'Nova Ipixuna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2471, 14, 'Nova Timboteua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2472, 14, 'Novo Progresso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2473, 14, 'Novo Repartimento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2474, 14, 'bidos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2475, 14, 'Oeiras do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2476, 14, 'Oriximin');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2477, 14, 'Ourm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2478, 14, 'Ourilndia do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2479, 14, 'Pacaj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2480, 14, 'Palestina do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2481, 14, 'Paragominas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2482, 14, 'Parauapebas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2483, 14, 'Pau d`Arco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2484, 14, 'Peixe-Boi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2485, 14, 'Piarra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2486, 14, 'Placas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2487, 14, 'Ponta de Pedras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2488, 14, 'Portel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2489, 14, 'Porto de Moz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2490, 14, 'Prainha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2491, 14, 'Primavera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2492, 14, 'Quatipuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2493, 14, 'Redeno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2494, 14, 'Rio Maria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2495, 14, 'Rondon do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2496, 14, 'Rurpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2497, 14, 'Salinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2498, 14, 'Salvaterra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2499, 14, 'Santa Brbara do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2500, 14, 'Santa Cruz do Arari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2501, 14, 'Santa Isabel do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2502, 14, 'Santa Luzia do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2503, 14, 'Santa Maria das Barreiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2504, 14, 'Santa Maria do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2505, 14, 'Santana do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2506, 14, 'Santarm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2507, 14, 'Santarm Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2508, 14, 'Santo Antnio do Tau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2509, 14, 'So Caetano de Odivelas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2510, 14, 'So Domingos do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2511, 14, 'So Domingos do Capim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2512, 14, 'So Flix do Xingu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2513, 14, 'So Francisco do Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2514, 14, 'So Geraldo do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2515, 14, 'So Joo da Ponta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2516, 14, 'So Joo de Pirabas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2517, 14, 'So Joo do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2518, 14, 'So Miguel do Guam');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2519, 14, 'So Sebastio da Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2520, 14, 'Sapucaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2521, 14, 'Senador Jos Porfrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2522, 14, 'Soure');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2523, 14, 'Tailndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2524, 14, 'Terra Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2525, 14, 'Terra Santa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2526, 14, 'Tom-Au');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2527, 14, 'Tracuateua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2528, 14, 'Trairo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2529, 14, 'Tucum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2530, 14, 'Tucuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2531, 14, 'Ulianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2532, 14, 'Uruar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2533, 14, 'Vigia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2534, 14, 'Viseu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2535, 14, 'Vitria do Xingu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2536, 14, 'Xinguara');


/* ***************************** P a r a  b a ****************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2537, 15, 'gua Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2538, 15, 'Aguiar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2539, 15, 'Alagoa Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2540, 15, 'Alagoa Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2541, 15, 'Alagoinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2542, 15, 'Alcantil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2543, 15, 'Algodo de Jandara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2544, 15, 'Alhandra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2545, 15, 'Amparo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2546, 15, 'Aparecida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2547, 15, 'Araagi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2548, 15, 'Arara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2549, 15, 'Araruna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2550, 15, 'Areia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2551, 15, 'Areia de Baranas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2552, 15, 'Areial');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2553, 15, 'Aroeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2554, 15, 'Assuno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2555, 15, 'Baa da Traio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2556, 15, 'Bananeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2557, 15, 'Barana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2558, 15, 'Barra de Santa Rosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2559, 15, 'Barra de Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2560, 15, 'Barra de So Miguel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2561, 15, 'Bayeux');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2562, 15, 'Belm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2563, 15, 'Belm do Brejo do Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2564, 15, 'Bernardino Batista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2565, 15, 'Boa Ventura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2566, 15, 'Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2567, 15, 'Bom Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2568, 15, 'Bom Sucesso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2569, 15, 'Bonito de Santa F');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2570, 15, 'Boqueiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2571, 15, 'Borborema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2572, 15, 'Brejo do Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2573, 15, 'Brejo dos Santos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2574, 15, 'Caapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2575, 15, 'Cabaceiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2576, 15, 'Cabedelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2577, 15, 'Cachoeira dos ndios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2578, 15, 'Cacimba de Areia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2579, 15, 'Cacimba de Dentro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2580, 15, 'Cacimbas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2581, 15, 'Caiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2582, 15, 'Cajazeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2583, 15, 'Cajazeirinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2584, 15, 'Caldas Brando');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2585, 15, 'Camala');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2586, 15, 'Campina Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2587, 15, 'Campo de Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2588, 15, 'Capim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2589, 15, 'Carabas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2590, 15, 'Carrapateira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2591, 15, 'Casserengue');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2592, 15, 'Catingueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2593, 15, 'Catol do Rocha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2594, 15, 'Caturit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2595, 15, 'Conceio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2596, 15, 'Condado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2597, 15, 'Conde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2598, 15, 'Congo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2599, 15, 'Coremas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2600, 15, 'Coxixola');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2601, 15, 'Cruz do Esprito Santo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2602, 15, 'Cubati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2603, 15, 'Cuit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2604, 15, 'Cuit de Mamanguape');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2605, 15, 'Cuitegi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2606, 15, 'Curral de Cima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2607, 15, 'Curral Velho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2608, 15, 'Damio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2609, 15, 'Desterro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2610, 15, 'Diamante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2611, 15, 'Dona Ins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2612, 15, 'Duas Estradas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2613, 15, 'Emas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2614, 15, 'Esperana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2615, 15, 'Fagundes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2616, 15, 'Frei Martinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2617, 15, 'Gado Bravo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2618, 15, 'Guarabira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2619, 15, 'Gurinhm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2620, 15, 'Gurjo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2621, 15, 'Ibiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2622, 15, 'Igaracy');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2623, 15, 'Imaculada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2624, 15, 'Ing');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2625, 15, 'Itabaiana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2626, 15, 'Itaporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2627, 15, 'Itapororoca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2628, 15, 'Itatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2629, 15, 'Jacara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2630, 15, 'Jeric');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2631, 15, 'Joo Pessoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2632, 15, 'Juarez Tvora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2633, 15, 'Juazeirinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2634, 15, 'Junco do Serid');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2635, 15, 'Juripiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2636, 15, 'Juru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2637, 15, 'Lagoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2638, 15, 'Lagoa de Dentro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2639, 15, 'Lagoa Seca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2640, 15, 'Lastro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2641, 15, 'Livramento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2642, 15, 'Logradouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2643, 15, 'Lucena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2644, 15, 'Me d`gua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2645, 15, 'Malta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2646, 15, 'Mamanguape');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2647, 15, 'Manara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2648, 15, 'Marcao');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2649, 15, 'Mari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2650, 15, 'Marizpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2651, 15, 'Massaranduba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2652, 15, 'Mataraca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2653, 15, 'Matinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2654, 15, 'Mato Grosso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2655, 15, 'Maturia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2656, 15, 'Mogeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2657, 15, 'Montadas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2658, 15, 'Monte Horebe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2659, 15, 'Monteiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2660, 15, 'Mulungu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2661, 15, 'Natuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2662, 15, 'Nazarezinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2663, 15, 'Nova Floresta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2664, 15, 'Nova Olinda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2665, 15, 'Nova Palmeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2666, 15, 'Olho d`gua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2667, 15, 'Olivedos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2668, 15, 'Ouro Velho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2669, 15, 'Parari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2670, 15, 'Passagem');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2671, 15, 'Patos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2672, 15, 'Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2673, 15, 'Pedra Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2674, 15, 'Pedra Lavrada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2675, 15, 'Pedras de Fogo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2676, 15, 'Pedro Rgis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2677, 15, 'Pianc');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2678, 15, 'Picu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2679, 15, 'Pilar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2680, 15, 'Piles');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2681, 15, 'Pilezinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2682, 15, 'Pirpirituba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2683, 15, 'Pitimbu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2684, 15, 'Pocinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2685, 15, 'Poo Dantas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2686, 15, 'Poo de Jos de Moura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2687, 15, 'Pombal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2688, 15, 'Prata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2689, 15, 'Princesa Isabel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2690, 15, 'Puxinan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2691, 15, 'Queimadas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2692, 15, 'Quixab');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2693, 15, 'Remgio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2694, 15, 'Riacho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2695, 15, 'Riacho do Bacamarte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2696, 15, 'Riacho do Poo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2697, 15, 'Riacho de Santo Antnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2698, 15, 'Riacho dos Cavalos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2699, 15, 'Rio Tinto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2700, 15, 'Salgadinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2701, 15, 'Salgado de So Flix');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2702, 15, 'Santa Ceclia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2703, 15, 'Santa Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2704, 15, 'Santa Helena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2705, 15, 'Santa Ins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2706, 15, 'Santa Luzia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2707, 15, 'Santa Rita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2708, 15, 'Santa Teresinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2709, 15, 'Santana de Mangueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2710, 15, 'Santana dos Garrotes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2711, 15, 'Santarm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2712, 15, 'Santo Andr');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2713, 15, 'So Bentinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2714, 15, 'So Bento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2715, 15, 'So Domingos de Pombal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2716, 15, 'So Domingos do Cariri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2717, 15, 'So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2718, 15, 'So Joo do Cariri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2719, 15, 'So Joo do Rio do Peixe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2720, 15, 'So Joo do Tigre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2721, 15, 'So Jos da Lagoa Tapada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2722, 15, 'So Jos de Caiana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2723, 15, 'So Jos de Espinharas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2724, 15, 'So Jos de Piranhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2725, 15, 'So Jos de Princesa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2726, 15, 'So Jos do Bonfim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2727, 15, 'So Jos do Brejo do Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2728, 15, 'So Jos do Sabugi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2729, 15, 'So Jos dos Cordeiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2730, 15, 'So Jos dos Ramos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2731, 15, 'So Mamede');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2732, 15, 'So Miguel de Taipu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2733, 15, 'So Sebastio de Lagoa de Roa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2734, 15, 'So Sebastio do Umbuzeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2735, 15, 'Sap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2736, 15, 'Serid');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2737, 15, 'Serra Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2738, 15, 'Serra da Raiz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2739, 15, 'Serra Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2740, 15, 'Serra Redonda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2741, 15, 'Serraria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2742, 15, 'Sertozinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2743, 15, 'Sobrado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2744, 15, 'Solnea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2745, 15, 'Soledade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2746, 15, 'Sossgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2747, 15, 'Sousa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2748, 15, 'Sum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2749, 15, 'Tapero');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2750, 15, 'Tavares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2751, 15, 'Teixeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2752, 15, 'Tenrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2753, 15, 'Triunfo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2754, 15, 'Uirana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2755, 15, 'Umbuzeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2756, 15, 'Vrzea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2757, 15, 'Vieirpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2758, 15, 'Vista Serrana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2759, 15, 'Zabel');


/* ****************************** P a r a n  ******************************* */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2760, 16, 'Abati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2761, 16, 'Adrianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2762, 16, 'Agudos do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2763, 16, 'Almirante Tamandar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2764, 16, 'Altamira do Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2765, 16, 'Alto Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2766, 16, 'Alto Piquiri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2767, 16, 'Altnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2768, 16, 'Alvorada do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2769, 16, 'Amapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2770, 16, 'Ampre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2771, 16, 'Anahy');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2772, 16, 'Andir');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2773, 16, 'ngulo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2774, 16, 'Antonina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2775, 16, 'Antnio Olinto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2776, 16, 'Apucarana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2777, 16, 'Arapongas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2778, 16, 'Arapoti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2779, 16, 'Arapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2780, 16, 'Araruna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2781, 16, 'Araucria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2782, 16, 'Ariranha do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2783, 16, 'Assa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2784, 16, 'Assis Chateaubriand');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2785, 16, 'Astorga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2786, 16, 'Atalaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2787, 16, 'Balsa Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2788, 16, 'Bandeirantes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2789, 16, 'Barbosa Ferraz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2790, 16, 'Barra do Jacar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2791, 16, 'Barraco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2792, 16, 'Bela Vista da Caroba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2793, 16, 'Bela Vista do Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2794, 16, 'Bituruna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2795, 16, 'Boa Esperana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2796, 16, 'Boa Esperana do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2797, 16, 'Boa Ventura de So Roque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2798, 16, 'Boa Vista da Aparecida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2799, 16, 'Bocaiva do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2800, 16, 'Bom Jesus do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2801, 16, 'Bom Sucesso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2802, 16, 'Bom Sucesso do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2803, 16, 'Borrazpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2804, 16, 'Braganey');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2805, 16, 'Brasilndia do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2806, 16, 'Cafeara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2807, 16, 'Cafelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2808, 16, 'Cafezal do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2809, 16, 'Califrnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2810, 16, 'Cambar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2811, 16, 'Camb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2812, 16, 'Cambira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2813, 16, 'Campina da Lagoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2814, 16, 'Campina do Simo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2815, 16, 'Campina Grande do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2816, 16, 'Campo Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2817, 16, 'Campo do Tenente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2818, 16, 'Campo Largo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2819, 16, 'Campo Magro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2820, 16, 'Campo Mouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2821, 16, 'Cndido de Abreu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2822, 16, 'Candi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2823, 16, 'Cantagalo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2824, 16, 'Capanema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2825, 16, 'Capito Lenidas Marques');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2826, 16, 'Carambe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2827, 16, 'Carlpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2828, 16, 'Cascavel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2829, 16, 'Castro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2830, 16, 'Catanduvas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2831, 16, 'Centenrio do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2832, 16, 'Cerro Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2833, 16, 'Cu Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2834, 16, 'Chopinzinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2835, 16, 'Cianorte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2836, 16, 'city Gacha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2837, 16, 'Clevelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2838, 16, 'Colombo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2839, 16, 'Colorado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2840, 16, 'Congonhinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2841, 16, 'Conselheiro Mairinck');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2842, 16, 'Contenda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2843, 16, 'Corblia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2844, 16, 'Cornlio Procpio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2845, 16, 'Coronel Domingos Soares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2846, 16, 'Coronel Vivida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2847, 16, 'Corumbata do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2848, 16, 'Cruz Machado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2849, 16, 'Cruzeiro do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2850, 16, 'Cruzeiro do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2851, 16, 'Cruzeiro do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2852, 16, 'Cruzmaltina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2853, 16, 'Curitiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2854, 16, 'Curiva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2855, 16, 'Diamante d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2856, 16, 'Diamante do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2857, 16, 'Diamante do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2858, 16, 'Dois Vizinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2859, 16, 'Douradina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2860, 16, 'Doutor Camargo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2861, 16, 'Doutor Ulysses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2862, 16, 'Enas Marques');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2863, 16, 'Engenheiro Beltro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2864, 16, 'Entre Rios do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2865, 16, 'Esperana Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2866, 16, 'Espigo Alto do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2867, 16, 'Farol');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2868, 16, 'Faxinal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2869, 16, 'Fazenda Rio Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2870, 16, 'Fnix');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2871, 16, 'Fernandes Pinheiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2872, 16, 'Figueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2873, 16, 'Flor da Serra do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2874, 16, 'Flora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2875, 16, 'Floresta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2876, 16, 'Florestpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2877, 16, 'Flrida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2878, 16, 'Formosa do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2879, 16, 'Foz do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2880, 16, 'Foz do Jordo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2881, 16, 'Francisco Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2882, 16, 'Francisco Beltro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2883, 16, 'General Carneiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2884, 16, 'Godoy Moreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2885, 16, 'Goioer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2886, 16, 'Goioxim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2887, 16, 'Grandes Rios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2888, 16, 'Guara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2889, 16, 'Guaira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2890, 16, 'Guamiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2891, 16, 'Guapirama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2892, 16, 'Guaporema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2893, 16, 'Guaraci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2894, 16, 'Guaraniau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2895, 16, 'Guarapuava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2896, 16, 'Guaraqueaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2897, 16, 'Guaratuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2898, 16, 'Honrio Serpa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2899, 16, 'Ibaiti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2900, 16, 'Ibema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2901, 16, 'Ibipor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2902, 16, 'Icarama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2903, 16, 'Iguarau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2904, 16, 'Iguatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2905, 16, 'Imba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2906, 16, 'Imbituva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2907, 16, 'Incio Martins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2908, 16, 'Inaj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2909, 16, 'Indianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2910, 16, 'Ipiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2911, 16, 'Ipor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2912, 16, 'Iracema do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2913, 16, 'Irati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2914, 16, 'Iretama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2915, 16, 'Itaguaj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2916, 16, 'Itaipulndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2917, 16, 'Itambarac');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2918, 16, 'Itamb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2919, 16, 'Itapejara d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2920, 16, 'Itaperuu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2921, 16, 'Itana do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2922, 16, 'Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2923, 16, 'Ivaipor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2924, 16, 'Ivat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2925, 16, 'Ivatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2926, 16, 'Jaboti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2927, 16, 'Jacarezinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2928, 16, 'Jaguapit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2929, 16, 'Jaguariava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2930, 16, 'Jandaia do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2931, 16, 'Janipolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2932, 16, 'Japira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2933, 16, 'Japur');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2934, 16, 'Jardim Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2935, 16, 'Jardim Olinda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2936, 16, 'Jataizinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2937, 16, 'Jesutas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2938, 16, 'Joaquim Tvora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2939, 16, 'Jundia do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2940, 16, 'Juranda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2941, 16, 'Jussara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2942, 16, 'Kalor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2943, 16, 'Lapa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2944, 16, 'Laranjal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2945, 16, 'Laranjeiras do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2946, 16, 'Lepolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2947, 16, 'Lidianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2948, 16, 'Lindoeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2949, 16, 'Loanda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2950, 16, 'Lobato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2951, 16, 'Londrina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2952, 16, 'Luiziana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2953, 16, 'Lunardelli');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2954, 16, 'Lupionpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2955, 16, 'Mallet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2956, 16, 'Mambor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2957, 16, 'Mandaguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2958, 16, 'Mandaguari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2959, 16, 'Mandirituba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2960, 16, 'Manfrinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2961, 16, 'Mangueirinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2962, 16, 'Manoel Ribas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2963, 16, 'Marechal Cndido Rondon');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2964, 16, 'Maria Helena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2965, 16, 'Marialva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2966, 16, 'Marilndia do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2967, 16, 'Marilena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2968, 16, 'Mariluz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2969, 16, 'Maring');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2970, 16, 'Maripolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2971, 16, 'Marip');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2972, 16, 'Marmeleiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2973, 16, 'Marquinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2974, 16, 'Marumbi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2975, 16, 'Matelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2976, 16, 'Matinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2977, 16, 'Mato Rico');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2978, 16, 'Mau da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2979, 16, 'Medianeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2980, 16, 'Mercedes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2981, 16, 'Mirador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2982, 16, 'Miraselva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2983, 16, 'Missal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2984, 16, 'Moreira Sales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2985, 16, 'Morretes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2986, 16, 'Munhoz de Melo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2987, 16, 'Nossa Senhora das Graas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2988, 16, 'Nova Aliana do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2989, 16, 'Nova Amrica da Colina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2990, 16, 'Nova Aurora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2991, 16, 'Nova Cantu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2992, 16, 'Nova Esperana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2993, 16, 'Nova Esperana do Sudoeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2994, 16, 'Nova Ftima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2995, 16, 'Nova Laranjeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2996, 16, 'Nova Londrina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2997, 16, 'Nova Olmpia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2998, 16, 'Nova Prata do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (2999, 16, 'Nova Santa Brbara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3000, 16, 'Nova Santa Rosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3001, 16, 'Nova Tebas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3002, 16, 'Novo Itacolomi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3003, 16, 'Ortigueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3004, 16, 'Ourizona');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3005, 16, 'Ouro Verde do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3006, 16, 'Paiandu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3007, 16, 'Palmas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3008, 16, 'Palmeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3009, 16, 'Palmital');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3010, 16, 'Palotina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3011, 16, 'Paraso do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3012, 16, 'Paranacity');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3013, 16, 'Paranagu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3014, 16, 'Paranapoema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3015, 16, 'Paranava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3016, 16, 'Pato Bragado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3017, 16, 'Pato Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3018, 16, 'Paula Freitas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3019, 16, 'Paulo Frontin');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3020, 16, 'Peabiru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3021, 16, 'Perobal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3022, 16, 'Prola');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3023, 16, 'Prola d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3024, 16, 'Pin');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3025, 16, 'Pinhais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3026, 16, 'Pinhal de So Bento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3027, 16, 'Pinhalo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3028, 16, 'Pinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3029, 16, 'Pira do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3030, 16, 'Piraquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3031, 16, 'Pitanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3032, 16, 'Pitangueiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3033, 16, 'Planaltina do Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3034, 16, 'Planalto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3035, 16, 'Ponta Grossa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3036, 16, 'Pontal do Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3037, 16, 'Porecatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3038, 16, 'Porto Amazonas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3039, 16, 'Porto Barreiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3040, 16, 'Porto Rico');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3041, 16, 'Porto Vitria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3042, 16, 'Prado Ferreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3043, 16, 'Pranchita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3044, 16, 'Presidente Castelo Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3045, 16, 'Primeiro de Maio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3046, 16, 'Prudentpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3047, 16, 'Quarto Centenrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3048, 16, 'Quatigu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3049, 16, 'Quatro Barras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3050, 16, 'Quatro Pontes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3051, 16, 'Quedas do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3052, 16, 'Querncia do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3053, 16, 'Quinta do Sol');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3054, 16, 'Quitandinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3055, 16, 'Ramilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3056, 16, 'Rancho Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3057, 16, 'Rancho Alegre d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3058, 16, 'Realeza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3059, 16, 'Rebouas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3060, 16, 'Renascena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3061, 16, 'Reserva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3062, 16, 'Reserva do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3063, 16, 'Ribeiro Claro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3064, 16, 'Ribeiro do Pinhal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3065, 16, 'Rio Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3066, 16, 'Rio Bom');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3067, 16, 'Rio Bonito do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3068, 16, 'Rio Branco do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3069, 16, 'Rio Branco do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3070, 16, 'Rio Negro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3071, 16, 'Rolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3072, 16, 'Roncador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3073, 16, 'Rondon');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3074, 16, 'Rosrio do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3075, 16, 'Sabudia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3076, 16, 'Salgado Filho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3077, 16, 'Salto do Itarar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3078, 16, 'Salto do Lontra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3079, 16, 'Santa Amlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3080, 16, 'Santa Ceclia do Pavo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3081, 16, 'Santa Cruz de Monte Castelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3082, 16, 'Santa F');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3083, 16, 'Santa Helena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3084, 16, 'Santa Ins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3085, 16, 'Santa Isabel do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3086, 16, 'Santa Izabel do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3087, 16, 'Santa Lcia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3088, 16, 'Santa Maria do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3089, 16, 'Santa Mariana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3090, 16, 'Santa Mnica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3091, 16, 'Santa Tereza do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3092, 16, 'Santa Terezinha de Itaipu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3093, 16, 'Santana do Itarar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3094, 16, 'Santo Antnio da Platina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3095, 16, 'Santo Antnio do Caiu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3096, 16, 'Santo Antnio do Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3097, 16, 'Santo Antnio do Sudoeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3098, 16, 'Santo Incio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3099, 16, 'So Carlos do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3100, 16, 'So Jernimo da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3101, 16, 'So Joo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3102, 16, 'So Joo do Caiu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3103, 16, 'So Joo do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3104, 16, 'So Joo do Triunfo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3105, 16, 'So Jorge d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3106, 16, 'So Jorge do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3107, 16, 'So Jorge do Patrocnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3108, 16, 'So Jos da Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3109, 16, 'So Jos das Palmeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3110, 16, 'So Jos dos Pinhais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3111, 16, 'So Manoel do Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3112, 16, 'So Mateus do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3113, 16, 'So Miguel do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3114, 16, 'So Pedro do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3115, 16, 'So Pedro do Iva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3116, 16, 'So Pedro do Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3117, 16, 'So Sebastio da Amoreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3118, 16, 'So Tom');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3119, 16, 'Sapopema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3120, 16, 'Sarandi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3121, 16, 'Saudade do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3122, 16, 'Sengs');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3123, 16, 'Serranpolis do Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3124, 16, 'Sertaneja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3125, 16, 'Sertanpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3126, 16, 'Siqueira Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3127, 16, 'Sulina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3128, 16, 'Tamarana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3129, 16, 'Tamboara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3130, 16, 'Tapejara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3131, 16, 'Tapira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3132, 16, 'Teixeira Soares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3133, 16, 'Telmaco Borba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3134, 16, 'Terra Boa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3135, 16, 'Terra Rica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3136, 16, 'Terra Roxa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3137, 16, 'Tibagi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3138, 16, 'Tijucas do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3139, 16, 'Toledo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3140, 16, 'Tomazina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3141, 16, 'Trs Barras do Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3142, 16, 'Tunas do Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3143, 16, 'Tuneiras do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3144, 16, 'Tupssi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3145, 16, 'Turvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3146, 16, 'Ubirat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3147, 16, 'Umuarama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3148, 16, 'Unio da Vitria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3149, 16, 'Uniflor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3150, 16, 'Ura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3151, 16, 'Ventania');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3152, 16, 'Vera Cruz do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3153, 16, 'Ver');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3154, 16, 'Vila Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3155, 16, 'Virmond');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3156, 16, 'Vitorino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3157, 16, 'Wenceslau Braz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3158, 16, 'Xambr');


/* ************************** P e r n a m b u c o *************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3159, 17, 'Abreu e Lima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3160, 17, 'Afogados da Ingazeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3161, 17, 'Afrnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3162, 17, 'Agrestina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3163, 17, 'gua Preta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3164, 17, 'guas Belas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3165, 17, 'Alagoinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3166, 17, 'Aliana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3167, 17, 'Altinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3168, 17, 'Amaraji');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3169, 17, 'Angelim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3170, 17, 'Araoiaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3171, 17, 'Araripina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3172, 17, 'Arcoverde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3173, 17, 'Barra de Guabiraba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3174, 17, 'Barreiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3175, 17, 'Belm de Maria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3176, 17, 'Belm de So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3177, 17, 'Belo Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3178, 17, 'Betnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3179, 17, 'Bezerros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3180, 17, 'Bodoc');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3181, 17, 'Bom Conselho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3182, 17, 'Bom Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3183, 17, 'Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3184, 17, 'Brejo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3185, 17, 'Brejinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3186, 17, 'Brejo da Madre de Deus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3187, 17, 'Buenos Aires');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3188, 17, 'Buque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3189, 17, 'Cabo de Santo Agostinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3190, 17, 'Cabrob');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3191, 17, 'Cachoeirinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3192, 17, 'Caets');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3193, 17, 'Calado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3194, 17, 'Calumbi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3195, 17, 'Camaragibe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3196, 17, 'Camocim de So Flix');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3197, 17, 'Camutanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3198, 17, 'Canhotinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3199, 17, 'Capoeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3200, 17, 'Carnaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3201, 17, 'Carnaubeira da Penha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3202, 17, 'Carpina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3203, 17, 'Caruaru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3204, 17, 'Casinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3205, 17, 'Catende');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3206, 17, 'Cedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3207, 17, 'Ch de Alegria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3208, 17, 'Ch Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3209, 17, 'Condado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3210, 17, 'Correntes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3211, 17, 'Corts');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3212, 17, 'Cumaru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3213, 17, 'Cupira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3214, 17, 'Custdia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3215, 17, 'Dormentes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3216, 17, 'Escada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3217, 17, 'Exu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3218, 17, 'Feira Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3219, 17, 'Fernando de Noronha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3220, 17, 'Ferreiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3221, 17, 'Flores');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3222, 17, 'Floresta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3223, 17, 'Frei Miguelinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3224, 17, 'Gameleira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3225, 17, 'Garanhuns');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3226, 17, 'Glria do Goit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3227, 17, 'Goiana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3228, 17, 'Granito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3229, 17, 'Gravat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3230, 17, 'Iati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3231, 17, 'Ibimirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3232, 17, 'Ibirajuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3233, 17, 'Igarassu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3234, 17, 'Iguaraci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3235, 17, 'Inaj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3236, 17, 'Ingazeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3237, 17, 'Ipojuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3238, 17, 'Ipubi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3239, 17, 'Itacuruba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3240, 17, 'Itaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3241, 17, 'Itamarac');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3242, 17, 'Itamb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3243, 17, 'Itapetim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3244, 17, 'Itapissuma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3245, 17, 'Itaquitinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3246, 17, 'Jaboato dos Guararapes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3247, 17, 'Jaqueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3248, 17, 'Jataba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3249, 17, 'Jatob');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3250, 17, 'Joo Alfredo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3251, 17, 'Joaquim Nabuco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3252, 17, 'Jucati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3253, 17, 'Jupi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3254, 17, 'Jurema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3255, 17, 'Lagoa do Carro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3256, 17, 'Lagoa do Itaenga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3257, 17, 'Lagoa do Ouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3258, 17, 'Lagoa dos Gatos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3259, 17, 'Lagoa Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3260, 17, 'Lajedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3261, 17, 'Limoeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3262, 17, 'Macaparana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3263, 17, 'Machados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3264, 17, 'Manari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3265, 17, 'Maraial');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3266, 17, 'Mirandiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3267, 17, 'Moreilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3268, 17, 'Moreno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3269, 17, 'Nazar da Mata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3270, 17, 'Olinda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3271, 17, 'Orob');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3272, 17, 'Oroc');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3273, 17, 'Ouricuri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3274, 17, 'Palmares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3275, 17, 'Palmeirina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3276, 17, 'Panelas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3277, 17, 'Paranatama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3278, 17, 'Parnamirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3279, 17, 'Passira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3280, 17, 'Paudalho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3281, 17, 'Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3282, 17, 'Pedra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3283, 17, 'Pesqueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3284, 17, 'Petrolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3285, 17, 'Petrolina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3286, 17, 'Poo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3287, 17, 'Pombos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3288, 17, 'Primavera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3289, 17, 'Quipap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3290, 17, 'Quixaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3291, 17, 'Recife');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3292, 17, 'Riacho das Almas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3293, 17, 'Ribeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3294, 17, 'Rio Formoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3295, 17, 'Sair');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3296, 17, 'Salgadinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3297, 17, 'Salgueiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3298, 17, 'Salo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3299, 17, 'Sanhar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3300, 17, 'Santa Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3301, 17, 'Santa Cruz da Baixa Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3302, 17, 'Santa Cruz do Capibaribe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3303, 17, 'Santa Filomena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3304, 17, 'Santa Maria da Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3305, 17, 'Santa Maria do Cambuc');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3306, 17, 'Santa Terezinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3307, 17, 'So Benedito do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3308, 17, 'So Bento do Una');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3309, 17, 'So Caitano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3310, 17, 'So Joo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3311, 17, 'So Joaquim do Monte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3312, 17, 'So Jos da Coroa Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3313, 17, 'So Jos do Belmonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3314, 17, 'So Jos do Egito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3315, 17, 'So Loureno da Mata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3316, 17, 'So Vicente Ferrer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3317, 17, 'Serra Talhada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3318, 17, 'Serrita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3319, 17, 'Sertnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3320, 17, 'Sirinham');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3321, 17, 'Solido');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3322, 17, 'Surubim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3323, 17, 'Tabira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3324, 17, 'Tacaimb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3325, 17, 'Tacaratu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3326, 17, 'Tamandar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3327, 17, 'Taquaritinga do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3328, 17, 'Terezinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3329, 17, 'Terra Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3330, 17, 'Timbaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3331, 17, 'Toritama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3332, 17, 'Tracunham');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3333, 17, 'Trindade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3334, 17, 'Triunfo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3335, 17, 'Tupanatinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3336, 17, 'Tuparetama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3337, 17, 'Venturosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3338, 17, 'Verdejante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3339, 17, 'Vertente do Lrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3340, 17, 'Vertentes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3341, 17, 'Vicncia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3342, 17, 'Vitria de Santo Anto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3343, 17, 'Xexu');


/* ******************************* P i a u  ******************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3344, 18, 'Acau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3345, 18, 'Agricolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3346, 18, 'gua Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3347, 18, 'Alagoinha do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3348, 18, 'Alegrete do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3349, 18, 'Alto Long');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3350, 18, 'Altos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3351, 18, 'Alvorada do Gurguia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3352, 18, 'Amarante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3353, 18, 'Angical do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3354, 18, 'Ansio de Abreu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3355, 18, 'Antnio Almeida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3356, 18, 'Aroazes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3357, 18, 'Arraial');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3358, 18, 'Assuno do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3359, 18, 'Avelino Lopes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3360, 18, 'Baixa Grande do Ribeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3361, 18, 'Barra d`Alcntara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3362, 18, 'Barras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3363, 18, 'Barreiras do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3364, 18, 'Barro Duro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3365, 18, 'Batalha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3366, 18, 'Bela Vista do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3367, 18, 'Belm do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3368, 18, 'Beneditinos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3369, 18, 'Bertolnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3370, 18, 'Betnia do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3371, 18, 'Boa Hora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3372, 18, 'Bocaina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3373, 18, 'Bom Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3374, 18, 'Bom Princpio do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3375, 18, 'Bonfim do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3376, 18, 'Boqueiro do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3377, 18, 'Brasileira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3378, 18, 'Brejo do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3379, 18, 'Buriti dos Lopes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3380, 18, 'Buriti dos Montes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3381, 18, 'Cabeceiras do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3382, 18, 'Cajazeiras do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3383, 18, 'Cajueiro da Praia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3384, 18, 'Caldeiro Grande do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3385, 18, 'Campinas do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3386, 18, 'Campo Alegre do Fidalgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3387, 18, 'Campo Grande do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3388, 18, 'Campo Largo do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3389, 18, 'Campo Maior');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3390, 18, 'Canavieira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3391, 18, 'Canto do Buriti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3392, 18, 'Capito de Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3393, 18, 'Capito Gervsio Oliveira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3394, 18, 'Caracol');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3395, 18, 'Carabas do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3396, 18, 'Caridade do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3397, 18, 'Castelo do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3398, 18, 'Caxing');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3399, 18, 'Cocal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3400, 18, 'Cocal de Telha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3401, 18, 'Cocal dos Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3402, 18, 'Coivaras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3403, 18, 'Colnia do Gurguia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3404, 18, 'Colnia do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3405, 18, 'Conceio do Canind');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3406, 18, 'Coronel Jos Dias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3407, 18, 'Corrente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3408, 18, 'Cristalndia do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3409, 18, 'Cristino Castro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3410, 18, 'Curimat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3411, 18, 'Currais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3412, 18, 'Curral Novo do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3413, 18, 'Curralinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3414, 18, 'Demerval Lobo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3415, 18, 'Dirceu Arcoverde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3416, 18, 'Dom Expedito Lopes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3417, 18, 'Dom Inocncio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3418, 18, 'Domingos Mouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3419, 18, 'Elesbo Veloso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3420, 18, 'Eliseu Martins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3421, 18, 'Esperantina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3422, 18, 'Fartura do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3423, 18, 'Flores do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3424, 18, 'Floresta do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3425, 18, 'Floriano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3426, 18, 'Francinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3427, 18, 'Francisco Ayres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3428, 18, 'Francisco Macedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3429, 18, 'Francisco Santos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3430, 18, 'Fronteiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3431, 18, 'Geminiano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3432, 18, 'Gilbus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3433, 18, 'Guadalupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3434, 18, 'Guaribas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3435, 18, 'Hugo Napoleo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3436, 18, 'Ilha Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3437, 18, 'Inhuma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3438, 18, 'Ipiranga do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3439, 18, 'Isaas Coelho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3440, 18, 'Itainpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3441, 18, 'Itaueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3442, 18, 'Jacobina do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3443, 18, 'Jaics');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3444, 18, 'Jardim do Mulato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3445, 18, 'Jatob do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3446, 18, 'Jerumenha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3447, 18, 'Joo Costa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3448, 18, 'Joaquim Pires');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3449, 18, 'Joca Marques');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3450, 18, 'Jos de Freitas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3451, 18, 'Juazeiro do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3452, 18, 'Jlio Borges');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3453, 18, 'Jurema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3454, 18, 'Lagoa Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3455, 18, 'Lagoa de So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3456, 18, 'Lagoa do Barro do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3457, 18, 'Lagoa do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3458, 18, 'Lagoa do Stio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3459, 18, 'Lagoinha do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3460, 18, 'Landri Sales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3461, 18, 'Lus Correia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3462, 18, 'Luzilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3463, 18, 'Madeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3464, 18, 'Manoel Emdio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3465, 18, 'Marcolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3466, 18, 'Marcos Parente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3467, 18, 'Massap do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3468, 18, 'Matias Olmpio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3469, 18, 'Miguel Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3470, 18, 'Miguel Leo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3471, 18, 'Milton Brando');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3472, 18, 'Monsenhor Gil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3473, 18, 'Monsenhor Hiplito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3474, 18, 'Monte Alegre do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3475, 18, 'Morro Cabea no Tempo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3476, 18, 'Morro do Chapu do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3477, 18, 'Murici dos Portelas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3478, 18, 'Nazar do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3479, 18, 'Nossa Senhora de Nazar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3480, 18, 'Nossa Senhora dos Remdios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3481, 18, 'Nova Santa Rita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3482, 18, 'Novo Oriente do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3483, 18, 'Novo Santo Antnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3484, 18, 'Oeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3485, 18, 'Olho d`gua do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3486, 18, 'Padre Marcos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3487, 18, 'Paes Landim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3488, 18, 'Paje do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3489, 18, 'Palmeira do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3490, 18, 'Palmeirais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3491, 18, 'Paquet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3492, 18, 'Parnagu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3493, 18, 'Parnaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3494, 18, 'Passagem Franca do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3495, 18, 'Patos do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3496, 18, 'Paulistana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3497, 18, 'Pavussu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3498, 18, 'Pedro II');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3499, 18, 'Pedro Laurentino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3500, 18, 'Picos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3501, 18, 'Pimenteiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3502, 18, 'Pio IX');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3503, 18, 'Piracuruca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3504, 18, 'Piripiri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3505, 18, 'Porto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3506, 18, 'Porto Alegre do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3507, 18, 'Prata do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3508, 18, 'Queimada Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3509, 18, 'Redeno do Gurguia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3510, 18, 'Regenerao');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3511, 18, 'Riacho Frio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3512, 18, 'Ribeira do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3513, 18, 'Ribeiro Gonalves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3514, 18, 'Rio Grande do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3515, 18, 'Santa Cruz do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3516, 18, 'Santa Cruz dos Milagres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3517, 18, 'Santa Filomena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3518, 18, 'Santa Luz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3519, 18, 'Santa Rosa do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3520, 18, 'Santana do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3521, 18, 'Santo Antnio de Lisboa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3522, 18, 'Santo Antnio dos Milagres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3523, 18, 'Santo Incio do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3524, 18, 'So Braz do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3525, 18, 'So Flix do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3526, 18, 'So Francisco de Assis do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3527, 18, 'So Francisco do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3528, 18, 'So Gonalo do Gurguia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3529, 18, 'So Gonalo do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3530, 18, 'So Joo da Canabrava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3531, 18, 'So Joo da Fronteira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3532, 18, 'So Joo da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3533, 18, 'So Joo da Varjota');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3534, 18, 'So Joo do Arraial');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3535, 18, 'So Joo do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3536, 18, 'So Jos do Divino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3537, 18, 'So Jos do Peixe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3538, 18, 'So Jos do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3539, 18, 'So Julio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3540, 18, 'So Loureno do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3541, 18, 'So Luis do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3542, 18, 'So Miguel da Baixa Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3543, 18, 'So Miguel do Fidalgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3544, 18, 'So Miguel do Tapuio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3545, 18, 'So Pedro do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3546, 18, 'So Raimundo Nonato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3547, 18, 'Sebastio Barros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3548, 18, 'Sebastio Leal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3549, 18, 'Sigefredo Pacheco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3550, 18, 'Simes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3551, 18, 'Simplcio Mendes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3552, 18, 'Socorro do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3553, 18, 'Sussuapara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3554, 18, 'Tamboril do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3555, 18, 'Tanque do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3556, 18, 'Teresina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3557, 18, 'Unio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3558, 18, 'Uruu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3559, 18, 'Valena do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3560, 18, 'Vrzea Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3561, 18, 'Vrzea Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3562, 18, 'Vera Mendes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3563, 18, 'Vila Nova do Piau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3564, 18, 'Wall Ferraz');


/* ********************** R i o   d e   J a n e i r o *********************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3565, 19, 'Angra dos Reis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3566, 19, 'Aperib');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3567, 19, 'Araruama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3568, 19, 'Areal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3569, 19, 'Armao dos Bzios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3570, 19, 'Arraial do Cabo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3571, 19, 'Barra do Pira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3572, 19, 'Barra Mansa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3573, 19, 'Belford Roxo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3574, 19, 'Bom Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3575, 19, 'Bom Jesus do Itabapoana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3576, 19, 'Cabo Frio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3577, 19, 'Cachoeiras de Macacu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3578, 19, 'Cambuci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3579, 19, 'Campos dos Goytacazes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3580, 19, 'Cantagalo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3581, 19, 'Carapebus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3582, 19, 'Cardoso Moreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3583, 19, 'Carmo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3584, 19, 'Casimiro de Abreu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3585, 19, 'Comendador Levy Gasparian');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3586, 19, 'Conceio de Macabu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3587, 19, 'Cordeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3588, 19, 'Duas Barras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3589, 19, 'Duque de Caxias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3590, 19, 'Engenheiro Paulo de Frontin');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3591, 19, 'Guapimirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3592, 19, 'Iguaba Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3593, 19, 'Itabora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3594, 19, 'Itagua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3595, 19, 'Italva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3596, 19, 'Itaocara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3597, 19, 'Itaperuna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3598, 19, 'Itatiaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3599, 19, 'Japeri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3600, 19, 'Laje do Muria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3601, 19, 'Maca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3602, 19, 'Macuco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3603, 19, 'Mag');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3604, 19, 'Mangaratiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3605, 19, 'Maric');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3606, 19, 'Mendes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3607, 19, 'Miguel Pereira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3608, 19, 'Miracema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3609, 19, 'Natividade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3610, 19, 'Nilpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3611, 19, 'Niteri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3612, 19, 'Nova Friburgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3613, 19, 'Nova Iguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3614, 19, 'Paracambi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3615, 19, 'Paraba do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3616, 19, 'Parati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3617, 19, 'Paty do Alferes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3618, 19, 'Petrpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3619, 19, 'Pinheiral');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3620, 19, 'Pira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3621, 19, 'Porcincula');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3622, 19, 'Porto Real');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3623, 19, 'Quatis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3624, 19, 'Queimados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3625, 19, 'Quissam');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3626, 19, 'Resende');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3627, 19, 'Rio Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3628, 19, 'Rio Claro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3629, 19, 'Rio das Flores');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3630, 19, 'Rio das Ostras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3631, 19, 'Rio de Janeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3632, 19, 'Santa Maria Madalena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3633, 19, 'Santo Antnio de Pdua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3634, 19, 'So Fidlis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3635, 19, 'So Francisco de Itabapoana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3636, 19, 'So Gonalo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3637, 19, 'So Joo da Barra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3638, 19, 'So Joo de Meriti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3639, 19, 'So Jos de Ub');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3640, 19, 'So Jos do Vale do Rio Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3641, 19, 'So Pedro da Aldeia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3642, 19, 'So Sebastio do Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3643, 19, 'Sapucaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3644, 19, 'Saquarema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3645, 19, 'Seropdica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3646, 19, 'Silva Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3647, 19, 'Sumidouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3648, 19, 'Tangu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3649, 19, 'Terespolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3650, 19, 'Trajano de Morais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3651, 19, 'Trs Rios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3652, 19, 'Valena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3653, 19, 'Varre-Sai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3654, 19, 'Vassouras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3655, 19, 'Volta Redonda');


/* ***************** R i o   G r a n d e   d o   N o r t e ****************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3656, 20, 'Acari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3657, 20, 'Au');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3658, 20, 'Afonso Bezerra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3659, 20, 'gua Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3660, 20, 'Alexandria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3661, 20, 'Almino Afonso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3662, 20, 'Alto do Rodrigues');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3663, 20, 'Angicos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3664, 20, 'Antnio Martins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3665, 20, 'Apodi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3666, 20, 'Areia Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3667, 20, 'Ars');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3668, 20, 'Augusto Severo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3669, 20, 'Baa Formosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3670, 20, 'Barana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3671, 20, 'Barcelona');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3672, 20, 'Bento Fernandes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3673, 20, 'Bod');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3674, 20, 'Bom Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3675, 20, 'Brejinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3676, 20, 'Caiara do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3677, 20, 'Caiara do Rio do Vento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3678, 20, 'Caic');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3679, 20, 'Campo Redondo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3680, 20, 'Canguaretama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3681, 20, 'Carabas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3682, 20, 'Carnaba dos Dantas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3683, 20, 'Carnaubais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3684, 20, 'Cear-Mirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3685, 20, 'Cerro Cor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3686, 20, 'Coronel Ezequiel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3687, 20, 'Coronel Joo Pessoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3688, 20, 'Cruzeta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3689, 20, 'Currais Novos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3690, 20, 'Doutor Severiano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3691, 20, 'Encanto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3692, 20, 'Equador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3693, 20, 'Esprito Santo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3694, 20, 'Extremoz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3695, 20, 'Felipe Guerra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3696, 20, 'Fernando Pedroza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3697, 20, 'Flornia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3698, 20, 'Francisco Dantas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3699, 20, 'Frutuoso Gomes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3700, 20, 'Galinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3701, 20, 'Goianinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3702, 20, 'Governador Dix-Sept Rosado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3703, 20, 'Grossos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3704, 20, 'Guamar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3705, 20, 'Ielmo Marinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3706, 20, 'Ipanguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3707, 20, 'Ipueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3708, 20, 'Itaj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3709, 20, 'Ita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3710, 20, 'Jaan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3711, 20, 'Jandara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3712, 20, 'Jandus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3713, 20, 'Janurio Cicco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3714, 20, 'Japi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3715, 20, 'Jardim de Angicos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3716, 20, 'Jardim de Piranhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3717, 20, 'Jardim do Serid');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3718, 20, 'Joo Cmara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3719, 20, 'Joo Dias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3720, 20, 'Jos da Penha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3721, 20, 'Jucurutu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3722, 20, 'Lagoa d`Anta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3723, 20, 'Lagoa de Pedras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3724, 20, 'Lagoa de Velhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3725, 20, 'Lagoa Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3726, 20, 'Lagoa Salgada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3727, 20, 'Lajes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3728, 20, 'Lajes Pintadas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3729, 20, 'Lucrcia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3730, 20, 'Lus Gomes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3731, 20, 'Macaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3732, 20, 'Macau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3733, 20, 'Major Sales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3734, 20, 'Marcelino Vieira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3735, 20, 'Martins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3736, 20, 'Maxaranguape');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3737, 20, 'Messias Targino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3738, 20, 'Montanhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3739, 20, 'Monte Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3740, 20, 'Monte das Gameleiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3741, 20, 'Mossor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3742, 20, 'Natal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3743, 20, 'Nsia Floresta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3744, 20, 'Nova Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3745, 20, 'Olho-d`gua do Borges');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3746, 20, 'Ouro Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3747, 20, 'Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3748, 20, 'Para');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3749, 20, 'Parazinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3750, 20, 'Parelhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3751, 20, 'Parnamirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3752, 20, 'Passa e Fica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3753, 20, 'Passagem');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3754, 20, 'Patu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3755, 20, 'Pau dos Ferros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3756, 20, 'Pedra Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3757, 20, 'Pedra Preta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3758, 20, 'Pedro Avelino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3759, 20, 'Pedro Velho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3760, 20, 'Pendncias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3761, 20, 'Piles');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3762, 20, 'Poo Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3763, 20, 'Portalegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3764, 20, 'Porto do Mangue');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3765, 20, 'Presidente Juscelino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3766, 20, 'Pureza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3767, 20, 'Rafael Fernandes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3768, 20, 'Rafael Godeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3769, 20, 'Riacho da Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3770, 20, 'Riacho de Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3771, 20, 'Riachuelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3772, 20, 'Rio do Fogo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3773, 20, 'Rodolfo Fernandes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3774, 20, 'Ruy Barbosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3775, 20, 'Santa Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3776, 20, 'Santa Maria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3777, 20, 'Santana do Matos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3778, 20, 'Santana do Serid');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3779, 20, 'Santo Antnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3780, 20, 'So Bento do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3781, 20, 'So Bento do Trair');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3782, 20, 'So Fernando');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3783, 20, 'So Francisco do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3784, 20, 'So Gonalo do Amarante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3785, 20, 'So Joo do Sabugi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3786, 20, 'So Jos de Mipibu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3787, 20, 'So Jos do Campestre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3788, 20, 'So Jos do Serid');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3789, 20, 'So Miguel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3790, 20, 'So Miguel de Touros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3791, 20, 'So Paulo do Potengi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3792, 20, 'So Pedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3793, 20, 'So Rafael');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3794, 20, 'So Tom');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3795, 20, 'So Vicente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3796, 20, 'Senador Eli de Souza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3797, 20, 'Senador Georgino Avelino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3798, 20, 'Serra de So Bento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3799, 20, 'Serra do Mel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3800, 20, 'Serra Negra do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3801, 20, 'Serrinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3802, 20, 'Serrinha dos Pintos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3803, 20, 'Severiano Melo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3804, 20, 'Stio Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3805, 20, 'Taboleiro Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3806, 20, 'Taipu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3807, 20, 'Tangar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3808, 20, 'Tenente Ananias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3809, 20, 'Tenente Laurentino Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3810, 20, 'Tibau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3811, 20, 'Tibau do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3812, 20, 'Timbaba dos Batistas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3813, 20, 'Touros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3814, 20, 'Triunfo Potiguar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3815, 20, 'Umarizal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3816, 20, 'Upanema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3817, 20, 'Vrzea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3818, 20, 'Venha-Ver');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3819, 20, 'Vera Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3820, 20, 'Viosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3821, 20, 'Vila Flor');


/* ******************* R i o   G r a n d e   d o   S u l ******************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3822, 21, 'gua Santa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3823, 21, 'Agudo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3824, 21, 'Ajuricaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3825, 21, 'Alecrim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3826, 21, 'Alegrete');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3827, 21, 'Alegria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3828, 21, 'Alpestre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3829, 21, 'Alto Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3830, 21, 'Alto Feliz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3831, 21, 'Alvorada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3832, 21, 'Amaral Ferrador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3833, 21, 'Ametista do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3834, 21, 'Andr da Rocha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3835, 21, 'Anta Gorda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3836, 21, 'Antnio Prado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3837, 21, 'Arambar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3838, 21, 'Araric');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3839, 21, 'Aratiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3840, 21, 'Arroio do Meio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3841, 21, 'Arroio do Sal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3842, 21, 'Arroio do Tigre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3843, 21, 'Arroio dos Ratos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3844, 21, 'Arroio Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3845, 21, 'Arvorezinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3846, 21, 'Augusto Pestana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3847, 21, 'urea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3848, 21, 'Bag');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3849, 21, 'Balnerio Pinhal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3850, 21, 'Baro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3851, 21, 'Baro de Cotegipe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3852, 21, 'Baro do Triunfo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3853, 21, 'Barra do Guarita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3854, 21, 'Barra do Quara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3855, 21, 'Barra do Ribeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3856, 21, 'Barra do Rio Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3857, 21, 'Barra Funda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3858, 21, 'Barraco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3859, 21, 'Barros Cassal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3860, 21, 'Benjamin Constant do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3861, 21, 'Bento Gonalves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3862, 21, 'Boa Vista das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3863, 21, 'Boa Vista do Buric');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3864, 21, 'Boa Vista do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3865, 21, 'Bom Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3866, 21, 'Bom Princpio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3867, 21, 'Bom Progresso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3868, 21, 'Bom Retiro do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3869, 21, 'Boqueiro do Leo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3870, 21, 'Bossoroca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3871, 21, 'Braga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3872, 21, 'Brochier');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3873, 21, 'Buti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3874, 21, 'Caapava do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3875, 21, 'Cacequi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3876, 21, 'Cachoeira do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3877, 21, 'Cachoeirinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3878, 21, 'Cacique Doble');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3879, 21, 'Caibat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3880, 21, 'Caiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3881, 21, 'Camaqu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3882, 21, 'Camargo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3883, 21, 'Cambar do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3884, 21, 'Campestre da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3885, 21, 'Campina das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3886, 21, 'Campinas do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3887, 21, 'Campo Bom');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3888, 21, 'Campo Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3889, 21, 'Campos Borges');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3890, 21, 'Candelria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3891, 21, 'Cndido Godi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3892, 21, 'Candiota');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3893, 21, 'Canela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3894, 21, 'Canguu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3895, 21, 'Canoas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3896, 21, 'Capo da Canoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3897, 21, 'Capo do Leo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3898, 21, 'Capela de Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3899, 21, 'Capito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3900, 21, 'Capivari do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3901, 21, 'Cara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3902, 21, 'Carazinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3903, 21, 'Carlos Barbosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3904, 21, 'Carlos Gomes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3905, 21, 'Casca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3906, 21, 'Caseiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3907, 21, 'Catupe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3908, 21, 'Caxias do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3909, 21, 'Centenrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3910, 21, 'Cerrito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3911, 21, 'Cerro Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3912, 21, 'Cerro Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3913, 21, 'Cerro Grande do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3914, 21, 'Cerro Largo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3915, 21, 'Chapada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3916, 21, 'Charqueadas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3917, 21, 'Charrua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3918, 21, 'Chiapeta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3919, 21, 'Chu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3920, 21, 'Chuvisca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3921, 21, 'Cidreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3922, 21, 'Ciraco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3923, 21, 'Colinas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3924, 21, 'Colorado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3925, 21, 'Condor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3926, 21, 'Constantina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3927, 21, 'Coqueiros do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3928, 21, 'Coronel Barros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3929, 21, 'Coronel Bicaco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3930, 21, 'Cotipor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3931, 21, 'Coxilha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3932, 21, 'Crissiumal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3933, 21, 'Cristal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3934, 21, 'Cristal do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3935, 21, 'Cruz Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3936, 21, 'Cruzeiro do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3937, 21, 'David Canabarro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3938, 21, 'Derrubadas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3939, 21, 'Dezesseis de Novembro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3940, 21, 'Dilermando de Aguiar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3941, 21, 'Dois Irmos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3942, 21, 'Dois Irmos das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3943, 21, 'Dois Lajeados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3944, 21, 'Dom Feliciano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3945, 21, 'Dom Pedrito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3946, 21, 'Dom Pedro de Alcntara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3947, 21, 'Dona Francisca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3948, 21, 'Doutor Maurcio Cardoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3949, 21, 'Doutor Ricardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3950, 21, 'Eldorado do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3951, 21, 'Encantado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3952, 21, 'Encruzilhada do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3953, 21, 'Engenho Velho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3954, 21, 'Entre Rios do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3955, 21, 'Entre-Ijus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3956, 21, 'Erebango');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3957, 21, 'Erechim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3958, 21, 'Ernestina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3959, 21, 'Erval Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3960, 21, 'Erval Seco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3961, 21, 'Esmeralda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3962, 21, 'Esperana do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3963, 21, 'Espumoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3964, 21, 'Estao');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3965, 21, 'Estncia Velha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3966, 21, 'Esteio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3967, 21, 'Estrela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3968, 21, 'Estrela Velha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3969, 21, 'Eugnio de Castro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3970, 21, 'Fagundes Varela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3971, 21, 'Farroupilha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3972, 21, 'Faxinal do Soturno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3973, 21, 'Faxinalzinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3974, 21, 'Fazenda Vilanova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3975, 21, 'Feliz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3976, 21, 'Flores da Cunha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3977, 21, 'Floriano Peixoto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3978, 21, 'Fontoura Xavier');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3979, 21, 'Formigueiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3980, 21, 'Fortaleza dos Valos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3981, 21, 'Frederico Westphalen');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3982, 21, 'Garibaldi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3983, 21, 'Garruchos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3984, 21, 'Gaurama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3985, 21, 'General Cmara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3986, 21, 'Gentil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3987, 21, 'Getlio Vargas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3988, 21, 'Giru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3989, 21, 'Glorinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3990, 21, 'Gramado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3991, 21, 'Gramado dos Loureiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3992, 21, 'Gramado Xavier');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3993, 21, 'Gravata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3994, 21, 'Guabiju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3995, 21, 'Guaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3996, 21, 'Guapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3997, 21, 'Guarani das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3998, 21, 'Harmonia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (3999, 21, 'Herval');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4000, 21, 'Herveiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4001, 21, 'Horizontina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4002, 21, 'Hulha Negra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4003, 21, 'Humait');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4004, 21, 'Ibarama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4005, 21, 'Ibia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4006, 21, 'Ibiraiaras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4007, 21, 'Ibirapuit');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4008, 21, 'Ibirub');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4009, 21, 'Igrejinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4010, 21, 'Iju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4011, 21, 'Ilpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4012, 21, 'Imb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4013, 21, 'Imigrante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4014, 21, 'Independncia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4015, 21, 'Inhacor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4016, 21, 'Ip');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4017, 21, 'Ipiranga do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4018, 21, 'Ira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4019, 21, 'Itaara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4020, 21, 'Itacurubi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4021, 21, 'Itapuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4022, 21, 'Itaqui');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4023, 21, 'Itatiba do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4024, 21, 'Ivor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4025, 21, 'Ivoti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4026, 21, 'Jaboticaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4027, 21, 'Jacutinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4028, 21, 'Jaguaro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4029, 21, 'Jaguari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4030, 21, 'Jaquirana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4031, 21, 'Jari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4032, 21, 'Jia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4033, 21, 'Jlio de Castilhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4034, 21, 'Lagoa dos Trs Cantos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4035, 21, 'Lagoa Vermelha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4036, 21, 'Lagoo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4037, 21, 'Lajeado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4038, 21, 'Lajeado do Bugre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4039, 21, 'Lavras do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4040, 21, 'Liberato Salzano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4041, 21, 'Lindolfo Collor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4042, 21, 'Linha Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4043, 21, 'Maambara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4044, 21, 'Machadinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4045, 21, 'Mampituba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4046, 21, 'Manoel Viana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4047, 21, 'Maquin');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4048, 21, 'Marat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4049, 21, 'Marau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4050, 21, 'Marcelino Ramos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4051, 21, 'Mariana Pimentel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4052, 21, 'Mariano Moro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4053, 21, 'Marques de Souza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4054, 21, 'Mata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4055, 21, 'Mato Castelhano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4056, 21, 'Mato Leito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4057, 21, 'Maximiliano de Almeida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4058, 21, 'Minas do Leo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4059, 21, 'Miragua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4060, 21, 'Montauri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4061, 21, 'Monte Alegre dos Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4062, 21, 'Monte Belo do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4063, 21, 'Montenegro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4064, 21, 'Mormao');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4065, 21, 'Morrinhos do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4066, 21, 'Morro Redondo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4067, 21, 'Morro Reuter');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4068, 21, 'Mostardas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4069, 21, 'Muum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4070, 21, 'Muitos Capes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4071, 21, 'Muliterno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4072, 21, 'No-Me-Toque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4073, 21, 'Nicolau Vergueiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4074, 21, 'Nonoai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4075, 21, 'Nova Alvorada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4076, 21, 'Nova Ara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4077, 21, 'Nova Bassano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4078, 21, 'Nova Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4079, 21, 'Nova Brscia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4080, 21, 'Nova Candelria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4081, 21, 'Nova Esperana do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4082, 21, 'Nova Hartz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4083, 21, 'Nova Pdua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4084, 21, 'Nova Palma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4085, 21, 'Nova Petrpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4086, 21, 'Nova Prata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4087, 21, 'Nova Ramada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4088, 21, 'Nova Roma do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4089, 21, 'Nova Santa Rita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4090, 21, 'Novo Barreiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4091, 21, 'Novo Cabrais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4092, 21, 'Novo Hamburgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4093, 21, 'Novo Machado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4094, 21, 'Novo Tiradentes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4095, 21, 'Osrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4096, 21, 'Paim Filho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4097, 21, 'Palmares do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4098, 21, 'Palmeira das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4099, 21, 'Palmitinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4100, 21, 'Panambi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4101, 21, 'Pantano Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4102, 21, 'Para');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4103, 21, 'Paraso do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4104, 21, 'Pareci Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4105, 21, 'Parob');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4106, 21, 'Passa Sete');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4107, 21, 'Passo do Sobrado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4108, 21, 'Passo Fundo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4109, 21, 'Paverama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4110, 21, 'Pedro Osrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4111, 21, 'Pejuara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4112, 21, 'Pelotas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4113, 21, 'Picada Caf');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4114, 21, 'Pinhal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4115, 21, 'Pinhal Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4116, 21, 'Pinheirinho do Vale');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4117, 21, 'Pinheiro Machado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4118, 21, 'Pirap');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4119, 21, 'Piratini');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4120, 21, 'Planalto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4121, 21, 'Poo das Antas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4122, 21, 'Ponto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4123, 21, 'Ponte Preta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4124, 21, 'Porto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4125, 21, 'Porto Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4126, 21, 'Porto Lucena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4127, 21, 'Porto Mau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4128, 21, 'Porto Vera Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4129, 21, 'Porto Xavier');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4130, 21, 'Pouso Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4131, 21, 'Presidente Lucena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4132, 21, 'Progresso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4133, 21, 'Protsio Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4134, 21, 'Putinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4135, 21, 'Quara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4136, 21, 'Quevedos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4137, 21, 'Quinze de Novembro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4138, 21, 'Redentora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4139, 21, 'Relvado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4140, 21, 'Restinga Seca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4141, 21, 'Rio dos ndios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4142, 21, 'Rio Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4143, 21, 'Rio Pardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4144, 21, 'Riozinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4145, 21, 'Roca Sales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4146, 21, 'Rodeio Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4147, 21, 'Rolante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4148, 21, 'Ronda Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4149, 21, 'Rondinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4150, 21, 'Roque Gonzales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4151, 21, 'Rosrio do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4152, 21, 'Sagrada Famlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4153, 21, 'Saldanha Marinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4154, 21, 'Salto do Jacu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4155, 21, 'Salvador das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4156, 21, 'Salvador do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4157, 21, 'Sananduva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4158, 21, 'Santa Brbara do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4159, 21, 'Santa Clara do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4160, 21, 'Santa Cruz do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4161, 21, 'Santa Maria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4162, 21, 'Santa Maria do Herval');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4163, 21, 'Santa Rosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4164, 21, 'Santa Tereza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4165, 21, 'Santa Vitria do Palmar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4166, 21, 'Santana da Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4167, 21, 'Santana do Livramento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4168, 21, 'Santiago');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4169, 21, 'Santo ngelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4170, 21, 'Santo Antnio da Patrulha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4171, 21, 'Santo Antnio das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4172, 21, 'Santo Antnio do Palma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4173, 21, 'Santo Antnio do Planalto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4174, 21, 'Santo Augusto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4175, 21, 'Santo Cristo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4176, 21, 'Santo Expedito do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4177, 21, 'So Borja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4178, 21, 'So Domingos do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4179, 21, 'So Francisco de Assis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4180, 21, 'So Francisco de Paula');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4181, 21, 'So Gabriel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4182, 21, 'So Jernimo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4183, 21, 'So Joo da Urtiga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4184, 21, 'So Joo do Polsine');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4185, 21, 'So Jorge');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4186, 21, 'So Jos das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4187, 21, 'So Jos do Herval');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4188, 21, 'So Jos do Hortncio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4189, 21, 'So Jos do Inhacor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4190, 21, 'So Jos do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4191, 21, 'So Jos do Ouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4192, 21, 'So Jos dos Ausentes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4193, 21, 'So Leopoldo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4194, 21, 'So Loureno do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4195, 21, 'So Luiz Gonzaga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4196, 21, 'So Marcos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4197, 21, 'So Martinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4198, 21, 'So Martinho da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4199, 21, 'So Miguel das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4200, 21, 'So Nicolau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4201, 21, 'So Paulo das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4202, 21, 'So Pedro da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4203, 21, 'So Pedro do Buti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4204, 21, 'So Pedro do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4205, 21, 'So Sebastio do Ca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4206, 21, 'So Sep');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4207, 21, 'So Valentim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4208, 21, 'So Valentim do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4209, 21, 'So Valrio do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4210, 21, 'So Vendelino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4211, 21, 'So Vicente do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4212, 21, 'Sapiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4213, 21, 'Sapucaia do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4214, 21, 'Sarandi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4215, 21, 'Seberi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4216, 21, 'Sede Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4217, 21, 'Segredo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4218, 21, 'Selbach');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4219, 21, 'Senador Salgado Filho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4220, 21, 'Sentinela do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4221, 21, 'Serafina Corra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4222, 21, 'Srio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4223, 21, 'Serto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4224, 21, 'Serto Santana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4225, 21, 'Sete de Setembro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4226, 21, 'Severiano de Almeida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4227, 21, 'Silveira Martins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4228, 21, 'Sinimbu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4229, 21, 'Sobradinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4230, 21, 'Soledade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4231, 21, 'Taba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4232, 21, 'Tapejara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4233, 21, 'Tapera');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4234, 21, 'Tapes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4235, 21, 'Taquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4236, 21, 'Taquari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4237, 21, 'Taquaruu do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4238, 21, 'Tavares');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4239, 21, 'Tenente Portela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4240, 21, 'Terra de Areia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4241, 21, 'Teutnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4242, 21, 'Tiradentes do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4243, 21, 'Toropi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4244, 21, 'Torres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4245, 21, 'Tramanda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4246, 21, 'Travesseiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4247, 21, 'Trs Arroios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4248, 21, 'Trs Cachoeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4249, 21, 'Trs Coroas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4250, 21, 'Trs de Maio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4251, 21, 'Trs Forquilhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4252, 21, 'Trs Palmeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4253, 21, 'Trs Passos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4254, 21, 'Trindade do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4255, 21, 'Triunfo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4256, 21, 'Tucunduva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4257, 21, 'Tunas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4258, 21, 'Tupanci do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4259, 21, 'Tupanciret');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4260, 21, 'Tupandi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4261, 21, 'Tuparendi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4262, 21, 'Turuu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4263, 21, 'Ubiretama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4264, 21, 'Unio da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4265, 21, 'Unistalda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4266, 21, 'Uruguaiana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4267, 21, 'Vacaria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4268, 21, 'Vale do Sol');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4269, 21, 'Vale Real');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4270, 21, 'Vale Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4271, 21, 'Vanini');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4272, 21, 'Venncio Aires');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4273, 21, 'Vera Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4274, 21, 'Veranpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4275, 21, 'Vespasiano Correa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4276, 21, 'Viadutos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4277, 21, 'Viamo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4278, 21, 'Vicente Dutra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4279, 21, 'Victor Graeff');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4280, 21, 'Vila Flores');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4281, 21, 'Vila Lngaro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4282, 21, 'Vila Maria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4283, 21, 'Vila Nova do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4284, 21, 'Vista Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4285, 21, 'Vista Alegre do Prata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4286, 21, 'Vista Gacha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4287, 21, 'Vitria das Misses');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4288, 21, 'Xangri-l');


/* **************************** R o n d  n i a ***************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4289, 22, 'Alta Floresta d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4290, 22, 'Alto Alegre dos Parecis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4291, 22, 'Alto Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4292, 22, 'Alvorada d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4293, 22, 'Ariquemes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4294, 22, 'Buritis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4295, 22, 'Cabixi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4296, 22, 'Cacaulndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4297, 22, 'Cacoal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4298, 22, 'Campo Novo de Rondnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4299, 22, 'Candeias do Jamari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4300, 22, 'Castanheiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4301, 22, 'Cerejeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4302, 22, 'Chupinguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4303, 22, 'Colorado do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4304, 22, 'Corumbiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4305, 22, 'Costa Marques');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4306, 22, 'Cujubim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4307, 22, 'Espigo d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4308, 22, 'Governador Jorge Teixeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4309, 22, 'Guajar-Mirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4310, 22, 'Itapu do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4311, 22, 'Jaru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4312, 22, 'Ji-Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4313, 22, 'Machadinho d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4314, 22, 'Ministro Andreazza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4315, 22, 'Mirante da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4316, 22, 'Monte Negro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4317, 22, 'Nova Brasilndia d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4318, 22, 'Nova Mamor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4319, 22, 'Nova Unio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4320, 22, 'Novo Horizonte do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4321, 22, 'Ouro Preto do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4322, 22, 'Parecis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4323, 22, 'Pimenta Bueno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4324, 22, 'Pimenteiras do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4325, 22, 'Porto Velho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4326, 22, 'Presidente Mdici');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4327, 22, 'Primavera de Rondnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4328, 22, 'Rio Crespo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4329, 22, 'Rolim de Moura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4330, 22, 'Santa Luzia d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4331, 22, 'So Felipe d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4332, 22, 'So Francisco do Guapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4333, 22, 'So Miguel do Guapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4334, 22, 'Seringueiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4335, 22, 'Teixeirpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4336, 22, 'Theobroma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4337, 22, 'Urup');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4338, 22, 'Vale do Anari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4339, 22, 'Vale do Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4340, 22, 'Vilhena');


/* ***************************** R o r a i m a ****************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4341, 23, 'Alto Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4342, 23, 'Amajari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4343, 23, 'Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4344, 23, 'Bonfim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4345, 23, 'Cant');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4346, 23, 'Caracara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4347, 23, 'Caroebe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4348, 23, 'Iracema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4349, 23, 'Mucaja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4350, 23, 'Normandia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4351, 23, 'Pacaraima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4352, 23, 'Rorainpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4353, 23, 'So Joo da Baliza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4354, 23, 'So Luiz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4355, 23, 'Uiramut');


/* ********************** S a n t a   C a t a r i n a *********************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4356, 24, 'Abdon Batista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4357, 24, 'Abelardo Luz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4358, 24, 'Agrolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4359, 24, 'Agronmica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4360, 24, 'gua Doce');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4361, 24, 'guas de Chapec');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4362, 24, 'guas Frias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4363, 24, 'guas Mornas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4364, 24, 'Alfredo Wagner');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4365, 24, 'Alto Bela Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4366, 24, 'Anchieta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4367, 24, 'Angelina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4368, 24, 'Anita Garibaldi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4369, 24, 'Anitpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4370, 24, 'Antnio Carlos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4371, 24, 'Apina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4372, 24, 'Arabut');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4373, 24, 'Araquari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4374, 24, 'Ararangu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4375, 24, 'Armazm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4376, 24, 'Arroio Trinta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4377, 24, 'Arvoredo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4378, 24, 'Ascurra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4379, 24, 'Atalanta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4380, 24, 'Aurora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4381, 24, 'Balnerio Arroio do Silva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4382, 24, 'Balnerio Barra do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4383, 24, 'Balnerio Cambori');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4384, 24, 'Balnerio Gaivota');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4385, 24, 'Bandeirante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4386, 24, 'Barra Bonita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4387, 24, 'Barra Velha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4388, 24, 'Bela Vista do Toldo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4389, 24, 'Belmonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4390, 24, 'Benedito Novo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4391, 24, 'Biguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4392, 24, 'Blumenau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4393, 24, 'Bocaina do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4394, 24, 'Bom Jardim da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4395, 24, 'Bom Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4396, 24, 'Bom Jesus do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4397, 24, 'Bom Retiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4398, 24, 'Bombinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4399, 24, 'Botuver');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4400, 24, 'Brao do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4401, 24, 'Brao do Trombudo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4402, 24, 'Brunpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4403, 24, 'Brusque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4404, 24, 'Caador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4405, 24, 'Caibi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4406, 24, 'Calmon');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4407, 24, 'Cambori');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4408, 24, 'Campo Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4409, 24, 'Campo Belo do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4410, 24, 'Campo Er');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4411, 24, 'Campos Novos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4412, 24, 'Canelinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4413, 24, 'Canoinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4414, 24, 'Capo Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4415, 24, 'Capinzal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4416, 24, 'Capivari de Baixo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4417, 24, 'Catanduvas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4418, 24, 'Caxambu do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4419, 24, 'Celso Ramos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4420, 24, 'Cerro Negro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4421, 24, 'Chapado do Lageado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4422, 24, 'Chapec');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4423, 24, 'Cocal do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4424, 24, 'Concrdia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4425, 24, 'Cordilheira Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4426, 24, 'Coronel Freitas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4427, 24, 'Coronel Martins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4428, 24, 'Correia Pinto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4429, 24, 'Corup');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4430, 24, 'Cricima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4431, 24, 'Cunha Por');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4432, 24, 'Cunhata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4433, 24, 'Curitibanos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4434, 24, 'Descanso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4435, 24, 'Dionsio Cerqueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4436, 24, 'Dona Emma');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4437, 24, 'Doutor Pedrinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4438, 24, 'Entre Rios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4439, 24, 'Ermo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4440, 24, 'Erval Velho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4441, 24, 'Faxinal dos Guedes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4442, 24, 'Flor do Serto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4443, 24, 'Florianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4444, 24, 'Formosa do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4445, 24, 'Forquilhinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4446, 24, 'Fraiburgo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4447, 24, 'Frei Rogrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4448, 24, 'Galvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4449, 24, 'Garopaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4450, 24, 'Garuva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4451, 24, 'Gaspar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4452, 24, 'Governador Celso Ramos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4453, 24, 'Gro Par');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4454, 24, 'Gravatal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4455, 24, 'Guabiruba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4456, 24, 'Guaraciaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4457, 24, 'Guaramirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4458, 24, 'Guaruj do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4459, 24, 'Guatamb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4460, 24, 'Herval d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4461, 24, 'Ibiam');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4462, 24, 'Ibicar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4463, 24, 'Ibirama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4464, 24, 'Iara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4465, 24, 'Ilhota');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4466, 24, 'Imaru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4467, 24, 'Imbituba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4468, 24, 'Imbuia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4469, 24, 'Indaial');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4470, 24, 'Iomer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4471, 24, 'Ipira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4472, 24, 'Ipor do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4473, 24, 'Ipuau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4474, 24, 'Ipumirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4475, 24, 'Iraceminha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4476, 24, 'Irani');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4477, 24, 'Irati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4478, 24, 'Irinepolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4479, 24, 'It');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4480, 24, 'Itaipolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4481, 24, 'Itaja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4482, 24, 'Itapema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4483, 24, 'Itapiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4484, 24, 'Itapo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4485, 24, 'Ituporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4486, 24, 'Jabor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4487, 24, 'Jacinto Machado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4488, 24, 'Jaguaruna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4489, 24, 'Jaragu do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4490, 24, 'Jardinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4491, 24, 'Joaaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4492, 24, 'Joinville');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4493, 24, 'Jos Boiteux');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4494, 24, 'Jupi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4495, 24, 'Lacerdpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4496, 24, 'Lages');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4497, 24, 'Laguna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4498, 24, 'Lajeado Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4499, 24, 'Laurentino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4500, 24, 'Lauro Muller');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4501, 24, 'Lebon Rgis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4502, 24, 'Leoberto Leal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4503, 24, 'Lindia do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4504, 24, 'Lontras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4505, 24, 'Luiz Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4506, 24, 'Luzerna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4507, 24, 'Macieira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4508, 24, 'Mafra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4509, 24, 'Major Gercino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4510, 24, 'Major Vieira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4511, 24, 'Maracaj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4512, 24, 'Maravilha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4513, 24, 'Marema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4514, 24, 'Massaranduba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4515, 24, 'Matos Costa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4516, 24, 'Meleiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4517, 24, 'Mirim Doce');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4518, 24, 'Modelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4519, 24, 'Monda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4520, 24, 'Monte Carlo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4521, 24, 'Monte Castelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4522, 24, 'Morro da Fumaa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4523, 24, 'Morro Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4524, 24, 'Navegantes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4525, 24, 'Nova Erechim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4526, 24, 'Nova Itaberaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4527, 24, 'Nova Trento');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4528, 24, 'Nova Veneza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4529, 24, 'Novo Horizonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4530, 24, 'Orleans');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4531, 24, 'Otaclio Costa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4532, 24, 'Ouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4533, 24, 'Ouro Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4534, 24, 'Paial');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4535, 24, 'Painel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4536, 24, 'Palhoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4537, 24, 'Palma Sola');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4538, 24, 'Palmeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4539, 24, 'Palmitos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4540, 24, 'Papanduva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4541, 24, 'Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4542, 24, 'Passo de Torres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4543, 24, 'Passos Maia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4544, 24, 'Paulo Lopes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4545, 24, 'Pedras Grandes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4546, 24, 'Penha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4547, 24, 'Peritiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4548, 24, 'Petrolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4549, 24, 'Piarras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4550, 24, 'Pinhalzinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4551, 24, 'Pinheiro Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4552, 24, 'Piratuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4553, 24, 'Planalto Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4554, 24, 'Pomerode');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4555, 24, 'Ponte Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4556, 24, 'Ponte Alta do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4557, 24, 'Ponte Serrada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4558, 24, 'Porto Belo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4559, 24, 'Porto Unio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4560, 24, 'Pouso Redondo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4561, 24, 'Praia Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4562, 24, 'Presidente Castelo Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4563, 24, 'Presidente Getlio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4564, 24, 'Presidente Nereu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4565, 24, 'Princesa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4566, 24, 'Quilombo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4567, 24, 'Rancho Queimado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4568, 24, 'Rio das Antas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4569, 24, 'Rio do Campo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4570, 24, 'Rio do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4571, 24, 'Rio do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4572, 24, 'Rio dos Cedros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4573, 24, 'Rio Fortuna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4574, 24, 'Rio Negrinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4575, 24, 'Rio Rufino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4576, 24, 'Riqueza');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4577, 24, 'Rodeio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4578, 24, 'Romelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4579, 24, 'Salete');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4580, 24, 'Saltinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4581, 24, 'Salto Veloso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4582, 24, 'Sango');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4583, 24, 'Santa Ceclia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4584, 24, 'Santa Helena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4585, 24, 'Santa Rosa de Lima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4586, 24, 'Santa Rosa do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4587, 24, 'Santa Terezinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4588, 24, 'Santa Terezinha do Progresso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4589, 24, 'Santiago do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4590, 24, 'Santo Amaro da Imperatriz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4591, 24, 'So Bento do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4592, 24, 'So Bernardino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4593, 24, 'So Bonifcio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4594, 24, 'So Carlos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4595, 24, 'So Cristovo do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4596, 24, 'So Domingos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4597, 24, 'So Francisco do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4598, 24, 'So Joo Batista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4599, 24, 'So Joo do Itaperi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4600, 24, 'So Joo do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4601, 24, 'So Joo do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4602, 24, 'So Joaquim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4603, 24, 'So Jos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4604, 24, 'So Jos do Cedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4605, 24, 'So Jos do Cerrito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4606, 24, 'So Loureno do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4607, 24, 'So Ludgero');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4608, 24, 'So Martinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4609, 24, 'So Miguel da Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4610, 24, 'So Miguel do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4611, 24, 'So Pedro de Alcntara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4612, 24, 'Saudades');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4613, 24, 'Schroeder');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4614, 24, 'Seara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4615, 24, 'Serra Alta');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4616, 24, 'Siderpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4617, 24, 'Sombrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4618, 24, 'Sul Brasil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4619, 24, 'Tai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4620, 24, 'Tangar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4621, 24, 'Tigrinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4622, 24, 'Tijucas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4623, 24, 'Timb do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4624, 24, 'Timb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4625, 24, 'Timb Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4626, 24, 'Trs Barras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4627, 24, 'Treviso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4628, 24, 'Treze de Maio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4629, 24, 'Treze Tlias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4630, 24, 'Trombudo Central');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4631, 24, 'Tubaro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4632, 24, 'Tunpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4633, 24, 'Turvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4634, 24, 'Unio do Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4635, 24, 'Urubici');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4636, 24, 'Urupema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4637, 24, 'Urussanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4638, 24, 'Vargeo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4639, 24, 'Vargem');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4640, 24, 'Vargem Bonita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4641, 24, 'Vidal Ramos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4642, 24, 'Videira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4643, 24, 'Vitor Meireles');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4644, 24, 'Witmarsum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4645, 24, 'Xanxer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4646, 24, 'Xavantina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4647, 24, 'Xaxim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4648, 24, 'Zorta');


/* *************************** S  o   P a u l o **************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4649, 25, 'Adamantina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4650, 25, 'Adolfo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4651, 25, 'Agua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4652, 25, 'guas da Prata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4653, 25, 'guas de Lindia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4654, 25, 'guas de Santa Brbara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4655, 25, 'guas de So Pedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4656, 25, 'Agudos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4657, 25, 'Alambari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4658, 25, 'Alfredo Marcondes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4659, 25, 'Altair');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4660, 25, 'Altinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4661, 25, 'Alto Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4662, 25, 'Alumnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4663, 25, 'lvares Florence');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4664, 25, 'lvares Machado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4665, 25, 'lvaro de Carvalho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4666, 25, 'Alvinlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4667, 25, 'Americana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4668, 25, 'Amrico Brasiliense');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4669, 25, 'Amrico de Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4670, 25, 'Amparo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4671, 25, 'Analndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4672, 25, 'Andradina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4673, 25, 'Angatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4674, 25, 'Anhembi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4675, 25, 'Anhumas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4676, 25, 'Aparecida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4677, 25, 'Aparecida d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4678, 25, 'Apia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4679, 25, 'Araariguama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4680, 25, 'Araatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4681, 25, 'Araoiaba da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4682, 25, 'Aramina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4683, 25, 'Arandu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4684, 25, 'Arape');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4685, 25, 'Araraquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4686, 25, 'Araras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4687, 25, 'Arco-ris');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4688, 25, 'Arealva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4689, 25, 'Areias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4690, 25, 'Areipolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4691, 25, 'Ariranha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4692, 25, 'Artur Nogueira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4693, 25, 'Aruj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4694, 25, 'Aspsia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4695, 25, 'Assis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4696, 25, 'Atibaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4697, 25, 'Auriflama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4698, 25, 'Ava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4699, 25, 'Avanhandava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4700, 25, 'Avar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4701, 25, 'Bady Bassitt');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4702, 25, 'Balbinos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4703, 25, 'Blsamo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4704, 25, 'Bananal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4705, 25, 'Baro de Antonina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4706, 25, 'Barbosa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4707, 25, 'Bariri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4708, 25, 'Barra Bonita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4709, 25, 'Barra do Chapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4710, 25, 'Barra do Turvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4711, 25, 'Barretos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4712, 25, 'Barrinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4713, 25, 'Barueri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4714, 25, 'Bastos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4715, 25, 'Batatais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4716, 25, 'Bauru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4717, 25, 'Bebedouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4718, 25, 'Bento de Abreu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4719, 25, 'Bernardino de Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4720, 25, 'Bertioga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4721, 25, 'Bilac');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4722, 25, 'Birigui');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4723, 25, 'Biritiba-Mirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4724, 25, 'Boa Esperana do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4725, 25, 'Bocaina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4726, 25, 'Bofete');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4727, 25, 'Boituva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4728, 25, 'Bom Jesus dos Perdes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4729, 25, 'Bom Sucesso de Itarar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4730, 25, 'Bor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4731, 25, 'Boracia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4732, 25, 'Borborema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4733, 25, 'Borebi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4734, 25, 'Botucatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4735, 25, 'Bragana Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4736, 25, 'Brana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4737, 25, 'Brejo Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4738, 25, 'Brodowski');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4739, 25, 'Brotas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4740, 25, 'Buri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4741, 25, 'Buritama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4742, 25, 'Buritizal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4743, 25, 'Cabrlia Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4744, 25, 'Cabreva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4745, 25, 'Caapava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4746, 25, 'Cachoeira Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4747, 25, 'Caconde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4748, 25, 'Cafelndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4749, 25, 'Caiabu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4750, 25, 'Caieiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4751, 25, 'Caiu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4752, 25, 'Cajamar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4753, 25, 'Cajati');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4754, 25, 'Cajobi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4755, 25, 'Cajuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4756, 25, 'Campina do Monte Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4757, 25, 'Campinas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4758, 25, 'Campo Limpo Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4759, 25, 'Campos do Jordo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4760, 25, 'Campos Novos Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4761, 25, 'Canania');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4762, 25, 'Canas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4763, 25, 'Cndido Mota');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4764, 25, 'Cndido Rodrigues');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4765, 25, 'Canitar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4766, 25, 'Capo Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4767, 25, 'Capela do Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4768, 25, 'Capivari');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4769, 25, 'Caraguatatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4770, 25, 'Carapicuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4771, 25, 'Cardoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4772, 25, 'Casa Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4773, 25, 'Cssia dos Coqueiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4774, 25, 'Castilho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4775, 25, 'Catanduva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4776, 25, 'Catigu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4777, 25, 'Cedral');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4778, 25, 'Cerqueira Csar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4779, 25, 'Cerquilho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4780, 25, 'Cesrio Lange');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4781, 25, 'Charqueada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4782, 25, 'Chavantes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4783, 25, 'Clementina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4784, 25, 'Colina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4785, 25, 'Colmbia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4786, 25, 'Conchal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4787, 25, 'Conchas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4788, 25, 'Cordeirpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4789, 25, 'Coroados');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4790, 25, 'Coronel Macedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4791, 25, 'Corumbata');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4792, 25, 'Cosmpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4793, 25, 'Cosmorama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4794, 25, 'Cotia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4795, 25, 'Cravinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4796, 25, 'Cristais Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4797, 25, 'Cruzlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4798, 25, 'Cruzeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4799, 25, 'Cubato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4800, 25, 'Cunha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4801, 25, 'Descalvado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4802, 25, 'Diadema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4803, 25, 'Dirce Reis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4804, 25, 'Divinolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4805, 25, 'Dobrada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4806, 25, 'Dois Crregos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4807, 25, 'Dolcinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4808, 25, 'Dourado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4809, 25, 'Dracena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4810, 25, 'Duartina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4811, 25, 'Dumont');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4812, 25, 'Echapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4813, 25, 'Eldorado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4814, 25, 'Elias Fausto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4815, 25, 'Elisirio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4816, 25, 'Embaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4817, 25, 'Embu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4818, 25, 'Embu-Guau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4819, 25, 'Emilianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4820, 25, 'Engenheiro Coelho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4821, 25, 'Esprito Santo do Pinhal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4822, 25, 'Esprito Santo do Turvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4823, 25, 'Estiva Gerbi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4824, 25, 'Estrela d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4825, 25, 'Estrela do Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4826, 25, 'Euclides da Cunha Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4827, 25, 'Fartura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4828, 25, 'Fernando Prestes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4829, 25, 'Fernandpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4830, 25, 'Ferno');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4831, 25, 'Ferraz de Vasconcelos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4832, 25, 'Flora Rica');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4833, 25, 'Floreal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4834, 25, 'Flornia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4835, 25, 'Flrida Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4836, 25, 'Franca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4837, 25, 'Francisco Morato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4838, 25, 'Franco da Rocha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4839, 25, 'Gabriel Monteiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4840, 25, 'Glia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4841, 25, 'Gara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4842, 25, 'Gasto Vidigal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4843, 25, 'Gavio Peixoto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4844, 25, 'General Salgado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4845, 25, 'Getulina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4846, 25, 'Glicrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4847, 25, 'Guaiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4848, 25, 'Guaimb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4849, 25, 'Guara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4850, 25, 'Guapiau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4851, 25, 'Guapiara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4852, 25, 'Guar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4853, 25, 'Guaraa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4854, 25, 'Guaraci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4855, 25, 'Guarani d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4856, 25, 'Guarant');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4857, 25, 'Guararapes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4858, 25, 'Guararema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4859, 25, 'Guaratinguet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4860, 25, 'Guare');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4861, 25, 'Guariba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4862, 25, 'Guaruj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4863, 25, 'Guarulhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4864, 25, 'Guatapar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4865, 25, 'Guzolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4866, 25, 'Herculndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4867, 25, 'Holambra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4868, 25, 'Hortolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4869, 25, 'Iacanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4870, 25, 'Iacri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4871, 25, 'Iaras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4872, 25, 'Ibat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4873, 25, 'Ibir');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4874, 25, 'Ibirarema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4875, 25, 'Ibitinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4876, 25, 'Ibina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4877, 25, 'Icm');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4878, 25, 'Iep');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4879, 25, 'Igarau do Tiet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4880, 25, 'Igarapava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4881, 25, 'Igarat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4882, 25, 'Iguape');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4883, 25, 'Ilha Comprida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4884, 25, 'Ilha Solteira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4885, 25, 'Ilhabela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4886, 25, 'Indaiatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4887, 25, 'Indiana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4888, 25, 'Indiapor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4889, 25, 'Inbia Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4890, 25, 'Ipauu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4891, 25, 'Iper');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4892, 25, 'Ipena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4893, 25, 'Ipigu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4894, 25, 'Iporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4895, 25, 'Ipu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4896, 25, 'Iracempolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4897, 25, 'Irapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4898, 25, 'Irapuru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4899, 25, 'Itaber');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4900, 25, 'Ita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4901, 25, 'Itajobi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4902, 25, 'Itaju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4903, 25, 'Itanham');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4904, 25, 'Itaca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4905, 25, 'Itapecerica da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4906, 25, 'Itapetininga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4907, 25, 'Itapeva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4908, 25, 'Itapevi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4909, 25, 'Itapira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4910, 25, 'Itapirapu Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4911, 25, 'Itpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4912, 25, 'Itaporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4913, 25, 'Itapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4914, 25, 'Itapura');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4915, 25, 'Itaquaquecetuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4916, 25, 'Itarar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4917, 25, 'Itariri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4918, 25, 'Itatiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4919, 25, 'Itatinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4920, 25, 'Itirapina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4921, 25, 'Itirapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4922, 25, 'Itobi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4923, 25, 'Itu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4924, 25, 'Itupeva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4925, 25, 'Ituverava');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4926, 25, 'Jaborandi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4927, 25, 'Jaboticabal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4928, 25, 'Jacare');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4929, 25, 'Jaci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4930, 25, 'Jacupiranga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4931, 25, 'Jaguarina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4932, 25, 'Jales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4933, 25, 'Jambeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4934, 25, 'Jandira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4935, 25, 'Jardinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4936, 25, 'Jarinu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4937, 25, 'Ja');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4938, 25, 'Jeriquara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4939, 25, 'Joanpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4940, 25, 'Joo Ramalho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4941, 25, 'Jos Bonifcio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4942, 25, 'Jlio Mesquita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4943, 25, 'Jumirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4944, 25, 'Jundia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4945, 25, 'Junqueirpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4946, 25, 'Juqui');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4947, 25, 'Juquitiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4948, 25, 'Lagoinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4949, 25, 'Laranjal Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4950, 25, 'Lavnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4951, 25, 'Lavrinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4952, 25, 'Leme');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4953, 25, 'Lenis Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4954, 25, 'Limeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4955, 25, 'Lindia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4956, 25, 'Lins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4957, 25, 'Lorena');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4958, 25, 'Lourdes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4959, 25, 'Louveira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4960, 25, 'Luclia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4961, 25, 'Lucianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4962, 25, 'Lus Antnio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4963, 25, 'Luizinia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4964, 25, 'Luprcio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4965, 25, 'Lutcia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4966, 25, 'Macatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4967, 25, 'Macaubal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4968, 25, 'Macednia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4969, 25, 'Magda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4970, 25, 'Mairinque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4971, 25, 'Mairipor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4972, 25, 'Manduri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4973, 25, 'Marab Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4974, 25, 'Maraca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4975, 25, 'Marapoama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4976, 25, 'Maripolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4977, 25, 'Marlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4978, 25, 'Marinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4979, 25, 'Martinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4980, 25, 'Mato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4981, 25, 'Mau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4982, 25, 'Mendona');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4983, 25, 'Meridiano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4984, 25, 'Mespolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4985, 25, 'Miguelpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4986, 25, 'Mineiros do Tiet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4987, 25, 'Mira Estrela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4988, 25, 'Miracatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4989, 25, 'Mirandpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4990, 25, 'Mirante do Paranapanema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4991, 25, 'Mirassol');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4992, 25, 'Mirassolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4993, 25, 'Mococa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4994, 25, 'Mogi das Cruzes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4995, 25, 'Mogi Guau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4996, 25, 'Mogi-Mirim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4997, 25, 'Mombuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4998, 25, 'Mones');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (4999, 25, 'Mongagu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5000, 25, 'Monte Alegre do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5001, 25, 'Monte Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5002, 25, 'Monte Aprazvel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5003, 25, 'Monte Azul Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5004, 25, 'Monte Castelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5005, 25, 'Monte Mor');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5006, 25, 'Monteiro Lobato');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5007, 25, 'Morro Agudo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5008, 25, 'Morungaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5009, 25, 'Motuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5010, 25, 'Murutinga do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5011, 25, 'Nantes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5012, 25, 'Narandiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5013, 25, 'Natividade da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5014, 25, 'Nazar Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5015, 25, 'Neves Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5016, 25, 'Nhandeara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5017, 25, 'Nipo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5018, 25, 'Nova Aliana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5019, 25, 'Nova Campina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5020, 25, 'Nova Cana Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5021, 25, 'Nova Castilho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5022, 25, 'Nova Europa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5023, 25, 'Nova Granada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5024, 25, 'Nova Guataporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5025, 25, 'Nova Independncia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5026, 25, 'Nova Luzitnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5027, 25, 'Nova Odessa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5028, 25, 'Novais');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5029, 25, 'Novo Horizonte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5030, 25, 'Nuporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5031, 25, 'Ocauu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5032, 25, 'leo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5033, 25, 'Olmpia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5034, 25, 'Onda Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5035, 25, 'Oriente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5036, 25, 'Orindiva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5037, 25, 'Orlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5038, 25, 'Osasco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5039, 25, 'Oscar Bressane');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5040, 25, 'Osvaldo Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5041, 25, 'Ourinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5042, 25, 'Ouro Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5043, 25, 'Ouroeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5044, 25, 'Pacaembu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5045, 25, 'Palestina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5046, 25, 'Palmares Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5047, 25, 'Palmeira d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5048, 25, 'Palmital');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5049, 25, 'Panorama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5050, 25, 'Paraguau Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5051, 25, 'Paraibuna');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5052, 25, 'Paraso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5053, 25, 'Paranapanema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5054, 25, 'Paranapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5055, 25, 'Parapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5056, 25, 'Pardinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5057, 25, 'Pariquera-Au');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5058, 25, 'Parisi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5059, 25, 'Patrocnio Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5060, 25, 'Paulicia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5061, 25, 'Paulnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5062, 25, 'Paulistnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5063, 25, 'Paulo de Faria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5064, 25, 'Pederneiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5065, 25, 'Pedra Bela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5066, 25, 'Pedranpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5067, 25, 'Pedregulho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5068, 25, 'Pedreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5069, 25, 'Pedrinhas Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5070, 25, 'Pedro de Toledo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5071, 25, 'Penpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5072, 25, 'Pereira Barreto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5073, 25, 'Pereiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5074, 25, 'Perube');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5075, 25, 'Piacatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5076, 25, 'Piedade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5077, 25, 'Pilar do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5078, 25, 'Pindamonhangaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5079, 25, 'Pindorama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5080, 25, 'Pinhalzinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5081, 25, 'Piquerobi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5082, 25, 'Piquete');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5083, 25, 'Piracaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5084, 25, 'Piracicaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5085, 25, 'Piraju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5086, 25, 'Piraju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5087, 25, 'Pirangi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5088, 25, 'Pirapora do Bom Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5089, 25, 'Pirapozinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5090, 25, 'Pirassununga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5091, 25, 'Piratininga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5092, 25, 'Pitangueiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5093, 25, 'Planalto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5094, 25, 'Platina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5095, 25, 'Po');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5096, 25, 'Poloni');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5097, 25, 'Pompia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5098, 25, 'Ponga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5099, 25, 'Pontal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5100, 25, 'Pontalinda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5101, 25, 'Pontes Gestal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5102, 25, 'Populina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5103, 25, 'Porangaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5104, 25, 'Porto Feliz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5105, 25, 'Porto Ferreira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5106, 25, 'Potim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5107, 25, 'Potirendaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5108, 25, 'Pracinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5109, 25, 'Pradpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5110, 25, 'Praia Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5111, 25, 'Pratnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5112, 25, 'Presidente Alves');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5113, 25, 'Presidente Bernardes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5114, 25, 'Presidente Epitcio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5115, 25, 'Presidente Prudente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5116, 25, 'Presidente Venceslau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5117, 25, 'Promisso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5118, 25, 'Quadra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5119, 25, 'Quat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5120, 25, 'Queiroz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5121, 25, 'Queluz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5122, 25, 'Quintana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5123, 25, 'Rafard');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5124, 25, 'Rancharia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5125, 25, 'Redeno da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5126, 25, 'Regente Feij');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5127, 25, 'Reginpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5128, 25, 'Registro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5129, 25, 'Restinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5130, 25, 'Ribeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5131, 25, 'Ribeiro Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5132, 25, 'Ribeiro Branco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5133, 25, 'Ribeiro Corrente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5134, 25, 'Ribeiro do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5135, 25, 'Ribeiro dos ndios');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5136, 25, 'Ribeiro Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5137, 25, 'Ribeiro Pires');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5138, 25, 'Ribeiro Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5139, 25, 'Rifaina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5140, 25, 'Rinco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5141, 25, 'Rinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5142, 25, 'Rio Claro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5143, 25, 'Rio das Pedras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5144, 25, 'Rio Grande da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5145, 25, 'Riolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5146, 25, 'Riversul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5147, 25, 'Rosana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5148, 25, 'Roseira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5149, 25, 'Rubicea');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5150, 25, 'Rubinia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5151, 25, 'Sabino');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5152, 25, 'Sagres');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5153, 25, 'Sales');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5154, 25, 'Sales Oliveira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5155, 25, 'Salespolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5156, 25, 'Salmouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5157, 25, 'Saltinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5158, 25, 'Salto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5159, 25, 'Salto de Pirapora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5160, 25, 'Salto Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5161, 25, 'Sandovalina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5162, 25, 'Santa Adlia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5163, 25, 'Santa Albertina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5164, 25, 'Santa Brbara d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5165, 25, 'Santa Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5166, 25, 'Santa Clara d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5167, 25, 'Santa Cruz da Conceio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5168, 25, 'Santa Cruz da Esperana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5169, 25, 'Santa Cruz das Palmeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5170, 25, 'Santa Cruz do Rio Pardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5171, 25, 'Santa Ernestina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5172, 25, 'Santa F do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5173, 25, 'Santa Gertrudes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5174, 25, 'Santa Isabel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5175, 25, 'Santa Lcia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5176, 25, 'Santa Maria da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5177, 25, 'Santa Mercedes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5178, 25, 'Santa Rita d`Oeste');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5179, 25, 'Santa Rita do Passa Quatro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5180, 25, 'Santa Rosa de Viterbo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5181, 25, 'Santa Salete');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5182, 25, 'Santana da Ponte Pensa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5183, 25, 'Santana de Parnaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5184, 25, 'Santo Anastcio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5185, 25, 'Santo Andr');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5186, 25, 'Santo Antnio da Alegria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5187, 25, 'Santo Antnio de Posse');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5188, 25, 'Santo Antnio do Aracangu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5189, 25, 'Santo Antnio do Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5190, 25, 'Santo Antnio do Pinhal');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5191, 25, 'Santo Expedito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5192, 25, 'Santpolis do Aguape');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5193, 25, 'Santos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5194, 25, 'So Bento do Sapuca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5195, 25, 'So Bernardo do Campo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5196, 25, 'So Caetano do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5197, 25, 'So Carlos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5198, 25, 'So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5199, 25, 'So Joo da Boa Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5200, 25, 'So Joo das Duas Pontes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5201, 25, 'So Joo de Iracema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5202, 25, 'So Joo do Pau d`Alho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5203, 25, 'So Joaquim da Barra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5204, 25, 'So Jos da Bela Vista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5205, 25, 'So Jos do Barreiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5206, 25, 'So Jos do Rio Pardo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5207, 25, 'So Jos do Rio Preto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5208, 25, 'So Jos dos Campos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5209, 25, 'So Loureno da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5210, 25, 'So Lus do Paraitinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5211, 25, 'So Manuel');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5212, 25, 'So Miguel Arcanjo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5213, 25, 'So Paulo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5214, 25, 'So Pedro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5215, 25, 'So Pedro do Turvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5216, 25, 'So Roque');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5217, 25, 'So Sebastio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5218, 25, 'So Sebastio da Grama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5219, 25, 'So Simo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5220, 25, 'So Vicente');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5221, 25, 'Sarapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5222, 25, 'Sarutai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5223, 25, 'Sebastianpolis do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5224, 25, 'Serra Azul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5225, 25, 'Serra Negra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5226, 25, 'Serrana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5227, 25, 'Sertozinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5228, 25, 'Sete Barras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5229, 25, 'Severnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5230, 25, 'Silveiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5231, 25, 'Socorro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5232, 25, 'Sorocaba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5233, 25, 'Sud Mennucci');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5234, 25, 'Sumar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5235, 25, 'Suzanpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5236, 25, 'Suzano');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5237, 25, 'Tabapu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5238, 25, 'Tabatinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5239, 25, 'Taboo da Serra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5240, 25, 'Taciba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5241, 25, 'Tagua');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5242, 25, 'Taiau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5243, 25, 'Taiva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5244, 25, 'Tamba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5245, 25, 'Tanabi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5246, 25, 'Tapira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5247, 25, 'Tapiratiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5248, 25, 'Taquaral');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5249, 25, 'Taquaritinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5250, 25, 'Taquarituba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5251, 25, 'Taquariva');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5252, 25, 'Tarabai');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5253, 25, 'Tarum');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5254, 25, 'Tatu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5255, 25, 'Taubat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5256, 25, 'Tejup');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5257, 25, 'Teodoro Sampaio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5258, 25, 'Terra Roxa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5259, 25, 'Tiet');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5260, 25, 'Timburi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5261, 25, 'Torre de Pedra');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5262, 25, 'Torrinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5263, 25, 'Trabiju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5264, 25, 'Trememb');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5265, 25, 'Trs Fronteiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5266, 25, 'Tuiuti');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5267, 25, 'Tup');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5268, 25, 'Tupi Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5269, 25, 'Turiba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5270, 25, 'Turmalina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5271, 25, 'Ubarana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5272, 25, 'Ubatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5273, 25, 'Ubirajara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5274, 25, 'Uchoa');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5275, 25, 'Unio Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5276, 25, 'Urnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5277, 25, 'Uru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5278, 25, 'Urups');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5279, 25, 'Valentim Gentil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5280, 25, 'Valinhos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5281, 25, 'Valparaso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5282, 25, 'Vargem');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5283, 25, 'Vargem Grande do Sul');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5284, 25, 'Vargem Grande Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5285, 25, 'Vrzea Paulista');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5286, 25, 'Vera Cruz');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5287, 25, 'Vinhedo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5288, 25, 'Viradouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5289, 25, 'Vista Alegre do Alto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5290, 25, 'Vitria Brasil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5291, 25, 'Votorantim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5292, 25, 'Votuporanga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5293, 25, 'Zacarias');


/* ***************************** S e r g i p e ****************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5294, 26, 'Amparo de So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5295, 26, 'Aquidab');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5296, 26, 'Aracaju');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5297, 26, 'Arau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5298, 26, 'Areia Branca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5299, 26, 'Barra dos Coqueiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5300, 26, 'Boquim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5301, 26, 'Brejo Grande');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5302, 26, 'Campo do Brito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5303, 26, 'Canhoba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5304, 26, 'Canind de So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5305, 26, 'Capela');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5306, 26, 'Carira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5307, 26, 'Carmpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5308, 26, 'Cedro de So Joo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5309, 26, 'Cristinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5310, 26, 'Cumbe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5311, 26, 'Divina Pastora');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5312, 26, 'Estncia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5313, 26, 'Feira Nova');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5314, 26, 'Frei Paulo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5315, 26, 'Gararu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5316, 26, 'General Maynard');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5317, 26, 'Gracho Cardoso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5318, 26, 'Ilha das Flores');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5319, 26, 'Indiaroba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5320, 26, 'Itabaiana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5321, 26, 'Itabaianinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5322, 26, 'Itabi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5323, 26, 'Itaporanga d`Ajuda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5324, 26, 'Japaratuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5325, 26, 'Japoat');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5326, 26, 'Lagarto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5327, 26, 'Laranjeiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5328, 26, 'Macambira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5329, 26, 'Malhada dos Bois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5330, 26, 'Malhador');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5331, 26, 'Maruim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5332, 26, 'Moita Bonita');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5333, 26, 'Monte Alegre de Sergipe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5334, 26, 'Muribeca');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5335, 26, 'Nepolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5336, 26, 'Nossa Senhora Aparecida');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5337, 26, 'Nossa Senhora da Glria');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5338, 26, 'Nossa Senhora das Dores');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5339, 26, 'Nossa Senhora de Lourdes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5340, 26, 'Nossa Senhora do Socorro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5341, 26, 'Pacatuba');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5342, 26, 'Pedra Mole');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5343, 26, 'Pedrinhas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5344, 26, 'Pinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5345, 26, 'Pirambu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5346, 26, 'Poo Redondo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5347, 26, 'Poo Verde');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5348, 26, 'Porto da Folha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5349, 26, 'Propri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5350, 26, 'Riacho do Dantas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5351, 26, 'Riachuelo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5352, 26, 'Ribeirpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5353, 26, 'Rosrio do Catete');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5354, 26, 'Salgado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5355, 26, 'Santa Luzia do Itanhy');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5356, 26, 'Santa Rosa de Lima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5357, 26, 'Santana do So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5358, 26, 'Santo Amaro das Brotas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5359, 26, 'So Cristvo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5360, 26, 'So Domingos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5361, 26, 'So Francisco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5362, 26, 'So Miguel do Aleixo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5363, 26, 'Simo Dias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5364, 26, 'Siriri');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5365, 26, 'Telha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5366, 26, 'Tobias Barreto');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5367, 26, 'Tomar do Geru');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5368, 26, 'Umbaba');


/* *************************** T o c a n t i n s **************************** */

INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5369, 27, 'Abreulndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5370, 27, 'Aguiarnpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5371, 27, 'Aliana do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5372, 27, 'Almas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5373, 27, 'Alvorada');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5374, 27, 'Anans');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5375, 27, 'Angico');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5376, 27, 'Aparecida do Rio Negro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5377, 27, 'Aragominas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5378, 27, 'Araguacema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5379, 27, 'Araguau');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5380, 27, 'Araguana');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5381, 27, 'Araguan');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5382, 27, 'Araguatins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5383, 27, 'Arapoema');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5384, 27, 'Arraias');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5385, 27, 'Augustinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5386, 27, 'Aurora do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5387, 27, 'Axix do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5388, 27, 'Babaulndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5389, 27, 'Bandeirantes do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5390, 27, 'Barra do Ouro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5391, 27, 'Barrolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5392, 27, 'Bernardo Sayo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5393, 27, 'Bom Jesus do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5394, 27, 'Brasilndia do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5395, 27, 'Brejinho de Nazar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5396, 27, 'Buriti do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5397, 27, 'Cachoeirinha');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5398, 27, 'Campos Lindos');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5399, 27, 'Cariri do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5400, 27, 'Carmolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5401, 27, 'Carrasco Bonito');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5402, 27, 'Caseara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5403, 27, 'Centenrio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5404, 27, 'Chapada da Natividade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5405, 27, 'Chapada de Areia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5406, 27, 'Colinas do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5407, 27, 'Colmia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5408, 27, 'Combinado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5409, 27, 'Conceio do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5410, 27, 'Couto de Magalhes');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5411, 27, 'Cristalndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5412, 27, 'Crixs do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5413, 27, 'Darcinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5414, 27, 'Dianpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5415, 27, 'Divinpolis do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5416, 27, 'Dois Irmos do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5417, 27, 'Duer');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5418, 27, 'Esperantina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5419, 27, 'Ftima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5420, 27, 'Figueirpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5421, 27, 'Filadlfia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5422, 27, 'Formoso do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5423, 27, 'Fortaleza do Taboco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5424, 27, 'Goianorte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5425, 27, 'Goiatins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5426, 27, 'Guara');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5427, 27, 'Gurupi');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5428, 27, 'Ipueiras');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5429, 27, 'Itacaj');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5430, 27, 'Itaguatins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5431, 27, 'Itapiratins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5432, 27, 'Itapor do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5433, 27, 'Ja do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5434, 27, 'Juarina');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5435, 27, 'Lagoa da Confuso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5436, 27, 'Lagoa do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5437, 27, 'Lajeado');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5438, 27, 'Lavandeira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5439, 27, 'Lizarda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5440, 27, 'Luzinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5441, 27, 'Marianpolis do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5442, 27, 'Mateiros');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5443, 27, 'Maurilndia do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5444, 27, 'Miracema do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5445, 27, 'Miranorte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5446, 27, 'Monte do Carmo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5447, 27, 'Monte Santo do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5448, 27, 'Muricilndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5449, 27, 'Natividade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5450, 27, 'Nazar');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5451, 27, 'Nova Olinda');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5452, 27, 'Nova Rosalndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5453, 27, 'Novo Acordo');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5454, 27, 'Novo Alegre');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5455, 27, 'Novo Jardim');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5456, 27, 'Oliveira de Ftima');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5457, 27, 'Palmas');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5458, 27, 'Palmeirante');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5459, 27, 'Palmeiras do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5460, 27, 'Palmeirpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5461, 27, 'Paraso do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5462, 27, 'Paran');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5463, 27, 'Pau d`Arco');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5464, 27, 'Pedro Afonso');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5465, 27, 'Peixe');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5466, 27, 'Pequizeiro');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5467, 27, 'Pindorama do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5468, 27, 'Piraqu');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5469, 27, 'Pium');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5470, 27, 'Ponte Alta do Bom Jesus');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5471, 27, 'Ponte Alta do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5472, 27, 'Porto Alegre do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5473, 27, 'Porto Nacional');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5474, 27, 'Praia Norte');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5475, 27, 'Presidente Kennedy');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5476, 27, 'Pugmil');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5477, 27, 'Recursolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5478, 27, 'Riachinho');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5479, 27, 'Rio da Conceio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5480, 27, 'Rio dos Bois');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5481, 27, 'Rio Sono');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5482, 27, 'Sampaio');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5483, 27, 'Sandolndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5484, 27, 'Santa F do Araguaia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5485, 27, 'Santa Maria do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5486, 27, 'Santa Rita do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5487, 27, 'Santa Rosa do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5488, 27, 'Santa Tereza do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5489, 27, 'Santa Terezinha do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5490, 27, 'So Bento do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5491, 27, 'So Flix do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5492, 27, 'So Miguel do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5493, 27, 'So Salvador do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5494, 27, 'So Sebastio do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5495, 27, 'So Valrio da Natividade');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5496, 27, 'Silvanpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5497, 27, 'Stio Novo do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5498, 27, 'Sucupira');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5499, 27, 'Taguatinga');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5500, 27, 'Taipas do Tocantins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5501, 27, 'Talism');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5502, 27, 'Tocantnia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5503, 27, 'Tocantinpolis');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5504, 27, 'Tupirama');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5505, 27, 'Tupiratins');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5506, 27, 'Wanderlndia');
INSERT INTO `city` (`city_id`, `state_id`, `city_name`) VALUES (5507, 27, 'Xambio');

COMMIT WORK;

